-- Scripts&Functions by PDO --

--	Simple functions

function HideDialogue()
	ScriptManager:dismissSubtitle()
end

function HideAllMarkers()
	ScriptManager:removeAllMarkers()
end

function EnableEndTurnButton()
	ScriptManager:enableEndTurnButton()
end

function DisableEndTurnButton()
	ScriptManager:disableEndTurnButton()
end

function EndGameFunction()
	ScriptManager:endGame()
end

function addOnEnterAreaTrigger2(x,y,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
	for i = x-1, x+1 do
		ScriptManager:addOnEnterTileTrigger(i,y,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
	end
	local xx = y % 2 -1
	ScriptManager:addOnEnterTileTrigger(x+xx,y+1,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
	ScriptManager:addOnEnterTileTrigger(x+xx+1,y+1,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
	ScriptManager:addOnEnterTileTrigger(x+xx,y-1,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
	ScriptManager:addOnEnterTileTrigger(x+xx+1,y-1,playerId,unitTemplateId,unitInstanceId,stopUnit,callbackName,triggerId,execInReplay)
end

--Script to check for game end

--Add Trigger to GameStart:
--	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"checkForEnd","checkForEnd")

--Add Function To script:
--function CheckForGameEnd()
--	MainGoalAccomplished(2,onMissionAccomplished,MissionFailed)		--Main Mission ID, Starts function if Accomplished, Starts function if Failed -- Function name without ()
--end

function MainGoalAccomplished(iD,accomplishedScript,failedScript)
	print(string.format("CheckFormissionEnd"))
	if ScriptManager:getMissionStatus(iD) == MissionStatus.ACCOMPLISHED then
		DisableEndTurnButton()
		print(string.format("MissionAccomplished"))
		accomplishedScript()
	elseif ScriptManager:getMissionStatus(iD) == MissionStatus.FAILED then
		print(string.format("MissionFailed"))
		DisableEndTurnButton()
		failedScript()
	end
end

function ShowMissionProgressPopup( missionProgress, textKey )
	ScriptManager:preparePopupText();
	ScriptManager:addPopupTextParameter( "x",missionProgress );
	ScriptManager:displaySubtitleAutoEx( textKey, false );
end

function MarkUnit( posX, posY, revealRadius, markDuration )
	ScriptManager:revealFogOfWar(	posX, posY, revealRadius, true );
	ScriptManager:showMarkerAt(		posX, posY );
	ScriptManager:wait( markDuration );
	ScriptManager:hideMarkerAt(		posX, posY );
	ScriptManager:revealFogOfWar(	posX, posY, revealRadius, false );
end

-- logic for the mine shafts used in DE6
function OnShaftEntered( tileY, unitId, shaftTable )
	-- only check the y value, cause they will never be the same
	-- direction indicates which way the unit moves
	local endX, endY, index, direction;
	if tileY == shaftTable[1][2] then
		index = 2;
		direction = 1;
		
	else
		index = 1;
		direction = -1;
	end
	
	-- get the other end of the shaft
	endX = shaftTable[index][1];
	endY = shaftTable[index][2];
	
	MoveThroughShaft( Unit:getUnitById( unitId ), endX, endY, direction );
end

function MoveThroughShaft( unit, endX, endY, direction )	
	local ap			= unit:getActionPoints();
	local ammo			= unit:getAmmo();
	local hp			= unit:getHealth();
	local templateId	= unit:getTemplateId();
		
	-- depending on the y value, x may have to be in-/decreased by 1
	local xModifier = endY % 2;
	
	-- if the player moves from the "exit" back to the "entrance" the xModifier has to be decreased
	if direction == -1 then
		xModifier = xModifier - 1;
	end
	
	-- the unit spawns directily on the mine shaft, so i move the unit manually one tile
	--local moveX = endX + xModifier;
	--local moveY = endY + direction
	
	-- but before i move, i check if the tile is free
	--local moveBlockingUnit	= Unit:getUnitAt( moveX, moveY );
	local endBlockingUnit	= Unit:getUnitAt( endX, endY );
	
	--if moveBlockingUnit == nil and endBlockingUnit == nil then
	if endBlockingUnit == nil then
		-- show the unit moving through the mine in a cutscene
		StartCutscene();
		
		--ScriptManager:moveCameraEx( moveX, moveY, 0.7, 1, false );
		ScriptManager:moveCameraEx( endX, endY, 0.7, 1, false );
		ScriptManager:removeUnitEx( unit:getId(), true );
		ScriptManager:wait( 0.5 );
		
		local newUnit = ScriptManager:spawnUnit( 0, templateId, endX, endY, 0, 0 );
		
		--ScriptManager:wait( 0.5 );
		--ScriptManager:moveUnitEx( newUnit:getId(), moveX, moveY, true );
		
		newUnit:setActionPoints( ap );
		newUnit:setAmmo( ammo );
		newUnit:setHealth( hp );
		
		EndCutscene();
	
	else
		-- the other side is blocked by at least one unit atm, so player gets notified to move his unit/s out of the way
		ScriptManager:displaySubtitle( Text.T_SUBTITLE_REINFORCMENT, false );
		
		ScriptManager:moveCameraEx( endX, endY, 0.7, 1, true );
		ScriptManager:showMarkerAt( endX, endY );
		
		--[[ScriptManager:moveCameraEx( moveX, moveY, 0.7, 1, true );
		
		if moveBlockingUnit ~= nil then
			ScriptManager:showMarkerAt( moveX, moveY );
		end
		
		if endBlockingUnit ~= nil then
			ScriptManager:showMarkerAt( endX, endY );
		end]]
		
		ScriptManager:sleep( 2, "HideAllMarkers" );
		ScriptManager:sleep( 2, "HideDialogue" );
	end
end


--Don't attack supply depot function
--Warns the player about beeing attacked
--Moves cam to the players supply depot if its still alive and marks it + shows dialogue

function ProtectTheSupplyDepotHint(attacker, defender)
	supplyDepot = Unit:getUnitById(defender:getId())
	if supplyDepot ~= nil then
		ScriptManager:runForPlayer(0,"DontLoseDepotCamMove")
	end
end

function ProtectTheSupplyDepotHintSingle(attacker, defender)
	supplyDepot = Unit:getUnitById(defender:getId())
	if supplyDepot ~= nil then
		ScriptManager:runForPlayer(0,"DontLoseDepotCamMoveSingle")
	end
end

function ProtectTheBuildingHintSingle(attacker, defender)
	supplyDepot = Unit:getUnitById(defender:getId())
	if supplyDepot ~= nil then
		ScriptManager:runForPlayer(0,"DontLoseBuildingCamMoveSingle")
	end
end

function ProtectTheSupplyDepotHintSingleNoDeath( attacker, defender )
	supplyDepot = Unit:getUnitById(defender:getId())
	if supplyDepot ~= nil then
		ScriptManager:runForPlayer(0,"DontLoseDepotCamMoveSingleNoDeath")
	end
end

function DontLoseDepotCamMove()
	if supplyDepot ~= nil then
		ScriptManager:disableEndTurnButton()
		ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_2_2_WARNING,"")
		ScriptManager:moveCamera(supplyDepot:getX(),supplyDepot:getY(),1.0,1.5,"")
		ScriptManager:showMarkerAt(supplyDepot:getX(),supplyDepot:getY())
		ScriptManager:sleep(2,"HideAllMarkers")
		ScriptManager:sleep(3,"EnableEndTurnButton")
	end
end
function DontLoseDepotCamMoveSingle()
	if supplyDepot ~= nil then
		ScriptManager:disableEndTurnButton()
		ScriptManager:displaySubtitleAutoWithCallback(Text.T_MAP_3_2_WARNING,"")
		ScriptManager:moveCamera(supplyDepot:getX(),supplyDepot:getY(),1.0,1.5,"")
		ScriptManager:showMarkerAt(supplyDepot:getX(),supplyDepot:getY())
		ScriptManager:sleep(2,"HideAllMarkers")
		ScriptManager:sleep(3,"EnableEndTurnButton")
	end
end
function DontLoseBuildingCamMoveSingle()
	if supplyDepot ~= nil then
		ScriptManager:disableEndTurnButton()
		ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_SUBTITLE_BUILDING_ATTACKED_WARNING,"")
		ScriptManager:moveCamera(supplyDepot:getX(),supplyDepot:getY(),1.0,1.5,"")
		ScriptManager:showMarkerAt(supplyDepot:getX(),supplyDepot:getY())
		ScriptManager:sleep(2,"HideAllMarkers")
		ScriptManager:sleep(3,"EnableEndTurnButton")
	end
end
function DontLoseDepotCamMoveSingleNoDeath()
	if supplyDepot ~= nil then
		ScriptManager:disableEndTurnButton()
		ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_DEPOT_WARNING,"")
		ScriptManager:moveCamera(supplyDepot:getX(),supplyDepot:getY(),1.0,1.5,"")
		ScriptManager:showMarkerAt(supplyDepot:getX(),supplyDepot:getY())
		ScriptManager:sleep(2,"HideAllMarkers")
		ScriptManager:sleep(3,"EnableEndTurnButton")
	end
end

-- Cutscenes
function StartCutscene()
	ScriptManager:startCutscene();
	HideDialogue();
	ScriptManager:wait( 1.5 );
end

function EndCutscene()
	ScriptManager:wait( 1 );
	ScriptManager:stopCutscene();
end

-- controllers
controllerButtonPressedCount = 0;
controllerButtonPressesNeeded = 0;

-- shows a graphic with highlighted face button that disappears after a certain number of button presses
function showControllerButtonGfx( buttonConstant, buttonPressesNeeded, tileX, tileY )
	ScriptManager:showControllerButtonAtTile( buttonConstant, tileX, tileY, 0.2 );
	
	controllerButtonPressesNeeded = buttonPressesNeeded;
	
	ScriptManager:addOnControllerButtonReleasedTrigger( buttonConstant, "removeControllerButtonGfx", "removeControllerButtonGfx" );
end

function removeControllerButtonGfx()
	controllerButtonPressedCount = controllerButtonPressedCount + 1;
	print( string.format( "button %i x pressed; %i presses needed", controllerButtonPressedCount, controllerButtonPressesNeeded ) );
	
	if controllerButtonPressedCount >= controllerButtonPressesNeeded then
		ScriptManager:hideControllerButton();	
		ScriptManager:removeTrigger( "removeControllerButtonGfx" );
		controllerButtonPressesNeeded	= 0;
		controllerButtonPressedCount	= 0;
	end
end

function showCursorAfterTwo()
	if controllerButtonPressedCount == 2 then
		ScriptManager:sleep( 0.2, "showTheCursorAgain" );
		RemoveTrigger( "showCursorAfterTwo" );
	end
end

function showTheCursorAgain()
	ScriptManager:setControllerCursorPosition( 5, 6 );
end

function cursorOver()
	ScriptManager:removeAllMarkers();
	ScriptManager:setControllerCursorEnabled( false );
	ScriptManager:removeTrigger( "cursorOverUnit" );
end

function cursorOverUnitSinglePress( tileX, tileY )
	cursorOver();
	showControllerButtonGfx( ControllerButton.FACE_DOWN, 1, tileX, tileY, 0.2 );
end

function cursorOverUnit( tileX, tileY )
	cursorOver();
	showControllerButtonGfx( ControllerButton.FACE_DOWN, 2, tileX, tileY, 0.2 );
end

function cursorOverUnitQuadraPress( tileX, tileY )
	cursorOver();
	showControllerButtonGfx( ControllerButton.FACE_DOWN, 4, tileX, tileY, 0.2 );
	ScriptManager:addOnControllerButtonReleasedTrigger( ControllerButton.FACE_DOWN, "showCursorAfterTwo", "showCursorAfterTwo" );
end

function cleanupController()
	ScriptManager:removeTrigger( "cursorOverUnit" );
	ScriptManager:hideControllerButton();
end

function checkControllerAndHideButton()
	if ScriptManager:isControllerConnected() then
		ScriptManager:hideControllerButton();
	end
end

function onControllerConnect()
	ScriptManager:setControllerCursorEnabled( true );
	ScriptManager:hideFinger();
end

function onControllerDisconnect()
	ScriptManager:hideControllerButton();
end