require "lua/Constants"
require "lua/Text"
require "lua/Units"
require "math"

cutsceneActive = 0


-- Scripts&Functions by PDO --
function InitiateFunctions_2()
	ScriptManager:addOnUnitSelectedTrigger(0,-1,-1,"unitLastSelected","unitLastSelected",false)
	ScriptManager:addOnUnitSelectedTrigger(-1,-1,-1,"PrintUnitInfo","PrintUnitInfo",false)
--	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_SU_HQ,-1,"DepotIsUnderAttack","DepotIsUnderAttack",false)
--	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_DE_HQ,-1,"DepotIsUnderAttack","DepotIsUnderAttack",false)
	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_SU_HQ,-1,"UnitIsUnderAttack","UnitIsUnderAttack",false)
	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_DE_HQ,-1,"UnitIsUnderAttack","UnitIsUnderAttack",false)
	
	--DebugTrigger
	ScriptManager:addOnUnitInstantSuppliedTrigger(-1,Units.GOTT,-1,"TransformGod","TransformGod",false)
	ScriptManager:addOnUnitInstantSuppliedTrigger(-1,47,-1,"TransformGodHQ","TransformGodHQ",false)
	ScriptManager:addOnUnitSelectedTrigger(-1,Units.GOTT,-1,"SpawnGoTTUnit","SpawnGoTTUnit",false)
	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"CheckForUnitsleft","CheckForUnitsleft",false)
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"CheckForUnitsleft","CheckForUnitsleft",false)
end

function CheckForUnitsleft()
	if ScriptManager:getCurrentRound() > 1 then
		if ScriptManager:noUnitsLeft(0) then
--			ScriptManager:removeTrigger("CheckForUnitsleft")
			ScriptManager:runForPlayer(0,"_EndGameCutscene")
		end
	end
end

function _EndGameCutscene()
	table.insert(cutsceneQueue,EndGameCutscene)
	CutsceneQueue()
end

endCutscene = 
{
	{"moveCam",10,10,0.8,10,false},
	{"wait",3},
	{"showDialogue",Text.T_MISSION_FAILED,true},
	{"wait",1},
}

function EndGameCutscene()
	ScriptManager:dismissSubtitle()
	ScriptManager:blockUI(true)
	CutsceneFunction(endCutscene)
	ScriptManager:wait(1)
	ScriptManager:endGame()
	ScriptManager:wait(1)
end

--God debug functions
function TransformGod(unit)
	ScriptManager:storeValue("godX",unit:getX())
	ScriptManager:storeValue("godY",unit:getY())
	ScriptManager:removeUnitEx(unit:getId(),true)
	ScriptManager:spawnUnit(0,47,ScriptManager:getValue("godX"),ScriptManager:getValue("godY"),0,0)
end

function TransformGodHQ(unit)
	ScriptManager:storeValue("godX",unit:getX())
	ScriptManager:storeValue("godY",unit:getY())
	ScriptManager:removeUnitEx(unit:getId(),true)
	ScriptManager:spawnUnit(0,Units.GOTT,ScriptManager:getValue("godX"),ScriptManager:getValue("godY"),0,0)		
end

function SpawnGoTTUnit(unit)
	ScriptManager:addOnUnitSelectedTrigger(-1,Units.GOTT,-1,"SpawnGoTTUnitConfirmed","SpawnGoTTUnitConfirmed",false)
	ScriptManager:wait(1)
	ScriptManager:removeTrigger("SpawnGoTTUnitConfirmed")
end

function SpawnGoTTUnitConfirmed(unit)
	ScriptManager:spawnUnit(0,Units.UNIT_DE_TIGER_EXTREME,unit:getX(),unit:getY(),0,0)
end

function HideDialogue()
	ScriptManager:dismissSubtitle()
end

function HideAllMarkers()
	ScriptManager:removeAllMarkers()
end

function EnableEndTurnButton()
	ScriptManager:enableEndTurnButton()
end

function DisableEndTurnButton()
	ScriptManager:disableEndTurnButton()
end

function BlockUi(boolean)
	if boolean == true then
		ScriptManager:blockUI(true)
	elseif boolean == false then
		ScriptManager:blockUI(false)
	end
end

function RemoveTrigger( triggerID )
	ScriptManager:removeTrigger( triggerID );
end

function DisablePlayerInteraction()
	ScriptManager:blockUI( true );
	ScriptManager:disableEndTurnButton();
end

function EnablePlayerInteraction()
	ScriptManager:enableEndTurnButton();
	ScriptManager:blockUI( false );
end

function PrintUnitInfo(unit)
	local unitId = unit:getId()
	local squadId = unit:getSquadId()
	local aiState = unit:getAiState()
	print(string.format("unitId:%i,squadId:%i aiState:%i",unitId,squadId,aiState))
end

-- needs a table with all its units 
function CamouflageSquad( squadTable )
	for i = 1, #squadTable do
		CamouflageUnit( squadTable[i] );
	end
end

function CamouflageUnit( unitId )
	ScriptManager:camouflageUnit( unitId );
end

--Store Unit ID of last selected unit
function unitLastSelected(unit)
	ScriptManager:storeValue("unitLastSelected",unit:getId())
end

--Set Game start properties 
function SetStartProperties(blockUi,xCam,yCam,startGold) 	--(BlockUi(Boolean),StartCameraPosition x&y, LocalStarting Gold)
	ScriptManager:moveCamera(xCam,yCam,0.75,0,"")			--Set Camera start position
	ScriptManager:gainGold(0,startGold)						--Set Player starting gold
	ScriptManager:blockUI(blockUi)							--blockUi at start true/false
end


--Create mission Script
function CreateMissions(missionContent)					--create table with {missionId,primary(boolean),textkey,xpReward}
	for i = 1, #missionContent do						--create all missions of table
		local data = missionContent[i]
		print(string.format("[Create Mission] %s ",data[3]))
		ScriptManager:createMission(data[1],data[2],data[3])	
		ScriptManager:setMissionXp(data[1],data[4])
	end
end

function SetMissionStatus( missionId, missionStatus )
	DisablePlayerInteraction();
	
	ScriptManager:setMissionStatus( missionId, missionStatus );
	ScriptManager:wait( 2 );
	
	EnablePlayerInteraction();
end

--cutscene to warn the player about a depot beeign attacked
depotIsAttacked =
{
	{"moveCam","attackedSupplyDepot",-1,0.9,2,true}, 								
	{"wait",1},		
	{"showMarker","attackedSupplyDepot",-1,3},				
	{"showDialogue",Text.T_MISSION_DEPOT_WARNING,true},	
	{"wait",1},								
	{"moveCam","unitLastSelected",-1,0.8,2,true}, 
}

--warns the player about depots beign attacked
function DepotIsUnderAttack(activeUnit, passiveUnit)
	ScriptManager:storeValue("attackedSupplyDepot",passiveUnit:getId())
	ScriptManager:runForPlayer(0,"DepotCutsceneFunction")
end

depotIsUnderAttack = 0

--Queues the cutscene to warn the player
function DepotCutsceneFunction()
	if depotIsUnderAttack == 0 then
		depotIsUnderAttack = 1
		table.insert(cutsceneQueue,_DepotCutsceneFunction)
		CutsceneQueue()
	end
end

function _DepotCutsceneFunction()
	ScriptManager:startCutscene()
	CutsceneFunction(depotIsAttacked)
	ScriptManager:stopCutscene()
	depotIsUnderAttack = 0
end

function OnUnitAttacked(attacker,defender,targetTemplateId,textString,remove) --attackerId, defenderId, unit template id, remove(boolean)
	globalTextString = textString
	targetId = -1
	if attacker:getTemplateId() == targetTemplateId then				
		targetId = attacker
	end
	if defender:getTemplateId() == targetTemplateId then
		targetId = defender
	end
	if remove == true then
		ScriptManager:removeTrigger("OnUnitAttacked")
	end
	ScriptManager:runForPlayer(0, "StartOnUnitAttackedCutscene")
end

function StartOnUnitAttackedCutscene()	--script for moveing the camera to the attacker/defending unit known from kill x missions
	local playerUnit = ScriptManager:getValue("unitLastSelected")
	local playerPosX = 1
	local playerPosY = 1
	if playerUnit ~= -1 then
		playerPosX = Unit:getUnitById(playerUnit):getX()
		playerPosY = Unit:getUnitById(playerUnit):getY()
	elseif playerUnit == -1 then
		playerPosX = targetId:getX()
		playerPosY = targetId:getY()
	end
	local enemyPosX = targetId:getX()
	local enemyPosY = targetId:getY()
	ScriptManager:blockUI(true)
	ScriptManager:enableSkipCutsceneButton()
	ScriptManager:moveCameraEx(enemyPosX,enemyPosY,0.9,2,true)
	ScriptManager:revealFogOfWar(enemyPosX,enemyPosY,1,true)
	ScriptManager:showMarkerAt(enemyPosX,enemyPosY)
	ScriptManager:sleep(2.5,"HideAllMarkers")
	ScriptManager:displaySubtitleAutoEx(globalTextString,true)
	ScriptManager:revealFogOfWar(enemyPosX,enemyPosY,1,false)
	ScriptManager:moveCameraEx(playerPosX,playerPosY,0.8,2,true)
	ScriptManager:blockUI(false)
	targetId = nil
	globalTextString = nil
end

--[[
--Function for Creating CutscgetUnitIdValueenes with a table 

{
	{"moveCam",x,y,zoom,time,wait}, 		--waitTillCamInPosition, wait til continue (handle),posX, posY, zoom, time
	{"wait",x},	{"wait",waitForCam}			--wait if input "number" x in seconds. input string "waitForCam" = waits for the camera movement to end, "waitForText" = waits the dialogue to end, "waitForUnit" = wait for unit moving to end, waitForAttack
	{"showMarker",x,y,time},				--posX/"storeunitid", poxY, duration
	{"revealFow",x,y,range,true},			--posX/"storeunitid", posY, range, true/false
	{"showDialogue",string,waitForText},	--showDialogue with autocallbackEx, wait for handle, TEXT
	{"spawnUnitAndMove",tableToSave,tableToSaveName(string),playerId,unitTemplateId,spawnPosX,spawnPosY,SquadId,AiState,movePosX,movePosY,waitForUnit},		--Tabletostore the spawn units, table name (string),playerId, unitId, posX, posY, movePosX, movePosY // if movePosX nil = waits for 1 seconds
	{"attack","unit1","unit2",true}			--string or number id for attacker/defender, data4 = boolean wait true/false 
}
]]--

--Cutscene function
function CutsceneFunction(cutsceneParameters) --function to create cutscenes using tables (examples above)
	local unitId = -1
	local unitId2 = -1
	local index = 1
	local unit = nil
	local data = nil
	local waitForCam = nil
	local waitForText = nil
	local waitForUnit = nil
	local waitForAttack = nil
	local UnitSpawnXPos = nil
	local UnitSpawnYPos = nil
	repeat
		data = cutsceneParameters[index]
		if data[1] == "moveCam" then																--moves camera to certain locatio
			if type(data[2]) == "number" then 														--data[2]&[3] = number the moves the camera to cordinates
				waitForCam = ScriptManager:moveCameraEx(data[2],data[3],data[4],data[5],data[6])
			elseif type(data[2]) == "string" then 													--uses data[]"string" to get values from stored unitids and moves to this id if existing
				if data[2] == "unitSpawnXPos" then
					UnitSpawnXPos = ScriptManager:getValue(data[2])
					UnitSpawnYPos = ScriptManager:getValue(data[3])
					print("movecamto"..UnitSpawnXPos)
					print("movecamto"..UnitSpawnYPos)
					waitForCam = ScriptManager:moveCameraEx(UnitSpawnXPos,UnitSpawnYPos,data[4],data[5],data[6])
				elseif data[2] ~= "unitSpawnXPos" then
					unitId = Unit:getUnitById(ScriptManager:getValue(data[2]))
					if unitId ~= nil then
						waitForCam = ScriptManager:moveCameraEx(unitId:getX(),unitId:getY(),data[4],data[5],data[6])
					elseif unitId == nil then
						unitId = ReturnAnyPlayerUnit()
						waitForCam = ScriptManager:moveCameraEx(unitId:getX(),unitId:getY(),data[4],data[5],data[6])
					end
				end
			end
		elseif data[1] == "wait" then
			if type(data[2]) ~= "string" then
				ScriptManager:wait(data[2])
			elseif data[2] == "waitForCam" then			--wait for camera movement to compelte
				print("waitForCam")
				ScriptManager:waitForCompletion(waitForCam)
			elseif data[2] == "waitForText" then		--wait for text dialogue to disapear
				print("waitForText")
				ScriptManager:waitForCompletion(waitForText)
			elseif data[2] == "waitForUnit" then		--wait for text dialogue to disapear
				print("waitForUnit")
				ScriptManager:waitForCompletion(waitForUnit)
			elseif data[2] == "waitForAttack" then		--wait for text dialogue to disapear
				print("waitForAttack")
				ScriptManager:waitForCompletion(waitForAttack)
			end
		elseif data[1] == "showMarker" then									--show marker on certain positions
			if type(data[2]) == "string" then								--if input is string 
				unitId = Unit:getUnitById(ScriptManager:getValue(data[2]))
				if unitId ~= nil then
					ScriptManager:showMarkerAt(unitId:getX(),unitId:getY())
				elseif unitId == nil then
					print(string.format("Can't mark unit %s (nil)",data[2]))
				end
			elseif type(data[2]) == "number" then							--if value is number
				ScriptManager:showMarkerAt(data[2],data[3])
			elseif type(data[2]) == "table" then
				for i = 1, #data[2] do										--if table contains unit ids
					ScriptManager:showMarkerAt(Unit:getUnitById(data[2][i]):getX(),Unit:getUnitById(data[2][i]):getY())
				end
				if #data[2] == 0 then										--if table is empty
					print("Can't mark unit: table is empty")
				end
			end
			ScriptManager:sleep(data[4],"HideAllMarkers")
		elseif data[1] == "revealFow" then
			if type(data[2]) == "string" then								--if input is string 
				if data[2] == "unitSpawnXPos" then
					ScriptManager:revealFogOfWar(ScriptManager:getValue(data[2]),ScriptManager:getValue(data[3]),data[4],data[5])
				elseif data[2] ~= "unitSpawnXPos" then
					unitId = Unit:getUnitById(ScriptManager:getValue(data[2]))
					if unitId ~= nil then 
						ScriptManager:revealFogOfWar(unitId:getX(),unitId:getY(),data[4],data[5]) --reveal fow on a unit
					elseif unitId == nil then 									--if input is empty
						print("can't move to unit (nil)")
					end
				end
			elseif type(data[2]) == "number" then							--if input is integer
					ScriptManager:revealFogOfWar(data[2],data[3],data[4],data[5])
			elseif type(data[2]) == "table" then
				for i = 1, #data[2] do										--if table contains unit ids
					ScriptManager:revealFogOfWar(Unit:getUnitById(data[2][i]):getX(),Unit:getUnitById(data[2][i]),data[4],data[5])
				end
				if #data[2] == 0 then										--if table is empty
					print("Can't reveal unit: table is empty")
				end
			end
		elseif data[1] == "showDialogue" then
			waitForText = ScriptManager:displaySubtitleAutoEx(data[2],data[3])
		elseif data[1] == "spawnAndMove" then 								--table, tableName, playerId, templateId, spawnPosX, spawnPosY, squadId, Aistate, movePosX, movePosY, waitForMove true/false
			unit = ScriptManager:spawnUnit(data[4],data[5],data[6],data[7],data[8],data[9]) --playerId, templateId, tileX, tileY, squadId, Aistate
			local tableId = data[2]
			table.insert(tableId,#tableId+1,unit:getId())					--insert unit id into table
			SaveUnitId(data[2],data[3])
			print(string.format("SAVEUNITINTOTABLE: Id: %i Table: %s",unit:getId(),data[3]))
			if data[10] ~= nil then											--if table contains move index, move unit
				waitForUnit = ScriptManager:moveUnitEx(unit:getId(),data[10],data[11],data[12])		--move unit to moveX,moveY wait until unit in position true/false
			elseif data[10] == nil then		
				ScriptManager:wait(1)
			end 										-- waits 1 second inbetween each spawn
			if type(data[13]) == "string" then							-- if data[13] is a string, stored the unit under this string
				print("saveValue:"..data[13])
				ScriptManager:storeValue(string.format("%s",data[13]),unit:getId())
			elseif type(data[13]) ~= nil then
				print("Can't store unit, string expected!")
			end
		elseif data[1] == "attack" then 											--attack function
			if type(data[2]) == "string" then										--gets value from string (stored unit id)
				unitId = ScriptManager:getValue(data[2])
				waitForAttack = ScriptManager:attackUnitEx(unitId,data[3],data[4])
			elseif type(data[3]) == "string" then									
				unitId = ScriptManager:getValue(data[3])
				waitForAttack = ScriptManager:attackUnitEx(data[2],unitId,data[4])
			elseif type(data[2]) == "string" and type(data[3]) == "string" then
				unitId = ScriptManager:getValue(data[2])
				unitId2 = ScriptManager:getValue(data[3])
				waitForAttack = ScriptManager:attackUnitEx(unitId,unitId2,data[4])
			elseif type(data[2]) == "number" and type(data[3]) == "number" then
				waitForAttack = ScriptManager:attackUnitEx(data[2],data[3],data[4])
			end
		elseif data[1] == "capture" then
			unitId = ScriptManager:getValue(data[2])
			ScriptManager:captureUnit(unitId,data[3],"")
			ScriptManager:wait(1)
		end
	index = index + 1															--increase index by 1								--Wait 1 second				
	until cutsceneParameters[index] == cutsceneParameters[#cutsceneParameters+1]
end

function ReturnAnyPlayerUnit()
	local unit = nil
	local iD = 0
	local playerId = nil
	repeat
		unit = Unit:getUnitById(iD)
		if unit ~= nil then
			playerId = unit:getPlayerId()
		end
		iD = iD+1
	until playerId == 0 and iD < 1000
	return unit
end
--Old functions

--SpawnUnits and move function
function SpawnAndMove(unitParameters)	--({playerId,unitId,spawnX,spawnY,moveX,moveY})
	local index = 1
	local unit = nil
	local unitData = nil
	repeat
		unitData = unitParameters[index]
		unit = ScriptManager:spawnUnit(unitData[1],unitData[2],unitData[3],unitData[4],ScriptManager:getCurrentRound()+666,AiState.ATTACK_AGGRESSIVE)
		if unitData[5] ~= nil then													--if table contains move index, move unit
			ScriptManager:moveUnitEx(unit:getId(),unitData[5],unitData[6],true)		--move unit to moveX,moveY wait until unit in position
		elseif unitData[5] == nil then		
			ScriptManager:wait(1)
		end
		index = index + 1															--increase index by 1								--Wait 1 second				
	until unitParameters[index] == unitParameters[#unitParameters+1]				--repeat until index is #unitParameters+1
	return 1
end

--Move camera function
function MoveCameraAndWait(cameraParameters) --(moveCamX,moveCamY,camZoom,time) (wait in seconds)
	local index = 1
	local camData = nil
	repeat
		camData = cameraParameters[index]
		if camData[2] ~= nil then
			ScriptManager:moveCameraEx(camData[1],camData[2],camData[3],camData[4],true)
		elseif camData[2] == nil then
			ScriptManager:wait(camData[1])
		end
		index = index + 1	
	until cameraParameters[index] == cameraParameters[#cameraParameters+1]
end


--mission accomplished cutscene
missionAccomplished = 
{
	{"moveCam","unitLastSelected",-1,0.7,4,true},
	{"wait",1},
}

--Mission succeed function
function MissionControlSucceed(missionMain,outroDialogue)
	ScriptManager:blockUI(true)
	ScriptManager:wait(1)
	ScriptManager:setMissionStatus(missionMain,MissionStatus.ACCOMPLISHED)
	ScriptManager:displaySubtitleAutoEx(outroDialogue,false)
	CutsceneFunction(missionAccomplished)
	ScriptManager:endGame()
end

--Returns the Gold value of certain unit
function GetGoldValue(unit) --returns gold value of a unit
	local unitTemplateId = unit:getTemplateId()
	if unitTemplateId == Units.UNIT_DE_MP40 or unitTemplateId == Units.UNIT_SU_RIFLE then
		return 200
	elseif unitTemplateId == Units.UNIT_DE_PANZERFAUST or unitTemplateId == Units.UNIT_SU_MORTAR then
		return 250
	elseif unitTemplateId == Units.UNIT_DE_AA or unitTemplateId == Units.UNIT_SU_AA then
		return 400
	elseif unitTemplateId == Units.UNIT_DE_TANK_3 then
		return 600
	elseif unitTemplateId == Units.UNIT_DE_TANK_4 or unitTemplateId == Units.UNIT_SU_TANK_T34 then
		return 750
	elseif unitTemplateId == Units.UNIT_DE_TRANSPORT_TRUCK or unitTemplateId == Units.UNIT_SU_TRANSPORT_TRUCK then
		return 1000
	elseif unitTemplateId == Units.UNIT_DE_SUPPLY_TRUCK or unitTemplateId == Units.UNIT_SU_SUPPLY_TRUCK then
		return 1000
	elseif unitTemplateId == Units.UNIT_DE_TANK_DESTROYER or unitTemplateId == Units.UNIT_SU_TANK_DESTROYER then
		return 1350
	elseif unitTemplateId == Units.UNIT_SU_KATYUSHA then
		return 1350
	elseif unitTemplateId == Units.UNIT_SU_HOWITZER or unitTemplateId == Units.UNIT_DE_ARTILLERY then
		return 1950
	elseif unitTemplateId == Units.UNIT_DE_TIGER or unitTemplateId == Units.UNIT_SU_TANK_KV1 then
		return 2400
	else
		return 0
	end
end

-- function to queue cutscenes
cutsceneQueue = {}

function CutsceneQueue()
	print("CutsceneQueue...")
	print("Cutscenes left = "..#cutsceneQueue)
	print("Cutscene is active = "..cutsceneActive)
	
	local cutscene = nil
	
	if #cutsceneQueue > 0 and cutsceneActive == 0 then --Check to start the function only once
		print("start cutscenefunction")
		cutsceneActive = 1
		cutscene = cutsceneQueue[1]
		cutscene()
		table.remove(cutsceneQueue,1)
		cutsceneActive = 0
		ScriptManager:continueAfterCutscene("CutsceneQueue")	--Repeat and check if there are more cutscenes to play left
	end	
end

function SubtitleQueue()
	print("CutsceneQueue...")
	print("Cutscenes left = "..#cutsceneQueue)
	print("Cutscene is active = "..cutsceneActive)
	
	local cutscene = nil
	
	if #cutsceneQueue > 0 and cutsceneActive == 0 then --Check to start the function only once
		print("start cutscenefunction")
		cutsceneActive = 1
		cutscene = cutsceneQueue[1]
		cutscene()
		table.remove(cutsceneQueue,1)
		cutsceneActive = 0
		ScriptManager:sleep( 1, "SubtitleQueue" );	--Repeat and check if there are more cutscenes to play left
	end	
end

--funtion to mark all attacked units
unitIsAttacked =
{
	{"moveCam","attackedUnitId",-1,0.9,2,true}, 								
	{"wait",1},		
	{"showMarker","attackedUnitId",-1,3},				
	{"showDialogue",Text.T_MISSION_DEPOT_WARNING,true},	
	{"wait",1},								
	{"moveCam","unitLastSelected",-1,0.8,2,true}, 
}

attackedUnitsQueue = {}

function UnitIsUnderAttack(activeUnit, passiveUnit)
	if CheckForAttackedUnit(passiveUnit:getId()) == false then
		print("inserting = "..passiveUnit:getId())
		table.insert(attackedUnitsQueue,passiveUnit:getId())
		ScriptManager:runForPlayer(0,"UnitAttackedFunction")
	end
end

function CheckForAttackedUnit(UnitId)
  for _, value in pairs(attackedUnitsQueue) do
    if value == UnitId then
      return true
    end
  end
  return false
end

--Queues the cutscene to warn the player
function UnitAttackedFunction()
	table.insert(cutsceneQueue,_UnitAttackedFunction)
	CutsceneQueue()
end

function _UnitAttackedFunction()
	ScriptManager:storeValue("attackedUnitId",attackedUnitsQueue[1])
	ScriptManager:startCutscene()
	CutsceneFunction(unitIsAttacked)
	ScriptManager:stopCutscene()
	table.remove(attackedUnitsQueue,1)
end