require "lua/MAP_SU_3_1_MISSION"
require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

tigerBelow2500 = 0
-- Spawn locations for enemy units
depotIds = {0,3,14} 
--spawn position for bunker defenders (units will disappear when directly spawning them at bunker pos...)
bunkerDefenderPos = 
{
	{7,7}, 
}

function onGameStart() 							--Initiate Start Functions & Trigger
	SetStartProperties(true,4,9,1000) 			--(BlockUi(Boolean),StartCameraPosition x&y, LocalStarting Gold)
	InitiateFunctionsAndTriggers()				--Initiate mission triggers MAP_SU_2_1_MISSION.lua
	
	InitiateFunctions_2	()	--"lua/Functions_2"
	IntitateUnitFunctions() --"lua/UnitFunctions"
	
	ScriptManager:sleep(0,"IntroCutScene")		--Intro cutscene

	--Initiate Enemy wave spawner
	ScriptManager:addOnTurnStartTrigger(1,-1,0,"SpawnFunction_1","SpawnFunction_1",false) 	--easy wave
	ScriptManager:addOnTurnStartTrigger(1,-1,1,"SpawnFunction_2","SpawnFunction_2",false)	--medium wave
	ScriptManager:addOnTurnStartTrigger(1,-1,2,"SpawnFunction_3","SpawnFunction_3",false)	--hardcore wave
	
	--Respawn enemies if dead & spawnPos alive
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"_ResetSpawnFunctions","_ResetSpawnFunctions",false)
	
	--Spawn defender of the depots
	SpawnEnemyReinforcements(0,saveUnit_4,"saveUnit_4", enemyGroupsGroundEasy, AiState.DEFEND)	--east base defenders
	SpawnEnemyReinforcements(3,saveUnit_5,"saveUnit_5", enemyGroupsGroundMedium, AiState.DEFEND)	--west base defenders
	SpawnEnemyReinforcements(14,saveUnit_6,"saveUnit_6",enemyGroupsGroundHard, AiState.DEFEND)	--North base defender
	SpawnEnemyReinforcements(bunkerDefenderPos,saveUnit_7,"saveUnit_7", enemyGroupsGroundEasy, AiState.DEFEND) 	--Bunker Defenders
end


spawnerProperties = --{depotId, randomMinTimer, randomMaxTimer, spawnCount}
{
	{3,1,2,7},
	{0,1,2,5},
	{14,2,3,5},
}


--check spawners & add respawn counters
function _ResetSpawnFunctions()
	ResetSpawnFunctions(spawnerProperties) --"lua/Functions_2"
end


function SpawnFunction_1()
	SpawnerFunction("spawnerActive_1", "spawnCounterIndex_1", 3, saveUnit_1, "saveUnit_1", enemyGroupsGroundEasy, AiState.ATTACK_AGGRESSIVE)
end


function SpawnFunction_2()
	SpawnerFunction("spawnerActive_2", "spawnCounterIndex_2", 0, saveUnit_2, "saveUnit_2", enemyGroupsGroundEasy, AiState.ATTACK_AGGRESSIVE)
end


function SpawnFunction_3()
	SpawnerFunction("spawnerActive_3", "spawnCounterIndex_3", 14, saveUnit_3, "saveUnit_3", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end


--Changes the Ai behaviour depending on the current health
function TigerUpdateAiBehaviour()	
	ScriptManager:runForPlayer(0,"TigerUpdateAiState")	--Change Ai state of the Tiger in Player turn
end

-- xSpawnPos,ySpawnPos,xAttackPos,yAttackPos
tigerSpawnPositions = 
{
	{13,16},
	{7,18},
	{1,19},
}

--spawnTiger and choosing first waypoint
function TigerSpawnChooseLocation()										
	local tigerCords = tigerSpawnPositions[math.random(1,#tigerSpawnPositions)] 	--(Randomly choose index of tigerSpawnPositions table)
	local superTiger = ScriptManager:spawnUnit(1,Units.UNIT_DE_TIGER_EXTREME,tigerCords[1],tigerCords[2],99,AiState.MOVE_AGGRESSIVE)
	ScriptManager:storeValue("superTiger",superTiger:getId())						--store tiger id for later use
	ScriptManager:camouflageUnit(superTiger:getId())
	print("TigerTarget location",tigerCords[1],tigerCords[2])						--TODO:remove prints later
	TigerPatrol()
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,superTiger:getId(),"TigerDestroyedCutscene","TigerDestroyedCutscene",false) -- MISSION.lua
	ScriptManager:addOnUnitSightedTrigger(1,-1,superTiger:getId(),true,"MissionStartKillTiger","MissionStartKillTiger",false)	--add trigger for enemy spotted
	ScriptManager:addOnUnitHasAttackedTrigger(-1,-1,superTiger:getId(),"MissionStartKillTiger","MissionStartKillTiger",false)
end


--Positions for the tiger to move to
tigerPatrolWaypoints =
{
	{8,13},
	{6,7},
	{3,9},
	{5,15},
	{9,17},
	{1,15},
}

--Initiate Patrolfunction
function TigerPatrol()
	tigerBelow2500 = 0
	for i = 1, #tigerPatrolWaypoints do
		ScriptManager:storeValue(string.format("waypoint_%i_%i",99,i),0)
	end
	_TigerChooseWayPoint()
end

function _TigerChooseWayPoint()
	ScriptManager:removeTrigger("_TigerChooseWayPoint")
	ScriptManager:runForPlayer(0,"TigerChooseWayPoint")
end

--Function to choose the waypoint randomly and go trough all waypoints, then resetes
function TigerChooseWayPoint()
	local unitId = ScriptManager:getValue("superTiger")
	local waypointStoreIndex = 0
	local wayPointIndex = 0	--define local variables
	local wayPoint = 0
	local wayPointsUsed = 0
	local squadId = 99
	--checks how many storages are used
	for i = 1, #tigerPatrolWaypoints do	
		if ScriptManager:getValue(string.format("waypoint_%i_%i",squadId,i)) ~= 0 then
			wayPointsUsed = wayPointsUsed + 1 --increase used index by 1 of theres a stored value ~= 0
		end
	end
	print("waypointsUsed:"..wayPointsUsed)											--TODO:remove prints for release
	--if #tigerPatrolWaypoints are used = resets the storages (0)
	if wayPointsUsed == #tigerPatrolWaypoints then			
		for i = 1, #tigerPatrolWaypoints do
			ScriptManager:storeValue(string.format("waypoint_%i_%i",squadId,i),0)
			print("RESETTING WAYPOINTS")
		end
	end
	--repeats until if finds an index storage which is empty
	repeat	
		wayPointIndex = math.random(1,#tigerPatrolWaypoints)												--randomly chooses a index from #tigerPatrolWaypoints
		waypointStoreIndex = ScriptManager:getValue(string.format("waypoint_%i_%i",squadId,wayPointIndex))	-- get index from storage
	until waypointStoreIndex == 0 -- if finds an empty storage us this index
	wayPoint = tigerPatrolWaypoints[wayPointIndex]
	ScriptManager:addOnMovedToTileTrigger(wayPoint[1],wayPoint[2],1,squadId,2,true,"_TigerChooseWayPoint","_TigerChooseWayPoint",false) -- creat new trigger for the target location
	ScriptManager:setTargetTile(1,squadId,wayPoint[1],wayPoint[2])																				-- set new move order
	print("New waypoint = "..wayPoint[1],wayPoint[2])												--TODO:remove prints for release
	ScriptManager:storeValue(string.format("waypoint_%i_%i",squadId,wayPointIndex),wayPointIndex) 	--stores unused index
end

tigerRetreatPos = --(xCordinate,yCordinate)
{
	{3,18},
}

--Change behaviour depending on the tigers health
function TigerUpdateAiState()
	local superTiger = Unit:getUnitById(ScriptManager:getValue("superTiger"))
	if superTiger ~= nil and superTiger:getHealth() < 2500 and tigerBelow2500 == 0 then 												-- if Tiger below 1300HP it switches Ai.state to retreat
		tigerBelow2500 = 1
		ScriptManager:removeTrigger("TigerUpdateAiBehaviour")							--remove trigger
		ScriptManager:removeTrigger("_TigerChooseWayPoint")							--remove trigger
		ScriptManager:runForPlayer(0,"TigerChangeBehaviour")							--change ai state, choose retreat position
		ScriptManager:addOnTurnEndTrigger(1,-1,ScriptManager:getCurrentRound()+2,"_TigerSpawnReinforcements","_TigerSpawnReinforcements",false)
		print("[TIGER]Below 1300, retreats")											--TODO:remove Prints later
	end
end

tigerUseSmoke = 
{
	{"moveCam","superTiger",-1,0.9,1.5,true},
	{"revealFow","superTiger",-1,2,true},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_05_1,false},
	{"wait",1},
	{"revealFow","superTiger",-1,2,false},
	{"moveCam","unitLastSelected",-1,0.8,1.5,true},
}

--Tiger retreats, spawning units assisting him
function TigerChangeBehaviour()
	local superTiger = Unit:getUnitById(ScriptManager:getValue("superTiger"))
	local index = math.random(1,#tigerRetreatPos)
	local tigerMovePos = tigerRetreatPos[index]			-- randomly choose location out from tigerRetreatPos table
	ScriptManager:setTargetTile(1,99,tigerMovePos[1],tigerMovePos[2])				-- Set target tile to retreat Pos
	ScriptManager:storeValue("tigerRetreatPosX",tigerMovePos[1])					--save tiger retreatPosX for spawning units in ai turn
	ScriptManager:storeValue("tigerRetreatPosY",tigerMovePos[2])					--save tiger retreatPosY for spawning units in ai turn
--	Unit:changeSquadState(1,superTiger:getSquadId(),AiState.MOVE)		
	ScriptManager:addOnMovedToTileTrigger(tigerMovePos[1],tigerMovePos[2],1,superTiger:getSquadId(),2,false,"TigerReachedRetreatPoint","TigerReachedRetreatPoint",false)
end

tigerRepairCutscene = 
{
	{"moveCam","superTiger",-1,0.9,2,true},
	{"revealFow","superTiger",-1,2,true},
	{"showMarker","superTiger",-1,2},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_07,false},
	{"wait",1},
}

tigerCutsceneEnd =
{
	{"revealFow","superTiger",-1,2,false},					
	{"moveCam","unitLastSelected",-1,0.8,2,true},
}

--Tiger reached retreat position and now changes back to agressive choosing a new waypoint
function TigerReachedRetreatPoint()
	ScriptManager:removeTrigger("TigerReachedRetreatPoint")
	ScriptManager:runForPlayer(0,"TigerSuppling")
end

function TigerSuppling()
	table.insert(cutsceneQueue,_TigerSuppling)
	CutsceneQueue()
end

function _TigerSuppling()
	ScriptManager:startCutscene()
	local superTiger = Unit:getUnitById(ScriptManager:getValue("superTiger"))
	local xPos = superTiger:getX()
	local yPos = superTiger:getY()
	local truckone = ScriptManager:spawnUnit(1,Units.UNIT_DE_SUPPLY_TRUCK,xPos,yPos,666,AiState.MOVE)
	local trucktwo = ScriptManager:spawnUnit(1,Units.UNIT_DE_SUPPLY_TRUCK,xPos,yPos,667,AiState.MOVE)
	ScriptManager:camouflageUnit(truckone:getId())
	ScriptManager:camouflageUnit(trucktwo:getId())
	Unit:changeSquadState(1,superTiger:getSquadId(),AiState.MOVE_AGGRESSIVE)
	ScriptManager:setTargetTile(1,666,7,10)
	ScriptManager:setTargetTile(1,667,7,11)
	CutsceneFunction(tigerRepairCutscene)
	ScriptManager:addOnUnitSuppliedTrigger(-1,-1,ScriptManager:getValue("superTiger"),"TigerSupplied","TigerSupplied",false)
	ScriptManager:supplyUnitEx(truckone:getId(),ScriptManager:getValue("superTiger"),true)
	ScriptManager:wait(2)
	ScriptManager:supplyUnitEx(trucktwo:getId(),ScriptManager:getValue("superTiger"),true)
	ScriptManager:wait(4)
	CutsceneFunction(tigerCutsceneEnd)
	ScriptManager:stopCutscene()
	ScriptManager:removeUnitEx(truckone:getId(),true)
	ScriptManager:removeUnitEx(trucktwo:getId(),true)
	TigerPatrol()
end

function TigerSupplied()
	local unitId = ScriptManager:getValue("superTiger")
	local tiger = Unit:getUnitById(unitId)
	tiger:setHealth(tiger:getHealth()+1000)
end

function TigerAlmostDeadDialogue()
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_1_MISSION_FLAVOR_03,false)
end

tigerReinforcements = 
{
	{11,17},
	{1,16},
	{9,19},
}
--Spawns units on the tiger's retreat position and move them to the tiger

tigerReinforcementsGroup =
{
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_MP40, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
}

function _TigerSpawnReinforcements()
		ScriptManager:addOnTurnEndTrigger(1,-1,ScriptManager:getCurrentRound()+2,"_TigerSpawnReinforcements","_TigerSpawnReinforcements",false)
	if #saveUnit_15 < 15 then
		SpawnEnemyReinforcements(tigerReinforcements,saveUnit_15,"saveUnit_15",tigerReinforcementsGroup, AiState.ATTACK_AGGRESSIVE)
		print("saveUnit_15 count = "..#saveUnit_15)
		ScriptManager:runForPlayer(0,"EnemyReinforcementsHaveArrived")
	end
end