require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

missionContent = --missionId,primary(boolean),textkey,xpReward
{
	{2,true,Text.T_MAP_SU_2_1_MISSION_PRIMARY_02,100},		--capture outpost
	{3,true,Text.T_MAP_SU_2_1_MISSION_PRIMARY_03,50},		--find the tiger
	{4,true,Text.T_MAP_SU_2_1_MISSION_PRIMARY_04,350},		--destroy the tiger
	{5,false,Text.T_MAP_SU_2_1_MISSION_SECONDARY_02,50},				--destroy the bunker
	{6,false,Text.T_MAP_SU_2_1_MISSION_SECONDARY_01,200},	--low casulties
	{7,false,Text.T_MAP_SU_2_1_MISSION_SECONDARY_03,250},	--destroy the remaining depots
}

--Initiate various triggers and 
function InitiateFunctionsAndTriggers()
--TODO: Comment out before commit
--	ScriptManager:spawnUnit(0,Units.GOTT,7,1,500,1)
--	ScriptManager:spawnUnit(0,Units.GOTT,6,1,500,1)

----	ScriptManager:spawnUnit(0,Units.UNIT_SU_RIFLE,11,5,500,1)
--	for i = 1, 5 do
--		ScriptManager:spawnUnit(0,Units.UNIT_SU_TANK_KV1,6,13,205,AiState.ATTACK_AGGRESSIVE)
--	end
--	--Create missions from missionContent table
	CreateMissions(missionContent)							
	
	--trigger to check tigger hp and update behaviour
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_TIGER_EXTREME,-1,"TigerUpdateAiBehaviour","TigerUpdateAiBehaviour", true)
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_TIGER_EXTREME,-1,"TigerUpdateAiBehaviour","TigerUpdateAiBehaviour", false)
	
	--Trigger to start destroy bunker mission									
	ScriptManager:addOnEnterTileTrigger(9,7,0,-1,-1,true,"MissionStartBunker","MissionStartBunker")	
	
	--Trigger to start destroy bunker mission						
	ScriptManager:addOnEnterTileTrigger(10,6,0,-1,-1,true,"MissionStartBunker","MissionStartBunker")		
	
	--Trigger for low casulties mission				
	ScriptManager:addOnUnitHasAttackedTrigger(0,-1,-1,"MissionStartLowCasualties","MissionStartLowCasualties",false)
	
	--Trigger for destroy bunker mission accomplished		
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,7,"MissionDestroyBunkerAccomplished","MissionDestroyBunkerAccomplished")	

	
	--mission Secondary low casulties trigger
	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"CountCasualties","CountCasualties",false)
	
	--set Casualties counter
	ScriptManager:setMissionProgress(6,0) --define Maximum of Casualties
	
	--mission Capture the depot MissionDepotCaptured
	ScriptManager:addOnUnitCapturedTrigger(0,-1,5,"MissionDepotCaptured","MissionDepotCaptured",false)
	
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_DEPOT_UNATTACKABLE,-1,"DepotDestroyed","DepotDestroyed",false)
	
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,5,"CaputeDepotFailed","CaputeDepotFailed",false)
	
	--destroy depots mission triggers
	ScriptManager:addOnUnitSightedTrigger(-1,-1,0,true,"MissionDestroyDepotsStart","MissionDestroyDepotsStart",false)
	ScriptManager:addOnUnitSightedTrigger(-1,-1,14,true,"MissionDestroyDepotsStart","MissionDestroyDepotsStart",false)
	ScriptManager:addOnUnitSightedTrigger(-1,-1,3,true,"MissionDestroyDepotsStart","MissionDestroyDepotsStart",false)
end

function CaputeDepotFailed()
	ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
	ScriptManager:setMissionStatus(3,MissionStatus.FAILED)
	ScriptManager:setMissionStatus(4,MissionStatus.FAILED)
	_EndGameCutscene()
end

--Start Low Casualties on unit attacked
function MissionStartLowCasualties()		
	ScriptManager:removeTrigger("MissionStartLowCasualties")
	ScriptManager:runForPlayer(0,"_MissionStartLowCasualties")
end

-- low Casualties cutscene
missionLowCasulties = 
{
	{"moveCam","unitLastSelected",-1,0.9,4,false}, 
	{"wait",1},	
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_SECONDARY_01_FLAVOR,true},
	{"moveCam","unitLastSelected",-1,0.75,1,true}, 	
}

-- Low Casualties start cutscene and set mission status in progress

function _MissionStartLowCasualties()
	table.insert(cutsceneQueue,__MissionStartLowCasualties)
	CutsceneQueue()
end

function __MissionStartLowCasualties()
	ScriptManager:blockUI(true)
	ScriptManager:wait(1)
	ScriptManager:startCutscene()
	CutsceneFunction(missionLowCasulties)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(6,MissionStatus.IN_PROGRESS)
	ScriptManager:blockUI(false)
end

--Get unit gold and set new mission Progress
function CountCasualties(unit)				
	local unitValue = GetGoldValue(unit) 												
	ScriptManager:setMissionProgress(6,ScriptManager:getMissionProgress(6)+unitValue)
	local missionProgress = ScriptManager:getMissionProgress(6)
	if missionProgress < 10000 then														-- depending on new progress start function after cutscene
		ScriptManager:runForPlayer(0,"MissionLowCasualtiesPrintProgress")
	elseif missionProgress > 10000 then
		ScriptManager:removeTrigger("CountCasualties")		
		ScriptManager:runForPlayer(0,"MissionLowCasualtiesFailed")
	end
end


function MissionLowCasualtiesPrintProgress()
	if ScriptManager:noUnitsLeft(0) ~= true then
		table.insert(cutsceneQueue,_MissionLowCasualtiesPrintProgress)
		CutsceneQueue()
	end
end

--Print Casualties value
function _MissionLowCasualtiesPrintProgress()			
	local progress = ScriptManager:getMissionProgress(6) -- show different messages depending on the casualties score
	if progress < 4000 then
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_1_MISSION_SECONDARY_01_COUNTER_1,false)
	elseif progress < 8000 and progress > 4000 then
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_1_MISSION_SECONDARY_01_COUNTER_2,false)
	elseif progress < 10000 and progress > 8000 then
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_1_MISSION_SECONDARY_01_COUNTER_3,false)
	end
end

function MissionLowCasualtiesFailed()
	table.insert(cutsceneQueue,_MissionLowCasualtiesFailed)
	CutsceneQueue()
end

--mission failed too much Casualties
function _MissionLowCasualtiesFailed()
	ScriptManager:blockUI(true)			
	ScriptManager:setMissionStatus(6,MissionStatus.FAILED)
	ScriptManager:wait(1.5)
	ScriptManager:blockUI(false)			
end

tigerReinforcementsCutscene = 
{
	{"moveCam","unitSpawnXPos","unitSpawnYPos",0.9,2,true},
	{"revealFow","unitSpawnXPos","unitSpawnYPos",2,true},
	{"wait",1},
	{"showMarker",saveUnit_15,-1,2},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_06,true},
	{"revealFow","unitSpawnXPos","unitSpawnYPos",2,false},
	{"moveCam","unitLastSelected",-1,0.8,2,true},
}

IntroPrameters = --Intro Cutscene
{
	{"moveCam",3,4,0.8,3,true}, 						
	{"revealFow",3,4,2,true},			
	{"wait",0.5},				
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_PRIMARY_02_FLAVOR,false},				
	{"wait",1},												
	{"showMarker",3,4,3.5},					
	{"wait",0.5},				
	{"moveCam",3,4,1,4,false}, 						
	{"wait",4},												
	{"spawnAndMove",saveUnit_11,"saveUnit_11",1,Units.UNIT_DE_MP40,3,6,2,AiState.DEFEND,2,5,true},
	{"spawnAndMove",saveUnit_11,"saveUnit_11",1,Units.UNIT_DE_MP40,2,2,2,AiState.DEFEND,2,3,true},
	{"spawnAndMove",saveUnit_11,"saveUnit_11",1,Units.UNIT_DE_PANZERFAUST,5,3,2,AiState.DEFEND,4,4,true},
	{"wait","waitForText"},								
	{"wait",1},											
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_PRIMARY_02_FLAVOR_01,false},				
	{"showMarker",saveUnit_2,-1,3},
	{"wait","waitForText"},								
	{"wait",1},											
	{"revealFow",3,4,2,false},	
	{"moveCam",12,3,1,5,false}, 						
	{"wait",3},													
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,11,1,0,AiState.DEFEND,11,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,12,1,0,AiState.DEFEND,12,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,13,2,0,AiState.DEFEND,11,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,12,1,0,AiState.DEFEND,12,2,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,13,2,0,AiState.DEFEND,12,3,true},
	{"moveCam",11,4,0.8,2,true}, 						
	{"wait",0.5},						
}

--On game start intro cutscene
function IntroCutScene()	
	ScriptManager:blockUI(true)
	ScriptManager:startCutscene()
	CutsceneFunction(IntroPrameters)
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 11, 4 );
	end
	ScriptManager:stopCutscene()
	ScriptManager:wait(1)
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
	ScriptManager:blockUI(false)
	EnablePlayerInteraction(); -- fix by fst
end

bunkerCutscene = 
{
	{"moveCam",7,6,1,1.5,true},
	{"revealFow",7,6,2,true},
	{"showMarker",7,6,2},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_SECONDARY_02_FALVOR,true},
	{"wait",1},
	{"revealFow",7,6,2,false},					
	{"moveCam",8,3,1,3,false},
	{"wait",1},
	{"showDialogue",Text.T_MISSION_REINFORCEMENTS,false},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,	8,1,0,AiState.DEFEND,9,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_KATYUSHA,	8,1,0,AiState.DEFEND,9,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	8,1,0,AiState.DEFEND,8,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	8,1,0,AiState.DEFEND,8,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	8,1,0,AiState.DEFEND,9,2,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	8,1,0,AiState.DEFEND,10,2,true},
	{"wait",1},
	{"moveCam","unitLastSelected",-1,0.8,1,true},
}

--Destroy the bunker mission + cutscene
function MissionStartBunker()
	ScriptManager:removeTrigger("MissionStartBunker")
	ScriptManager:blockUI(true)
	ScriptManager:wait(1)
	ScriptManager:startCutscene()
	CutsceneFunction(bunkerCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(5,MissionStatus.IN_PROGRESS)
	ScriptManager:blockUI(false)
end

--Destroy bunker mission
function MissionDestroyBunkerAccomplished()
	ScriptManager:removeTrigger("MissionDestroyBunkerAccomplished")
	ScriptManager:setMissionStatus(5,MissionStatus.ACCOMPLISHED)
end


missionDepotCaptured = 
{
	{"moveCam",3,4,0.7,10,false},
	{"wait",1},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_01,false},
	{"wait",0.5},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_DESTROYER,3,1,0,AiState.DEFEND,3,3,true},
	{"wait",1.5},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_KV1,3,1,0,AiState.DEFEND,4,2,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,1,3,0,AiState.DEFEND,3,5,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,1,3,0,AiState.DEFEND,2,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,1,3,0,AiState.DEFEND,2,5,true},
	{"wait","waitForText"},	
	{"moveCam",8,4,0.7,10,false},
	{"wait",2},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_T34,8,1,0,AiState.DEFEND,9,6,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_DESTROYER,8,1,0,AiState.DEFEND,8,5,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_T34,6,1,0,AiState.DEFEND,7,5,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_SUPPLY_TRUCK,6,1,0,AiState.DEFEND,7,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_T34,6,1,0,AiState.DEFEND,6,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,8,1,0,AiState.DEFEND,7,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,8,1,0,AiState.DEFEND,7,2,true},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_02,false},
	{"wait","waitForText"},
	{"wait",1},
}

function MissionDepotCaptured()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(2)
	ScriptManager:startCutscene()
	CutsceneFunction(missionDepotCaptured)
	ScriptManager:stopCutscene()
	ScriptManager:gainGold(0,1000)
	ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	ScriptManager:blockUI(false)
	TigerSpawnChooseLocation()
end



cutsceneDestroyDepot = 
{
	{"moveCam","DepotId",-1,0.9,2,true},
	{"revealFow","DepotId",-1,2,true},
	{"showMarker","DepotId",-1,2},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_SECONDARY_03_FALVOR,true},
	{"wait",1},
	{"revealFow","DepotId",-1,2,false},					
	{"moveCam","unitLastSelected",-1,0.8,2,true},
}

function MissionDestroyDepotsStart(activeUnit, passiveUnit)
	if ScriptManager:getValue("DepotId") == -1 then
		ScriptManager:storeValue("DepotId",passiveUnit:getId())
		table.insert(cutsceneQueue,_MissionDestroyDepotsStart)
		CutsceneQueue()
	end
end

function _MissionDestroyDepotsStart()
	print("depotSighted!")
	ScriptManager:removeTrigger("MissionDestroyDepotsStart")
	ScriptManager:blockUI(true)
	ScriptManager:wait(1)
	ScriptManager:startCutscene()
	CutsceneFunction(cutsceneDestroyDepot)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(7,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(1)
	ScriptManager:blockUI(false)
end


function DepotDestroyed()
	local progress = ScriptManager:setMissionProgress(7,ScriptManager:getMissionProgress(7)+1)
		ScriptManager:preparePopupText()
		print("missionprogress")
		ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(7))
		ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_1_MISSION_SECONDARY_03_COUNTER,false)
	if progress == 3 then
		ScriptManager:setMissionStatus(7,MissionStatus.ACCOMPLISHED)
	end
end


tigerCutscene = 
{
	{"moveCam","superTiger",-1,0.9,2,true},
	{"revealFow","superTiger",-1,2,true},
	{"showMarker","superTiger",-1,2},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_05,true},
	{"wait",1},
	{"revealFow","superTiger",-1,2,false},					
	{"moveCam","unitLastSelected",-1,0.8,2,true},
}

function MissionStartKillTiger()
	ScriptManager:removeTrigger("MissionStartKillTiger")
	ScriptManager:runForPlayer(0,"_MissionStartKillTiger")
end

function _MissionStartKillTiger()	--Start tiger cutscnene (on sighted) and updates missions
	table.insert(cutsceneQueue,__MissionStartKillTiger)
	CutsceneQueue()
end

function __MissionStartKillTiger()
	ScriptManager:removeTrigger("MissionStartKillTiger")
	ScriptManager:setMissionStatus(3,MissionStatus.ACCOMPLISHED)
	ScriptManager:blockUI(true)
	ScriptManager:wait(1.5)
	ScriptManager:startCutscene()
	CutsceneFunction(tigerCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:blockUI(false)
	ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
end

--cutscene for dead tiger
tigerDeadCutscene = 
{
	{"moveCam","unitLastSelected",-1,0.7,5,false},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_FLAVOR_03,true},
	{"wait","waitForCam"},
}

--cutscene for game end
outro =
{
	{"moveCam",7,9,0.7,15,false},
	{"showDialogue",Text.T_MAP_SU_2_1_MISSION_OUTRO,true},
	{"wait",2},
}

function TigerDestroyedCutscene()
	ScriptManager:removeAllTriggers()
	ScriptManager:runForPlayer(0,"_TigerDestroyedCutscene")
end

function _TigerDestroyedCutscene()
	table.insert(cutsceneQueue,__TigerDestroyedCutscene)
	CutsceneQueue()
end


--Tiger dead and outro cutscene
function __TigerDestroyedCutscene()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(4,MissionStatus.ACCOMPLISHED)
	if ScriptManager:getMissionStatus(6) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(6,MissionStatus.ACCOMPLISHED)
	end
	ScriptManager:wait(1.5)
	ScriptManager:startCutscene()
	CutsceneFunction(tigerDeadCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:wait(2)
	ScriptManager:startCutscene()
	CutsceneFunction(outro)
	ScriptManager:stopCutscene()
	table.insert(cutsceneQueue,__TigerDestroyedCutscene_2)
	CutsceneQueue()
end

function __TigerDestroyedCutscene_2()
	ScriptManager:wait(2)
	ScriptManager:displaySubtitleAutoEx(Text.T_MISSION_VICTORY,true)
	ScriptManager:wait(1)
	ScriptManager:endGame()
end

function EnemyReinforcementsHaveArrived()
	table.insert(cutsceneQueue,_EnemyReinforcementsHaveArrived)
	CutsceneQueue()
end

function _EnemyReinforcementsHaveArrived()
	print("starttigerreinforcementcutscene")
	ScriptManager:startCutscene()
	CutsceneFunction(tigerReinforcementsCutscene)
	ScriptManager:stopCutscene()
end