require "lua/MAP_SU_3_2_MISSION"
require "lua/MAP_SU_3_2_CONVOY"
require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

function onGameStart()
	ScriptManager:storeValue("convoySquadIndex",0)
	ScriptManager:storeValue("targetIndex",1)
	InitiateEnemies()
	-- TODO: fix for 31911 / 31976, camera moving into fow. if something bugs later on, check back here
	-- for the fix i just removed the line below
	--SetStartProperties(false,5,5,1500) --Start properties "lua/Functions_2"
	InitiateFunctions_2() --"/Functions_2"
	IntitateUnitFunctions() --"lua/UnitFunctions"
	
	-- make bunker, factory and aa unattackable
	Unit:getUnitById(  6 ):setIsAttackable( false ); -- factory
	Unit:getUnitById( 18 ):setIsAttackable( false ); -- aa
	Unit:getUnitById( 19 ):setIsAttackable( false ); -- aa
	Unit:getUnitById(  0 ):setIsAttackable( false ); -- bunker
	Unit:getUnitById(  1 ):setIsAttackable( false ); -- bunker
	Unit:getUnitById(  2 ):setIsAttackable( false ); -- bunker

	--Checks if trucks reached the factory
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"TrucksCheckIfReachedTrigger","TrucksCheckIfReachedTrigger",false)
	ScriptManager:addOnTurnEndTrigger(1,-1,0,"TruckSpawner","TruckSpawner",false)
	InitiateFunctions() -- "lua/MAP_SU_2_2_MISSION"
	--Trigger for intro cutscene
	ScriptManager:sleep(0,"IntroCutscene")
	local factory = Unit:getUnitById(6)
	factory:setIsAttackable(false)
end

function InitiateEnemies()
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"_ResetSpawnFunctions","_ResetSpawnFunctions",false)

	--Depot Defenders
	SpawnEnemyReinforcements(7,saveUnit_4,"saveUnit_4",	enemyGroupsGroundMedium,AiState.DEFEND)
	SpawnEnemyReinforcements(5,saveUnit_5,"saveUnit_5",	enemyGroupsGroundHard,AiState.DEFEND)
	SpawnEnemyReinforcements(8,saveUnit_6,"saveUnit_6",	enemyGroupsGroundMedium,AiState.DEFEND)
	SpawnEnemyReinforcements(20,saveUnit_8,"saveUnit_8", enemyGroupsGroundEasy,AiState.DEFEND)
	
	--Initiate Enemy wave spawner
	ScriptManager:addOnTurnStartTrigger(1,-1,0,"SpawnFunction_1","SpawnFunction_1",false) 	--easy wave
	ScriptManager:addOnTurnStartTrigger(1,-1,2,"SpawnFunction_2","SpawnFunction_2",false)	--medium wave
	ScriptManager:addOnTurnStartTrigger(1,-1,0,"SpawnFunction_3","SpawnFunction_3",false)	--easy wave
	ScriptManager:addOnTurnStartTrigger(1,-1,1,"SpawnFunction_4","SpawnFunction_4",false)	--easy wave
end

--Properties for respawning {depotId, randomMinTimer, randomMaxTimer, spawnCount}
spawnerProperties = 
{
	{7,1,2,10},
	{5,3,5,3},
	{8,1,2,10},
	{20,2,3,10},
}

--check spawners & add respawn counters
function _ResetSpawnFunctions()
	ResetSpawnFunctions(spawnerProperties) --"lua/Functions_2"
end


function SpawnFunction_1()
	SpawnerFunction("spawnerActive_1", "spawnCounterIndex_1", 7, saveUnit_1, "saveUnit_1", enemyGroupsGroundEasySU_2_2, AiState.ATTACK_AGGRESSIVE)
end


function SpawnFunction_2()
	SpawnerFunction("spawnerActive_2", "spawnCounterIndex_2", 5, saveUnit_2, "saveUnit_2", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end


function SpawnFunction_3()
	SpawnerFunction("spawnerActive_3", "spawnCounterIndex_3", 8, saveUnit_3, "saveUnit_3", enemyGroupsGroundEasySU_2_2, AiState.ATTACK_AGGRESSIVE)
end

function SpawnFunction_4()
	SpawnerFunction("spawnerActive_4", "spawnCounterIndex_4", 20, saveUnit_7, "saveUnit_7", enemyGroupsGroundEasySU_2_2, AiState.ATTACK_AGGRESSIVE)
end