require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

validBomberPos = { { 12, 18 }, { 11, 17 }, { 12, 16 }, { 13, 16 }, { 13, 17 } };

missionContent =
{
	{1,true,Text.T_MAP_SU_2_2_MISSION_PRIMARY_01,300},		--Kill the trucks
	{2,true,Text.T_MAP_SU_2_2_MISSION_PRIMARY_02,200},		--Kill the trucks 2
	{4,false,Text.T_MAP_SU_2_2_MISSION_SECONDARY_01,300},	--prevent next tiger tank

}

function InitiateFunctions()
	SetStartProperties(false,5,23,1500)
	CreateMissions(missionContent)
	--TODO:remove Test units before commit
--	ScriptManager:spawnUnit(0,Units.GOTT,9,2,0,0)
--	ScriptManager:spawnUnit(0,Units.GOTT,10,2,0,0)
	
	--Trigger for Tankfactory cutscene
	ScriptManager:addOnTurnStartTrigger(0,-1,1,"FactoryIntroCutscene","FactoryIntroCutscene",false)
	
	--Trigger for killing convoy
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_CONVOY,-1,"ConvoyDestroyed","ConvoyDestroyed",false)
end



function ConvoyDestroyed()
	ScriptManager:setMissionProgress(1,ScriptManager:getMissionProgress(1)+1)
	ScriptManager:preparePopupText()
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(1))
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_2_MISSION_PRIMARY_01_COUNTER,false)
	if ScriptManager:getMissionProgress(1) == 10 then
		ScriptManager:removeTrigger("ConvoyDestroyed")
		AlmostThereCutscene()
		ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_CONVOY,-1,"ConvoyDestroyed2","ConvoyDestroyed2",false)
	end
end

function ConvoyDestroyed2()
	ScriptManager:setMissionProgress(2,ScriptManager:getMissionProgress(2)+1)
	ScriptManager:preparePopupText()
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(2))
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_2_MISSION_PRIMARY_01_COUNTER_2,false)
	if ScriptManager:getMissionProgress(2) == 5 then
		BomberArriving()
	end
end

introCutsceneParameters = 
{
	{"moveCam",3,26,0.8,5,false}, 									
	{"wait",1},				
	{"showDialogue",Text.T_MAP_SU_2_2_MISSION_PRIMARY_02_FLAVOR,false},																											
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,2,29,0,			AiState.DEFEND,3,27,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,2,29,0,			AiState.DEFEND,2,26,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_KV1,2,29,0,			AiState.DEFEND,2,27,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_SUPPLY_TRUCK,2,29,0,			AiState.DEFEND,3,28,true},
	{"wait","waitForCam"},											
	{"wait","waitForText"},												
	{"moveCam",12,4,0.9,3,true},
	{"showDialogue",Text.T_MAP_SU_2_2_MISSION_PRIMARY_02_FLAVOR_2,false},																											
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,	13,1,0,AiState.DEFEND,12,2,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_MORTAR,	13,1,0,AiState.DEFEND,13,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	13,1,0,AiState.DEFEND,13,2,true},
	{"moveCam",11,3,0.8,7,false}, 						
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_T34,	10,1,0,AiState.DEFEND,11,4,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_T34,	10,1,0,AiState.DEFEND,9,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_TANK_DESTROYER,	10,1,0,AiState.DEFEND,10,3,true},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_RIFLE,	13,1,0,AiState.DEFEND,11,1,true},
	{"wait","waitForCam"},			
	{"wait","waitForText"},		
	{"wait",1},				
}

function IntroCutscene()
	ScriptManager:startCutscene()
	CutsceneFunction(introCutsceneParameters)
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 11, 2 );
	end
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(1)
end


factoryCutsceneParameters =
{
	{"moveCam",12,17,0.9,2,true}, 								
	{"revealFow",12,17,3,true},			
	{"wait",1},				
	{"showMarker",12,17,3},				
	{"moveCam",12,17,1,3,false}, 								
	{"showDialogue",Text.T_MAP_SU_2_2_MISSION_PRIMARY_03_FLAVOR,true},				
	{"wait",1},			
	{"revealFow",12,17,3,false},			
	{"wait","waitForCam"},			
	{"moveCam","unitLastSelected",-1,0.8,2,true}, 	
}


function FactoryIntroCutscene()
	table.insert(cutsceneQueue,_FactoryIntroCutscene)
	CutsceneQueue()
end

function _FactoryIntroCutscene()
	ScriptManager:blockUI(true)
	ScriptManager:startCutscene()
	CutsceneFunction(factoryCutsceneParameters)
	ScriptManager:stopCutscene()
	ScriptManager:blockUI(false)
end

bomberNearlyThereCutscene =
{
	{"moveCam",12,17,0.9,3,true}, 						
	{"revealFow",12,17,3,true},			
	{"wait",1},								
	{"showDialogue",Text.T_MAP_SU_2_2_MISSION_PRIMARY_03_FLAVOR_2,true},				
	{"wait",1},		
	{"revealFow",12,17,3,false},					
	{"moveCam","unitLastSelected",-1,0.8,2,true}, 			
}

function AlmostThereCutscene()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(2)
	ScriptManager:startCutscene()
	CutsceneFunction(bomberNearlyThereCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(1)
	ScriptManager:blockUI(false)
end

bomberCutscene = 
{
	{"moveCam",12,17,0.9,3,true}, 						
	{"revealFow",12,17,3,true},			
	{"wait",0.5},				
	{"showMarker",12,17,3},					
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_02_BOMBER,	13,13,0,AiState.DEFEND,validBomberPos[1][1], validBomberPos[1][2],true,"bomber_1"},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_02_BOMBER,	13,19,0,AiState.DEFEND,validBomberPos[2][1], validBomberPos[2][2],true,"bomber_2"},
	{"spawnAndMove",saveUnit_10,"saveUnit_10",0,Units.UNIT_SU_02_BOMBER,	13,17,0,AiState.DEFEND,validBomberPos[3][1], validBomberPos[3][2],true,"bomber_3"},
	{"wait",2},			
	{"attack","bomber_1",6,true},			
	{"attack",18,"bomber_1",true},			
	{"attack","bomber_2",6,true},			
	{"attack",19,"bomber_2",true},			
	{"attack","bomber_3",6,true},			
	{"moveCam",12,17,0.8,3,true}, 	
}

function BomberArriving()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(2)
	ScriptManager:startCutscene()
	ScriptManager:playSound("sfx_siren_1")
	getValidBomberPos()
	CutsceneFunction(bomberCutscene)
	ScriptManager:stopCutscene()
	if ScriptManager:getMissionStatus(4) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(4,MissionStatus.ACCOMPLISHED)
	end
	ScriptManager:wait(2)
	OutroCutscene()	
end

function getValidBomberPos()
	local posCounter = 0;
	
	-- go through all valid attack positions, remove tose where a unit already stands. after three valid positions continue
	for i = 1, #validBomberPos do
		if Unit:getUnitAt( validBomberPos[i][1], validBomberPos[i][2] ) ~= nil then
			table.remove( validBomberPos, i );
		
		else
			posCounter = posCounter + 1;
			if posCounter >= 3 then
				break;
			end
		end
	end
	
end

outroCutscene = 
{
	{"moveCam",7,17,0.8,10,false}, 									
	{"showDialogue",Text.T_MAP_SU_2_2_MISSION_OUTRO,true},				
}

function OutroCutscene()
	ScriptManager:startCutscene()
	CutsceneFunction(outroCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:wait(2)
	ScriptManager:displaySubtitleAutoEx(Text.T_MISSION_VICTORY,true)
	ScriptManager:wait(1)
	ScriptManager:endGame()
end