require "lua/MAP_SU_3_3_MISSION"
require "lua/MAP_SU_3_3_TIGER"
require "lua/MAP_SU_3_3_KV1"
require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

onStartTriggers = {1,1,1,1,1,1,1,} --trigger spawn after x turns Factory_1,2,3,Camp_1,2,Airport_1,2

startUnitId = {22, 21, 18, 20, 19}

function onGameStart()
	for i = 1, #startUnitId do
		local unit = Unit:getUnitById(startUnitId[i])
		unit:setHealth(50)
	end
	SetStartProperties(false,2,7,1500)
	InitiateFunctions()
	InitiateFunctions_2() -- Functions_2
	IntitateUnitFunctions() --Enemies
	TigerSpawnAndPatrol()
	MissionSpawnKv1()
	cutsceneTigerIsRunning = 0 -- global variable to check if another cutscene is running (prevents script conflict)
	
	--Factroy 2 Trigger
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,1,"ActivateFactory_2","ActivateFactory_2",false)
	for i = 1, 15 do
		ScriptManager:addOnEnterTileTrigger(19,i,0,-1,-1,false,"ActivateFactory_2","ActivateFactory_2",false)
	end

	--Factory 3 Trigger
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,4,"ActivateFactory_3","ActivateFactory_3",false)
	for i = 1, 15 do
		ScriptManager:addOnEnterTileTrigger(27,i,0,-1,-1,false,"ActivateFactory_3","ActivateFactory_3",false)
	end

	--Back depots
	for i = 1, 15 do
		ScriptManager:addOnEnterTileTrigger(19,i,0,-1,-1,false,"ActivateDepots","ActivateDepots",false)
	end
	
	--Respawn enemies
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"_ResetSpawnFunctions","_ResetSpawnFunctions",false)
	
	--Spawn Defender Enemies
	SpawnEnemyUnits()
	ScriptManager:sleep(0,"IntroCutscene")
end

--spawn Initial defending enemy units
function SpawnEnemyUnits()
	--Spawn defender of the depots
	SpawnEnemyReinforcements(13,saveUnit_9,"saveUnit_9",enemyGroupsGroundMedium,AiState.DEFEND)
	SpawnEnemyReinforcements(3,saveUnit_10,"saveUnit_10",enemyGroupsGroundMedium,AiState.DEFEND)
	SpawnEnemyReinforcements(14,saveUnit_11,"saveUnit_11",enemyGroupsGroundHard,AiState.DEFEND)
	SpawnEnemyReinforcements(6,saveUnit_12,"saveUnit_12",enemyGroupsGroundMedium,AiState.DEFEND)
	SpawnEnemyReinforcements(24,saveUnit_13,"saveUnit_13",enemyGroupsGroundMedium,AiState.DEFEND)
	
	SpawnEnemyReinforcements(1,saveUnit_14,"saveUnit_14",enemyGroupsGroundHard,AiState.DEFEND)
	SpawnEnemyReinforcements(4,saveUnit_15,"saveUnit_15",enemyGroupsGroundHard,AiState.DEFEND)
	SpawnEnemyReinforcements(2,saveUnit_16,"saveUnit_16",enemyGroupsGroundHard,AiState.DEFEND)	
end

function ActivateFactory_2()
	ScriptManager:removeTrigger("ActivateFactory_2")
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_7","SpawnFunction_7",false)
end

function ActivateFactory_3()
	ScriptManager:removeTrigger("ActivateFactory_3")
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_8","SpawnFunction_8",false)
end

function ActivateDepots()
	ScriptManager:removeTrigger("ActivateDepots")
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_4","SpawnFunction_4",false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_5","SpawnFunction_5",false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2,"SpawnFunction_9","SpawnFunction_9",false)
end

spawnerProperties = --{depotId, randomMinTimer, randomMaxTimer, spawnCount}
{
	{13,1,3,7}, -- de depot 1
	{3,1,3,7}, -- de depot 2
	{14,1,3,7}, -- de depot 3
	{6,1,3,7}, -- de depot 4
	{24,1,3,7}, -- de depot 5
	{1,2,4,5}, -- Tankfactory 1
	{4,2,4,5}, -- Tankfactory 2
	{2,2,4,5}, -- Tankfactory 3
	{15,2,4,5}, -- Airport
}


--check spawners & add respawn counters
function _ResetSpawnFunctions()
	ResetSpawnFunctions(spawnerProperties) --"lua/Functions_2"
end


function SpawnFunction_1()
	SpawnerFunction("spawnerActive_1", "spawnCounterIndex_1", 13, saveUnit_1, "saveUnit_1", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_2()
	SpawnerFunction("spawnerActive_2", "spawnCounterIndex_2", 3, saveUnit_2, "saveUnit_2", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_3()
	SpawnerFunction("spawnerActive_3", "spawnCounterIndex_3", 14, saveUnit_3, "saveUnit_3", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_4()
	SpawnerFunction("spawnerActive_4", "spawnCounterIndex_4", 6, saveUnit_4, "saveUnit_4", enemyGroupsGroundMedium, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_5()
	SpawnerFunction("spawnerActive_5", "spawnCounterIndex_5", 24, saveUnit_5, "saveUnit_5", enemyGroupsGroundHard, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_9()
	SpawnerFunction("spawnerActive_9", "spawnCounterIndex_9", 15, saveUnit_19, "saveUnit_19", enemyGroupsPlanes, AiState.AIRPLANE)
end

--Tankfactories
function SpawnFunction_6()	--first factory
	SpawnerFunction("spawnerActive_6", "spawnCounterIndex_6", 1, saveUnit_6, "saveUnit_6", enemyGroupsTanfactory_2_3, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_7()	--middle factory
	SpawnerFunction("spawnerActive_7", "spawnCounterIndex_7", 4, saveUnit_7, "saveUnit_7", enemyGroupsTanfactory_2_3, AiState.ATTACK_AGGRESSIVE)
end
function SpawnFunction_8() --last factory
	SpawnerFunction("spawnerActive_8", "spawnCounterIndex_8", 2, saveUnit_8, "saveUnit_8", enemyGroupsTanfactory_2_3, AiState.ATTACK_AGGRESSIVE)
end
