require "lua/Constants"
require "lua/UnitFunctions"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"


missionContent =
{
	{1,true,Text.T_MAP_SU_2_3_MISSION_PRIMARY_01,50},	--Capture the soviet outpostback
	{2,true,Text.T_MAP_SU_2_3_MISSION_PRIMARY_01_1,100},	--defend the ourpost
	{3,true,Text.T_MAP_SU_2_3_MISSION_PRIMARY_02,250},	--Destroy "Stahlwerk"
	{4,true,Text.T_MAP_SU_2_3_MISSION_PRIMARY_03,250},	--Destroy "Stahlschmiede"
	{5,true,Text.T_MAP_SU_2_3_MISSION_PRIMARY_04,250},	--Destroy "stahltiegel"
	{6,true,"",500},	--Destroy the 3 factories
	{7,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_01,50},	--Find a Kv1
	{8,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_02,100},	--repair the kv1
	{9,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_03,200},	--repair more kv1
	{10,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_04,100},	--destroy the maus
	{11,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_05,100},	--repair the maus
	{12,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_06,150},	--destroy the airfield
	{13,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_07,50},	--capture another depot
	{14,false,Text.T_MAP_SU_2_3_MISSION_SECONDARY_08,350},	--destroy all bunkers
}

function InitiateFunctions()
	CreateMissions(missionContent)
--	ScriptManager:spawnUnit(0,Units.GOTT,6,4,0,0)
--	ScriptManager:spawnUnit(0,Units.GOTT,5,3,0,0)
--	for i = 1, 5 do
--		ScriptManager:spawnUnit(0,Units.UNIT_SU_SUPPLY_TRUCK,26,12,0,0)
--	end
--		ScriptManager:spawnUnit(0,Units.UNIT_SU_TANK_KV1,26,12,0,0)

	--start airfield mission
	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_DE_FIGHTER,-1,"MissionAirbase","MissionAirbase",false)
	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_DE_BOMBER,-1,"MissionAirbase","MissionAirbase",false)
	
	--mission triggers
	
	--start depot mission
	ScriptManager:addOnUnitSightedTrigger(-1,Units.UNIT_DE_HQ,-1,true,"MissionStartCapture","MissionStartCapture",false)
	
	--capture another depot finished
	ScriptManager:addOnUnitCapturedTrigger(-1,Units.UNIT_DE_HQ,-1,"MissionDepotCapturedAccomplished","MissionDepotCapturedAccomplished",false)
	
	--capture airfield
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_AIRFIELD,-1,"MissionAirfieldAccomplished","MissionAirfieldAccomplished",false)
	ScriptManager:addOnUnitCapturedTrigger(-1,Units.UNIT_DE_AIRFIELD,-1,"MissionAirfieldAccomplished","MissionAirfieldAccomplished",false)
	
	--tank factories
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,1,"MissionFactoryDestroyed","MissionFactoryDestroyed",false) 	--Stahlschmiede
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,2,"MissionFactoryDestroyed","MissionFactoryDestroyed",false) 	--Stahlschmiede
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,4,"MissionFactoryDestroyed","MissionFactoryDestroyed",false) 	--Stahlschmiede
	
	--Super Bunker mission
	ScriptManager:addOnUnitSightedTrigger(1,Units.UNIT_SU_BUNKER,-1,false,"MissionStartEliteBunker","MissionStartEliteBunker",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_BUNKER,-1,"MissionBunkerDestroyed","MissionBunkerDestroyed",false)
	
	--Capture the su depot back
	ScriptManager:addOnUnitCapturedTrigger(0,Units.UNIT_SU_HQ,-1,"MissionStartIntro","MissionStartIntro",false)

	ScriptManager:addOnUnitDestroyedTrigger(0,Units.UNIT_SU_HQ,-1,"MissionFailed","MissionFailed",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_HQ,-1,"MissionFailed","MissionFailed",false)
end

function spawntruck(unit)
	ScriptManager:spawnUnit(0,Units.UNIT_SU_SUPPLY_TRUCK,unit:getX(),unit:getY(),0,0)
end

function MissionStartCapture()
	ScriptManager:removeTrigger("MissionStartCapture")
	ScriptManager:setMissionStatus(13,MissionStatus.IN_PROGRESS)
end

function MissionDepotCapturedAccomplished()
	ScriptManager:removeTrigger("MissionDepotCapturedAccomplished")
	ScriptManager:setMissionStatus(13,MissionStatus.ACCOMPLISHED)
end

function MissionAirfieldAccomplished()
	ScriptManager:removeTrigger("MissionAirfieldAccomplished")
	ScriptManager:setMissionStatus(12,MissionStatus.ACCOMPLISHED)
end

function MissionFactoryDestroyed(unit)
	print("Factory Destroyed!")
	local unitId = unit:getId()
	if unitId == 4 then
		ScriptManager:setMissionStatus(3,MissionStatus.ACCOMPLISHED)
		ScriptManager:setMissionProgress(6,ScriptManager:getMissionProgress(6)+1)
	elseif unitId == 1 then
		ScriptManager:setMissionStatus(4,MissionStatus.ACCOMPLISHED)
		ScriptManager:setMissionProgress(6,ScriptManager:getMissionProgress(6)+1)
	elseif unitId == 2 then
		ScriptManager:setMissionStatus(5,MissionStatus.ACCOMPLISHED)
		ScriptManager:setMissionProgress(6,ScriptManager:getMissionProgress(6)+1)
	end
	if ScriptManager:getMissionProgress(6) == 3 then
		ScriptManager:blockUI(true)
		ScriptManager:wait(2)
		if ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS then
			ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
		end
		MissionOutro()
	end
end

introPlayerUnitId = {20,18,19,22,21,23}

function IntroCutscene()
	print("start cutscene")
	--CutsceneFunction(introCutscene)
	for i = 1, #introPlayerUnitId do
		local unitId = introPlayerUnitId[i]
		Unit:getUnitById(unitId):setHealth(50)
	end
end

missionBriefing = 
{
	{"moveCam",13,14,0.9,6,false}, 								
	{"wait",1},				
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FLAVOR_02,true},				
	{"wait",1},				
	{"revealFow",13,14,2,true},			
	{"wait",1},				
	{"showMarker",13,14,2},				
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FACTORY_02,true},				
	{"wait",1},			
	{"revealFow",13,14,2,false},			
	{"moveCam",21,6,0.9,6,true}, 								
	{"revealFow",21,6,2,true},			
	{"wait",1},				
	{"showMarker",21,6,2},				
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FACTORY_01,true},				
	{"wait",1},			
	{"revealFow",21,6,2,false},			
	{"moveCam",30,9,0.9,6,false}, 		
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FLAVOR_03,true},				
	{"revealFow",30,9,2,true},			
	{"wait",1},				
	{"showMarker",30,9,2},				
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FACTORY_03,true},				
	{"wait",1},			
	{"revealFow",30,9,2,false},					
	{"moveCam","unitLastSelected",-1,0.8,7,false}, 
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_05_FLAVOR,true},				
	{"wait","waitForCam"},			
}

function MissionStartIntro()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(2)
	ScriptManager:startCutscene()
	CutsceneFunction(missionBriefing)
	ScriptManager:stopCutscene()
	ScriptManager:continueAfterCutscene("_MissionStartIntro")
end

function _MissionStartIntro()
	ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionStatus(5,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(4)
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
	if ScriptManager:getMissionStatus(7) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:setMissionStatus(7,MissionStatus.IN_PROGRESS)
	end
	ScriptManager:blockUI(false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_1","SpawnFunction_1",false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnFunction_2","SpawnFunction_2",false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2,"SpawnFunction_3","SpawnFunction_3",false)
	ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2,"SpawnFunction_6","SpawnFunction_6",false)
end

introCutscene = 

{	
	{"moveCam",3,9,0.8,8,false},			 						
	{"wait",0.5},				
	{"wait",2},												
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_TANK_3,7,10,0,AiState.DEFEND,4,11,true,"attacker_2"},
	{"attack","attacker_2",18,true},
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_01_FLAVOR,false},				
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_TANK_4,7,10,0,AiState.DEFEND,3,11,true,"attacker_1"},
	{"attack","attacker_1",21,true},
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_PANZERFAUST,7,10,0,AiState.DEFEND,5,9,true,"attacker_3"},
	{"attack","attacker_3",20,true},
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_TANK_3,7,10,0,AiState.DEFEND,5,10,true,"attacker_4"},
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_TANK_4,7,10,0,AiState.DEFEND,4,7,true,"attacker_5"},
	{"attack","attacker_4",19,true},
	{"attack","attacker_5",22,true},
	{"spawnAndMove",saveUnit_18,"saveUnit_18",1,Units.UNIT_DE_MP40,7,10,0,AiState.DEFEND,5,8,true,"capturer"},
	{"capture","capturer",10},
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_PRIMARY_01_FLAVOR_1,false},				
	{"wait",1},				
	{"moveCam",3,2,1,6,false},
	{"wait",3},				
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_TANK_T34,1,1,0,AiState.DEFEND,2,3,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_TANK_T34,1,1,0,AiState.DEFEND,3,2,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_MORTAR,1,1,0,AiState.DEFEND,3,1,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_MORTAR,1,1,0,AiState.DEFEND,2,1,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_SUPPLY_TRUCK,1,1,0,AiState.DEFEND,2,2,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_TANK_DESTROYER,1,1,0,AiState.DEFEND},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_TANK_KV1,1,1,0,AiState.DEFEND,4,2,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_RIFLE,4,1,0,AiState.DEFEND,3,3,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_RIFLE,4,1,0,AiState.DEFEND,4,3,true},
	{"spawnAndMove",saveUnit_17,"saveUnit_17",0,Units.UNIT_SU_RIFLE,4,1,0,AiState.DEFEND,5,2,true},
}

function IntroCutscene()
	ScriptManager:startCutscene()
	CutsceneFunction(introCutscene)
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 3, 2 );
	end
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
end

airbaseCutscene = 
{
	{"moveCam",30,2,0.9,3,true},			 						
	{"revealFow",30,2,2,true},			
	{"wait",1},		
	{"showMarker",3,4,3},					
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_SECONDARY_06_FLAVOR,true},	
	{"wait",0.5},				
	{"revealFow",30,2,2,false},			
	{"moveCam","unitLastSelected",-1,0.8,3,false}, 
}

function MissionAirbase()
	ScriptManager:runForPlayer(0,"_MissionAirbase")
	ScriptManager:removeTrigger("MissionAirbase")
end

function _MissionAirbase()
	table.insert(cutsceneQueue,__MissionAirbase)
	CutsceneQueue()
end

function __MissionAirbase()
	ScriptManager:startCutscene()
	CutsceneFunction(airbaseCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(12,MissionStatus.IN_PROGRESS)
end

--Bunker cutscene
bunkerCutscene = 
{
	{"moveCam","bunker",-1,0.9,1,true},
	{"revealFow","bunker",-1,2,true},			
	{"wait",1},		
	{"showMarker","bunker",-1,3},					
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_SECONDARY_08_FLAVOR,true},	
	{"wait",0.5},
	{"revealFow","bunker",-1,2,false},			
	{"moveCam","unitLastSelected",-1,0.8,2,false}, 		
}

function MissionStartEliteBunker(activeUnit, passiveUnit)
	ScriptManager:removeTrigger("MissionStartEliteBunker")
	if activeUnit:getTemplateId() == Units.UNIT_SU_BUNKER then
		ScriptManager:storeValue("bunker",activeUnit:getId())
	elseif passiveUnit:getTemplateId() == Units.UNIT_SU_BUNKER then
		ScriptManager:storeValue("bunker",passiveUnit:getId())
	end
	table.insert(cutsceneQueue,_MissionStartEliteBunker)
	CutsceneQueue()
end

function _MissionStartEliteBunker()
	ScriptManager:startCutscene()
	CutsceneFunction(bunkerCutscene)
	ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(14,MissionStatus.IN_PROGRESS)
end

function MissionBunkerDestroyed()
ScriptManager:setMissionProgress(14,ScriptManager:getMissionProgress(14)+1)
	if ScriptManager:getMissionProgress(14) <= 7 then
		ScriptManager:preparePopupText()
		ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(14))
		ScriptManager:displaySubtitleAutoEx(Text.T_MAP_SU_2_3_MISSION_SECONDARY_08_COUNTER,false)
		ScriptManager:wait(1.5)
	end
	if ScriptManager:getMissionProgress(14) == 7 then
		ScriptManager:setMissionStatus(14,MissionStatus.ACCOMPLISHED)
	end
end

outroCutscene =
{
	{"moveCam",21,8,0.9,15,false},
	{"wait",2},		
	{"showDialogue",Text.T_MAP_SU_2_3_MISSION_OUTRO,true},	
	{"wait",1},
}

function MissionFailed()
	table.insert(cutsceneQueue,_MissionFailed)
	CutsceneQueue()
end

function _MissionFailed()
	ScriptManager:blockUI(true)
	if ScriptManager:getMissionStatus(1) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:setMissionStatus(1,MissionStatus.FAILED)
	end
	ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
	ScriptManager:displaySubtitleAutoEx(Text.T_MAP_3_2_MISSION_FAILED,true)
	ScriptManager:wait(1)
	ScriptManager:endGame()
	ScriptManager:wait(3)
end

function MissionOutro()
	ScriptManager:startCutscene()
	CutsceneFunction(outroCutscene)
	ScriptManager:stopCutscene()	
	ScriptManager:wait(2)
	ScriptManager:displaySubtitleAutoEx(Text.T_MISSION_VICTORY,true)
	ScriptManager:wait(1)
	ScriptManager:endGame()
end
