require "lua/Functions"
require "math"


MissionStatus = {
	NOT_STARTED = 0,
	IN_PROGRESS = 1,
	FAILED = 2,
	ACCOMPLISHED = 3,
}
 
Text = {
	T_MISSION_MAP_10_MAIN = "T_MISSION_MAP_10_MAIN"
}

Missions = {
	MISSION_1 = 1,
}

Units = {
	UNIT_TIGER = 4,
}

unitCount = 0;


function onGameStart()
	print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:createMission(Missions.MISSION_1, true, Text.T_MISSION_MAP_10_MAIN);
	ScriptManager:setMissionStatus(Missions.MISSION_1, MissionStatus.IN_PROGRESS);
	ScriptManager:setMissionProgress(Missions.MISSION_1, unitCount);
	
	ScriptManager:addOnEnterTileTrigger(5, 9, 0, -1, -1, false, "onEnteredCrossRoad");
	return 1
end

function onEnteredCrossRoad(tileX, tileY, playerId, unitTemplateId, unitId)
	ScriptManager:gainGold(0, 500);
	return 1
end

function onFirstTurnStart(playerId, turnId, roundId)
	print(string.format("[SCRIPT] onFirstTurnStart(%i, %i, %i)...", playerId, turnId, roundId));
	--ScriptManager:displayPopup(Text.T_MISSION_MAP_10_MAIN, "onPopupAccept", "onPopupCancel");
	ScriptManager:moveCamera(10, 10, 0.7, 2.0, "onRevealCameraFinished");
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_10_MAIN);
	return 1
end

function onRevealCameraFinished()
	ScriptManager:revealFogOfWar(10, 10, 2, true);
	ScriptManager:sleep(3, "onRevealSleepFinished");
	return 1
end

function onRevealSleepFinished()
	ScriptManager:dismissSubtitle();
	ScriptManager:revealFogOfWar(10, 10, 2, false);
end

function onPopupAccept()
	ScriptManager:gainGold(0, 1000);
	return 1
end

function onPopupCancel()
	ScriptManager:gainGold(0, 100);
	return 1
end

function onInfantryDestroyed(unit)
	local progress = ScriptManager:getMissionProgress(Missions.MISSION_1);
	print(string.format("[SCRIPT] onInfantryDestroyed() - progress: %i...", progress));
	unitCount = progress + 1;
	ScriptManager:setMissionProgress(Missions.MISSION_1, unitCount);
	if unitCount == 2 then
		ScriptManager:setMissionStatus(Missions.MISSION_1, MissionStatus.ACCOMPLISHED);
		ScriptManager:moveCamera(5, 9, 0.8, 2.0, "onGetTigerCameraFinished");
	end
	return 1
end

function onGetTigerCameraFinished()
	ScriptManager:spawnUnits(0, Units.UNIT_TIGER, 5, 9, 0, 0, 1);
	return 1
end
