require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

--ONGAMESTART TRIGGER

function onGameStart()

	ScriptManager:preparePopupText()
	--print(string.format("[SCRIPT] onGameStart()..."));
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_TANK_T34,-1,"onTargetAttacked","onTargetAttacked")
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_SU_TANK_T34,-1,"beforeTankmission","beforeTankmission")
	
	ScriptManager:moveCamera(3,7,0.8,0,"")					--Set Camera Start position

	ScriptManager:moveUnit(29 ,9 ,5 , "")
	ScriptManager:moveUnit(2 ,9 ,7 , "")					--Adjusted unit position
	--ScriptManager:blockUI(true)
	ScriptManager:disableEndTurnButton()
	ScriptManager:sleep(1,"showMission1Dialogue")
	
	ScriptManager:createMission(2, true, Text.T_MISSION_MAP_1_1_INTRO_MISSION_MAIN_2);
	ScriptManager:setMissionXp(2,125)
	ScriptManager:createMission(3, false, Text.T_MISSION_MAP_1_1_INTRO_MISSION_SECONDARY);
	ScriptManager:setMissionXp(3,25)
	ScriptManager:createMission(1, true, Text.T_MISSION_MAP_1_1_INTRO_MISSION_MAIN);
	ScriptManager:setMissionXp(1,25)
	ScriptManager:gainGold(0,500)
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
		
	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"checkForEnd","checkForEnd")
	
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"CheckForGameEnd")
	
	ScriptManager:sleep(0,"StartIntro")
		
	return 1
end


--Game End Check
function CheckForGameEnd()
	MainGoalAccomplished(2,outroText,MissionFailed)		--Main Mission ID, Script to start if Accomplished, Script to start if Failed
end

function checkForEnd()
	if ScriptManager:noUnitsLeft(0) or Unit:getUnitById(1) == nil then
		ScriptManager:runForPlayer(0, "endGameWait")
	end
end

function endGameWait()
	ScriptManager:continueAfterCutscene("MissionFailed")
end

--END GAMESTART TRIGGER



--Hide Dialogues

function HideDialogue()												
	ScriptManager:dismissSubtitle()
end

function enableEndTurn()
	ScriptManager:enableEndTurnButton()
end
--END



--Intro camera movement

function StartIntro()															
	ScriptManager:startCutscene();																				--Start intro cutscene	
	IntroMoveCam()																								--Camera movement
	MovePlayerTank_1()	
				--Start spawning player units
end

function IntroMoveCam()
	ScriptManager:moveCamera(3,10,0.8,4,"sleepPlayerBase")
	
	
end

function sleepPlayerBase()
	ScriptManager:sleep(0.5,"endCutscene")
	--ScriptManager:sleep(1,"waitForMission")
	
end

function endCutscene()		
																					--End cutscene and create mission 1 + triggers
	ScriptManager:stopCutscene()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 4, 10 );
	end
	ScriptManager:continueAfterCutscene("StopCutsceneStartMissions")
	

	--TODO:SCREENSHOT
--ScriptManager:spawnUnit(0,30,1,11,0,0)		--TODO: GODS!
--ScriptManager:spawnUnit(0,30,1,11,0,0)
--	ScriptManager:moveCamera(0,0,0.77,0,"")
end

--END CAMERA MOVEMENT

function StopCutsceneStartMissions()
	ScriptManager:blockUI(true)
	--ScriptManager:disableEndTurnButton()
	ScriptManager:sleep(3,"endblock")
	ScriptManager:setMissionStatus(1, MissionStatus.IN_PROGRESS);		-- start mission
end

function endblock()	
	ScriptManager:blockUI(false)
	ScriptManager:enableEndTurnButton()
	waitForMission()
end

-- Intro: Move player Tanks

function MovePlayerTank_1()
		
		local unit = ScriptManager:spawnUnit(
		0 ,2 , 	--PLAYER, UNIT
		4, 10 ,	--X, Y
		30, 5); --SQUADID, STATE
		MovePlayerTank_2()
		MovePlayerTank_3()
end

function MovePlayerTank_2()
		local unit = ScriptManager:spawnUnit(
		0 ,2 , 	--PLAYER, UNIT
		3, 9 ,	--X, Y
		30, 5); --SQUADID, STATE
end

function MovePlayerTank_3()
		local unit = ScriptManager:spawnUnit(
		0 ,3 , 	--PLAYER, UNIT
		2, 13 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),3 ,11 , "MovePlayerTank_4")
end

function MovePlayerTank_4()
		local unit = ScriptManager:spawnUnit(
		0 ,3 , 	--PLAYER, UNIT
		1, 8 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),3 ,10 , "MovePlayerTank_5")
		
end

function MovePlayerTank_5()					
		local unit = ScriptManager:spawnUnit(
		0 ,3 , 	--PLAYER, UNIT
		1, 8 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),2 ,9 , "")
		
end

function showMission1Dialogue()
	ScriptManager:removeTrigger("showMission1Dialogue");
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_1_1_INTRO_DIALOGUE_01,"")
end

--Trigger for finding the supply depot mission

function waitForMission()
	for y = 0, 14 do
		ScriptManager:addOnEnterTileTrigger(14,y,0,-1,-1,true,"unitEnterTile","unitEnterTile")						--Create 14* Unit enter tile trigger on x6 line up 
	end
end


--Mission main 1 accomplished

function unitEnterTile(x, y, playerId, templateID, unitID)														--remove 14* main mission 1 triggers
	for i = 0, 14 do
		ScriptManager:removeTrigger("unitEnterTile")
	end
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)												--set main mission 1 to accomplished
	ScriptManager:sleep(1,"mainMissionCutscene")
	local enterTileUnitId = unitID
	ScriptManager:storeValue("enterTileUnitId",enterTileUnitId)
end


-- CUTSCENE: MAIN MISSION 2 - SHOW SUPPLY DEPOT

function mainMissionCutscene()																--Start cutscene
	ScriptManager:startCutscene()		
	ScriptManager:moveCamera(18,4,0.9,2,"RevealFowDepot")
end

function RevealFowDepot()
	ScriptManager:spawnUnit(1,Units.UNIT_SU_HQ,18,4,4,2)
	ScriptManager:revealFogOfWar(18,4,2,true);
	ScriptManager:showMarkerAt(18,4)													--Reveal fog, show marker, create subtitle, move units
	ScriptManager:sleep(1,"MoveTank_1")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_1_INTRO_DIALOGUE_03)
end

function MoveTank_1()
	local unit = ScriptManager:spawnUnit(1, Units.UNIT_SU_TANK_T34, 19, 2, 4, AiState.DEFEND);
	ScriptManager:moveUnit(unit:getId(), 17, 3, "MoveTank_2")
end

function MoveTank_2()
	local unit = ScriptManager:spawnUnit(1, Units.UNIT_SU_TANK_T34, 18, 7, 4, AiState.DEFEND);
	ScriptManager:moveUnit(unit:getId(), 18, 5, "MoveTank_3")
end

function MoveTank_3()
	local unit = ScriptManager:spawnUnit(1, Units.UNIT_SU_MORTAR, 16, 6, 4, AiState.DEFEND);
	ScriptManager:moveUnit(unit:getId(), 17, 5, "wait_1")
end

function wait_1()
	ScriptManager:hideMarkerAt(18,4)
	ScriptManager:sleep(1,"HideMainMission")
end

function HideMainMission()
	HideDialogue()
	ScriptManager:revealFogOfWar(18,4,2,false);
	ScriptManager:sleep(1,"MoveCam_1" ) 																
end

function MoveCam_1()		
	local enterTileUnitId = ScriptManager:getValue("enterTileUnitId")																				--Move cam to last unit
	ScriptManager:moveCamera(Unit:getUnitById(enterTileUnitId):getX(),
	Unit:getUnitById(enterTileUnitId):getY(),0.9,3,"EndMainCutscene")												--Move Camera to last unit
end

function EndMainCutscene()
	ScriptManager:stopCutscene()
	ScriptManager:continueAfterCutscene("createMainMission2_end")
end

function createMainMission2_end()
	--ScriptManager:enableEndTurnButton()
	ScriptManager:blockUI(false)
	ScriptManager:sleep(1,"createMainMission2")
end


--CREAT MAIN MISSION 2 - 

function createMainMission2()
	ScriptManager:setMissionStatus(2, MissionStatus.IN_PROGRESS);
	ScriptManager:addOnUnitDestroyedTrigger(1, Units.UNIT_SU_HQ, -1, "DepotDestroyed", "DepotDestroyed");
	ScriptManager:addOnUnitCapturedTrigger(0, Units.UNIT_SU_HQ, -1, "onHqDestroyedOrCaptured", "onHqDestroyedOrCaptured");
	ScriptManager:sleep(2,"mainMission2")
	ScriptManager:blockUI(false)
	ScriptManager:disableEndTurnButton()
end

function mainMission2()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_1_INTRO_DIALOGUE_02)
	ScriptManager:sleep(5,"HideDialogue")
	ScriptManager:sleep(5,"enableEndTurn")
end

--Mission Progression tracking & Game end controller

function onHqDestroyedOrCaptured(unit)												-- Main mission trigger
	ScriptManager:removeTrigger("onHqDestroyedOrCaptured");
	ScriptManager:disableEndTurnButton()
	
	ScriptManager:setMissionStatus(2, MissionStatus.ACCOMPLISHED);
	ScriptManager:sleep(2,"outroText")
end

--Create Secondary Mission

function onTargetAttacked(attacker, defender)		
	targetID = -1
	if attacker:getTemplateId() == Units.UNIT_SU_TANK_T34 then				
		targetID = attacker:getId()
	end
	if defender:getTemplateId() == Units.UNIT_SU_TANK_T34 then
		targetID = defender:getId()
	end
	ScriptManager:removeTrigger("onTargetAttacked")
	ScriptManager:runForPlayer(0, "MoveCamToTarget")
end

function MoveCamToTarget()
	ScriptManager:blockUI(true);
	ScriptManager:enableSkipCutsceneButton()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,2,"CamOnTarget")
end

function CamOnTarget()
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,true)
	ScriptManager:showMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_1_INTRO_DIALOGUE_04)
	ScriptManager:sleep(5,"HideDialogue")
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,3,"ZoomCamOutAndEndScript")
end

function ZoomCamOutAndEndScript()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.8,2,"EndMetaCutScene")
	ScriptManager:hideMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,false)
end

function EndMetaCutScene()
	ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	ScriptManager:disableSkipCutsceneButton()
	ScriptManager:blockUI(false);
end

--END


function secondaryDialogue()
		ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_1_INTRO_DIALOGUE_04)
		ScriptManager:sleep(5,"HideDialogue")
end

function tankDestroyed()																--Tank destroyed! x/5
	HideDialogue()
	ScriptManager:preparePopupText();
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(3))
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_1_SECONDARY_MISSION_SUBTITLE)
	ScriptManager:sleep(3,"HideDialogue")
end

function beforeTankmission()

	ScriptManager:runForPlayer(0, "onTankDestroyed")
	

end

function onTankDestroyed(unit)																--Kill tank counter, secondary mission progress
	if ScriptManager:getMissionStatus(3) ~= MissionStatus.IN_PROGRESS and
	ScriptManager:getMissionStatus(3) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:removeTrigger("onTargetAttacked")
		--ScriptManager:removeTrigger("beforeTankmission");
		ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	end
		if 	ScriptManager:getMissionProgress(3) < 5 then
			ScriptManager:setMissionProgress(3, ScriptManager:getMissionProgress(3) + 1);
		end
		
	if ScriptManager:getMissionProgress(3) == 5 then
		ScriptManager:setMissionStatus(3, MissionStatus.ACCOMPLISHED);
		ScriptManager:removeTrigger("beforeTankmission");
		ScriptManager:removeTrigger("onTankDestroyed");
		return
	end
	tankDestroyed()
end

--END MISSIONS

function DepotDestroyed()
	if ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS or ScriptManager:getMissionStatus(2) ~= MissionStatus.NOT_STARTED then
		ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
		MissionFailed()
		ScriptManager:disableEndTurnButton()
		ScriptManager:blockUI(true)
		
	end
end

function MissionFailed()
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitle(Text.T_MAP_3_2_MISSION_FAILED)
	ScriptManager:sleep(3,"HideDialogue")
	ScriptManager:sleep(5,"EndGame")
end

--END GAME

function onMissionAccomplished()					
								--Outro
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_VICTORY,"")
	ScriptManager:sleep(3,"HideDialogue")
	ScriptManager:sleep(4,"EndGame")
end

function outroText()
	ScriptManager:preparePopupText()
	ScriptManager:blockUI(true)
	ScriptManager:disableEndTurnButton()	
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_1_1_INTRO_OUTRO,"onMissionAccomplished")							
	--ScriptManager:sleep(7.5,"HideDialogue")
end

function EndGame()
	ScriptManager:endGame()
end