require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

--GAMESTART

function onGameStart()
	--print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:preparePopupText()
	ScriptManager:sleep(0.0, "StartIntro");
	ScriptManager:createMission(5,false, Text.T_MISSION_MAP_1_2_INTRO_MISSION_SECONDARY)				
	ScriptManager:createMission(1, true, Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_1);
	ScriptManager:createMission(2, true, Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_2);
	ScriptManager:createMission(3, true, Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_3);
	ScriptManager:createMission(4, true, "");
	ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionXp(1,10)
	ScriptManager:setMissionXp(2,40)
	ScriptManager:setMissionXp(3,100)
	ScriptManager:setMissionXp(5,100)
	ScriptManager:gainGold(0,1000)
	
	--ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	
	--Trigger to start mission Depot 2
	
	ScriptManager:addOnEnterTileTrigger(5,12,0,-1,-1,true,"Depot1trigger","Depot1trigger")
	ScriptManager:addOnEnterTileTrigger(6,11,0,-1,-1,true,"Depot1trigger","Depot1trigger")
	ScriptManager:addOnEnterTileTrigger(4,14,0,-1,-1,true,"Depot1trigger","Depot1trigger")
	
	ScriptManager:addOnUnitCapturedTrigger(0,-1,4,"Depot1trigger2","Depot1trigger2")
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,4,"DepotDestroyedwait","DepotDestroyed")
	
	--Trigger to start mission Depot 3

	ScriptManager:addOnUnitCapturedTrigger(0,-1,1,"Depot2trigger2","Depot2trigger2")
	ScriptManager:addOnUnitDestroyedTrigger(1,-1,1,"DepotDestroyedwait","DepotDestroyed")
	for x2 = 0, 7 do
		ScriptManager:addOnEnterTileTrigger(11+x2,12,0,-1,-1,true,"Depot2trigger","Depot2trigger")
	end
	
	ScriptManager:addOnUnitCapturedTrigger(0,-1,22,"onDepot3DestroyedOrCaptured","onDepot3DestroyedOrCaptured")
	
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_HQ,-1,"DepotDestroyedwait","DepotDestroyed")
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_SU_HQ,-1,"DepotDestroyedwait","DepotDestroyed")
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	
	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"checkForEnd","checkForEnd")
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"CheckForGameEnd")
		
	return 1

end

function DepotDestroyedwait()
	ScriptManager:runForPlayer(0,"DepotDestroyed")
end

--Warning that the depot should not be destroyed
function DontAttackDepotWarning()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_2_WARNING)
	ScriptManager:sleep(3,"HideDialogue")
end
-- Checks if the player has no more units or his depot is destroyed => mission failed
function checkForEnd()
	if ScriptManager:noUnitsLeft(0) or Unit:getUnitById(0) == nil then
		ScriptManager:runForPlayer(0, "endGameWait")
	end
end

--Game End Check: every time a savegame is loaded the script checks if the mission is accomplished or failed

 function CheckForGameEnd()
 	MainGoalAccomplished(4,onMissionAccomplished,MissionFailed)		--Main Mission ID, Script to start if Accomplished, Script to start if Failed
 	ScriptManager:sleep(3,"HideDialogue")
 end

function endGameWait()
	ScriptManager:continueAfterCutscene("MissionFailed")
end

--Start cutscene

function StartIntro()
	ScriptManager:startCutscene();
	ScriptManager:sleep(1,"SpawnPlayerUnits")
	ScriptManager:sleep(2,"MoveCamBase")
end
--EndenableEndTurn


--Cutscene Camera at the beginning

function MoveCamBase()
	ScriptManager:moveCamera(3,9,0.9,3,"waitDepot1")
end

function waitDepot1()
	ScriptManager:revealFogOfWar(3,9,1,true)
	ScriptManager:showMarkerAt(3,9)
	ScriptManager:sleep(2,"moveBackDepot1")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_1)
	ScriptManager:sleep(3,"HideDialogue")
end

function moveBackDepot1()
	ScriptManager:revealFogOfWar(3,9,1,false)
	ScriptManager:hideMarkerAt(3,9)
	
	ScriptManager:moveCamera(4,4,0.8,3,"createMissionMain1Wait")
end

function createMissionMain1Wait()
	
	ScriptManager:sleep(0.5,"EndIntroCutscene")
end

--Spawn Player Units at the beginning

function SpawnPlayerUnits()							
		local unit = ScriptManager:spawnUnit(
		0 ,3 , 	--PLAYER, UNIT
		1, 4 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),3 ,2 , "")
		ScriptManager:sleep(2 ,"MovePlayerTank_2")
end

function MovePlayerTank_2()
		local unit = ScriptManager:spawnUnit(
		0 ,2 , 	--PLAYER, UNIT
		1, 4 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),3 ,3 , "")
		ScriptManager:sleep(2 ,"MovePlayerTank_3")
end

function MovePlayerTank_3()
		local unit = ScriptManager:spawnUnit(
		0 ,2 , 	--PLAYER, UNIT
		1, 4 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),3 ,4 , "")
		ScriptManager:sleep(2 ,"MovePlayerTank_4")
end

function MovePlayerTank_4()
		local unit = ScriptManager:spawnUnit(
		0 ,3 , 	--PLAYER, UNIT
		1, 4 ,	--X, Y
		30, 5); --SQUADID, STATE
		ScriptManager:moveUnit(unit:getId(),2 ,4 , "SpawnTiger")
end

function EndIntroCutscene()
	ScriptManager:stopCutscene()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 4, 4 );
	end
	ScriptManager:continueAfterCutscene("CreateIntroFunctions")
end	


--------------------------------------------
--TODO:DELETE GODS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
--ScriptManager:spawnUnit(0,30,4,4,0,0)
--ScriptManager:spawnUnit(0,30,5,5,0,0)
--ScriptManager:moveCamera(0,0,0.77,0,"")
---------------------------------------------------

-- mission start after the beginning cutscene

function CreateIntroFunctions()
	ScriptManager:blockUI(true)
	ScriptManager:sleep(3,"showDialogue1")
	ScriptManager:setMissionStatus(1, MissionStatus.IN_PROGRESS);
end

function showDialogue1()
	ScriptManager:sleep(2,"enableDialogue1")
	ScriptManager:blockUI(false)
	ScriptManager:enableEndTurnButton()
end

function enableDialogue1()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_2_INTRO_DIALOGUE_START_DIALOGUE)
	ScriptManager:sleep(5,"HideDialogue")
end

function SpawnTiger()																		--Spawn Tigertank and create secondary mission
	local unit = ScriptManager:spawnUnit(0, Units.UNIT_DE_TIGER, 1, 4, 0, 0);
	local spawnTiger = unit:getId()
	ScriptManager:storeValue("tigerID",spawnTiger)
	ScriptManager:addOnUnitHasAttackedTrigger(-1, -1,spawnTiger,"tigerAttacked","tigerAttacked")	--Create Secondary mission
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, spawnTiger, "onTigerDestroyed");
	ScriptManager:moveUnit(spawnTiger,1,3, "")
		
end

--Start Secondary Mission & check progress

function tigerAttacked()																--Check tiger
	if Unit:getUnitById(ScriptManager:getValue("tigerID")):getHealth() >= 1 then		--If tiger attacks a unit and gets no counter attack
		ScriptManager:removeTrigger("tigerAttacked")
		ScriptManager:runForPlayer(0, "CreateSecondaryMission")
	elseif Unit:getUnitById(ScriptManager:getValue("tigerID")):getHealth() < 1 then
		ScriptManager:removeTrigger("tigerAttacked")
		ScriptManager:runForPlayer(0, "onTigerDestroyed")
	end
end

function CreateSecondaryMission()				-- Create Secondary mission if Tiger gets damage
	ScriptManager:removeTrigger("tigerAttacked")
	ScriptManager:removeTrigger("CreateSecondaryMission")
	local TigerID = ScriptManager:getValue("tigerID")
	local tiger = Unit:getUnitById(TigerID)
	if tiger ~= nil then
		ScriptManager:moveCamera(tiger:getX(),tiger:getY(),1.2,2,"CamInPosition")				--zoom in tiger
	end
end

function CamInPosition()
	local TigerID = ScriptManager:getValue("tigerID")
	local tiger = Unit:getUnitById(TigerID)
	ScriptManager:moveCamera(tiger:getX(),tiger:getY(),1.2,2,"moveCamback")	
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_1_2_INTRO_MISSION_SECONDARY_DIALOGUE,"")	--Protect your tiger!
	ScriptManager:sleep(5,"HideDialogue")
end

function moveCamback()					
	local tiger = Unit:getUnitById(ScriptManager:getValue("tigerID"))
	ScriptManager:moveCamera(tiger:getX(),tiger:getY(),0.8,1,"startSecondaryMission")						--Zoom out - tiger
end

function startSecondaryMission()
	ScriptManager:blockUI(false)
--	ScriptManager:enableEndTurnButton()
	ScriptManager:disableSkipCutsceneButton()
	local TigerID = ScriptManager:getValue("tigerID")
	local tiger = Unit:getUnitById(TigerID)
	if tiger ~= nil then																	--for worst case if the tank gets instantly destroyed 
		ScriptManager:setMissionStatus(5,MissionStatus.IN_PROGRESS)
	else
		ScriptManager:setMissionStatus(5,MissionStatus.FAILED)
	end
end

function onTigerDestroyed(unit)		--Mission failed if Tank destroyed
	ScriptManager:runForPlayer(0,"tigerKilled")
end

function tigerKilled()
	ScriptManager:setMissionStatus(5, MissionStatus.FAILED);
end

--END

--START MISSION DEPOT 2

function Depot1trigger(x, y, playerId, templateID, unitID)				--On enter tile trigger
	for i = 0, 3 do
		ScriptManager:removeTrigger("Depot1trigger")
	end
	ScriptManager:sleep(3,"BriefingMission2")
	ScriptManager:storeValue("cameraX_2",x)
	ScriptManager:storeValue("cameraY_2",y)
end

function Depot1trigger2()
 	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)											--On captured / destroyed trigger
	for i = 0, 2 do
		ScriptManager:removeTrigger("Depot1trigger2")
	end																	--remove triggers
	for i = 0,3 do
		ScriptManager:removeTrigger("Depot1trigger")
	end
	if ScriptManager:getValue("cameraX_2") == -1 then
		ScriptManager:sleep(3,"BriefingMission2")
	else
	 	ScriptManager:enableEndTurnButton()
		ScriptManager:blockUI(false)		
	end
	ScriptManager:setMissionStatus(1, MissionStatus.ACCOMPLISHED);
	onHqDestroyedOrCaptured()
end

function BriefingMission2()												-- move cam to depot 2
	ScriptManager:startCutscene()									
	ScriptManager:moveCamera(9,15,0.8,2,"CameraDepot2InPosition")
end

function CameraDepot2InPosition()
	ScriptManager:sleep(2,"MoveBacktoUnitDepot2")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_2)		--dialogue capture this base!
	ScriptManager:enableEndTurnButton()
	ScriptManager:sleep(5,"HideDialogue")
end

function MoveBacktoUnitDepot2()											--Move camera back
	local x = ScriptManager:getValue("cameraX_2")
	local y = ScriptManager:getValue("cameraY_2")						-- if triggerd by unit on enter tile move back to unit else to depot 1
	if x == -1 then
		x = 3
		y = 9
	end
	ScriptManager:moveCamera(x,y,0.8,2,"SetMissionProgressDepot2")
	ScriptManager:blockUI(false)
end

function SetMissionProgressDepot2()
	ScriptManager:stopCutscene()
	if ScriptManager:getMissionStatus(2) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
	end
	ScriptManager:enableEndTurnButton()
	ScriptManager:blockUI(false)
end

--END

--START MISSION DEPOT 3

function Depot2trigger(x, y, playerId, templateID, unitID)				--On enter tile trigger
	ScriptManager:blockUI(true)
	ScriptManager:disableEndTurnButton()
	for i = 0, 7 do
		ScriptManager:removeTrigger("Depot2trigger")
	end																	--remove triggers
	ScriptManager:sleep(2,"BriefingMission3")
	ScriptManager:storeValue("cameraX_3",x)
	ScriptManager:storeValue("cameraY_3",y)
end

function Depot2trigger2()												--On captured / destroyed trigger
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	for i = 0,7 do
		ScriptManager:removeTrigger("Depot2trigger")
	end
	for i = 0, 2 do
		ScriptManager:removeTrigger("Depot2trigger2")
	end
	if ScriptManager:getValue("cameraX_3") == -1 then
		ScriptManager:sleep(3,"BriefingMission3")
	else
		ScriptManager:blockUI(false)
		ScriptManager:enableEndTurnButton()
	end															--remove triggers
	ScriptManager:setMissionStatus(2, MissionStatus.ACCOMPLISHED);
	onHqDestroyedOrCaptured()
end

function BriefingMission3()
	ScriptManager:startCutscene()
	ScriptManager:moveCamera(11,5,0.9,2,"CameraDepot3InPosition")
end

function CameraDepot3InPosition()
	ScriptManager:sleep(2,"MoveBacktoUnitDepot3")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_2_INTRO_MISSION_MAIN_3)
	ScriptManager:sleep(5,"HideDialogue")
end

function MoveBacktoUnitDepot3()
	local x = ScriptManager:getValue("cameraX_3")
	local y = ScriptManager:getValue("cameraY_3")						-- if triggerd by unit on enter tile move back to unit else to depot 1
	if x == -1 then
		x = 9
		y = 15
	end
	ScriptManager:moveCamera(x,y,0.8,2,"SetMissionProgressDepot3")
	ScriptManager:blockUI(false)
end

function SetMissionProgressDepot3()			--Set mission main 2 to done and create trigger for main mission 3
	ScriptManager:stopCutscene()
	ScriptManager:enableEndTurnButton()
	ScriptManager:continueAfterCutscene("DepotCutSceneContinue")
end

function DepotCutSceneContinue()
	if ScriptManager:getMissionStatus(3) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	end	
	ScriptManager:sleep(1,"enableDialogue2")
	ScriptManager:blockUI(false)
end

function enableDialogue2()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_1_2_INTRO_DIALOGUE_DEPOT_2_DIALOGUE)
	ScriptManager:sleep(5,"HideDialogue")
	ScriptManager:sleep(5,"EnableEndTurnButton")
end

--END

--Main Mission Progress

function onHqDestroyedOrCaptured(unit)													--Check Main mission progress
	if 	ScriptManager:getMissionStatus(1) == MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus(2) == MissionStatus.ACCOMPLISHED and
	  	ScriptManager:getMissionStatus(3) == MissionStatus.ACCOMPLISHED then
		ScriptManager:blockUI(true);
		ScriptManager:setMissionStatus(4, MissionStatus.ACCOMPLISHED);
		if ScriptManager:getMissionStatus(5) ~= MissionStatus.FAILED then 			--Set tiger mission to done if still in progress
			ScriptManager:setMissionStatus(5,MissionStatus.ACCOMPLISHED)
		end
		ScriptManager:sleep(3,"outroText")
	end
end

function onDepot3DestroyedOrCaptured(unit)													--Depot 3 destoryed
	ScriptManager:setMissionStatus(3, MissionStatus.ACCOMPLISHED);
	onHqDestroyedOrCaptured()
end

--End


--MISSION FAIL TRIGGER END MISSION

function DepotDestroyed()
	if ScriptManager:getMissionStatus(1) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(1,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"MissionFailed")
	elseif ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"MissionFailed")
	elseif ScriptManager:getMissionStatus(3) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(3,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"MissionFailed")
	end

end

function MissionFailed()
	ScriptManager:blockUI(true);
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MAP_3_2_MISSION_FAILED,"")
	ScriptManager:sleep(3,"HideDialogue")
	ScriptManager:sleep(4,"EndGamewait2")
end

--End mission script

function EndGamewait2()
	ScriptManager:runForPlayer(0,"EndGame")
end


function onMissionAccomplished()														--Outro
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_VICTORY,"")
	ScriptManager:sleep(3,"EndGamewait2")
end

function outroText()
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_1_2_INTRO_DIALOGUE_TEASER,"onMissionAccomplished")
end

function EndGame()
	ScriptManager:endGame()
end

 