require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"


Missions = {
	MISSION_MAIN = 1,
	MISSION_HANGAR_1 = 2,
	MISSION_HANGAR_2 = 3,
	MISSION_HANGAR_3 = 4,
	MISSION_BASE_1 = 5,
	MISSION_BASE_2 = 6,
	MISSION_BASE_3 = 7,
	MISSION_SECONDARY = 8,
	MISSION_SECONDARY2 = 9,
	MISSION_MAIN2 = 10,
}

Units_Templates = {
	UNIT_TEMP_FIGHTER = 23,
	UNIT_TEMP_BOMBER = 24,
}

function onGameStart()
	--print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:preparePopupText()
	--TODO:Makros
	
	ScriptManager:gainGold(0,2000)
		
	ScriptManager:createMission(Missions.MISSION_MAIN, true, Text.T_MISSION_MAP_2_3_INTRO_MISSION_MAIN);
	ScriptManager:createMission(Missions.MISSION_MAIN2, true, Text.T_MISSION_3_2_WARNING);
	
	ScriptManager:createMission(Missions.MISSION_HANGAR_1, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_1, MissionStatus.IN_PROGRESS);
	
	ScriptManager:createMission(Missions.MISSION_HANGAR_2, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_2, MissionStatus.IN_PROGRESS);
	
	ScriptManager:createMission(Missions.MISSION_HANGAR_3, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_3, MissionStatus.IN_PROGRESS);
	
	ScriptManager:createMission(Missions.MISSION_SECONDARY, false, Text.T_MISSION_MAP_2_3_INTRO_MISSION_SECONDARY);
	
	ScriptManager:createMission(11, false, Text.T_MISSION_MAP_2_3_INTRO_MISSION_SECONDARY_2);
	
	ScriptManager:createMission(Missions.MISSION_BASE_1, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_BASE_1, MissionStatus.IN_PROGRESS);
	
	ScriptManager:createMission(Missions.MISSION_BASE_2, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_BASE_2, MissionStatus.IN_PROGRESS);
	
	ScriptManager:createMission(Missions.MISSION_BASE_3, false, "");
	ScriptManager:setMissionStatus(Missions.MISSION_BASE_3, MissionStatus.IN_PROGRESS);
	
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 7, "AirfieldDestroyed");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 7, "onHangar1DestroyedOrCaptured");
	
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 6, "AirfieldDestroyed");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 6, "onHangar2DestroyedOrCaptured");
	
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 20, "AirfieldDestroyed");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 20, "onHangar3DestroyedOrCaptured");
	
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 5, "onBase1Destroyedorcaptured");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 5, "onBase1Destroyedorcaptured");

	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 2, "onBase2Destroyedorcaptured");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 2, "onBase2Destroyedorcaptured");
	
	ScriptManager:addOnUnitDestroyedTrigger(-1, -1, 3, "onBase3Destroyedorcaptured");
	ScriptManager:addOnUnitCapturedTrigger(-1, -1, 3, "onBase3Destroyedorcaptured");
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_AIRFIELD,-1,"displayWarning","displayWarning")
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	
	--SECONDARY 2 TRIGGER
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_HOWITZER,-1,"onTargetAttacked","onTargetAttacked")
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_SU_HOWITZER,-1,"onArtilleryDestroyed","onArtilleryDestroyed")
	
	ScriptManager:setMissionXp(Missions.MISSION_MAIN,250)
	ScriptManager:setMissionXp(Missions.MISSION_MAIN2,150)
	ScriptManager:setMissionXp(Missions.MISSION_SECONDARY,150)
	ScriptManager:setMissionXp(11,100)
	
	ScriptManager:addOnTurnStartTrigger(1,-1,2, "SpawnEnemyReinforcements_4");
	ScriptManager:addOnTurnStartTrigger(1,-1,5, "SpawnEnemyReinforcements_5");
	ScriptManager:addOnTurnStartTrigger(1,-1,10, "SpawnEnemyReinforcements_6");
	ScriptManager:addOnTurnStartTrigger(1,-1,4, "SwitchAIState_Hangar2");
	ScriptManager:addOnTurnStartTrigger(1,-1,7, "SwitchAIState_Hangar3");
	
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"CheckForGameEnd")
	
	ScriptManager:sleep(0,"IntroCutscene")
	
	--CAMERA STARTING POSITION
	
	ScriptManager:moveCamera(16,16,1.1,0,"")
--	ScriptManager:spawnUnit(0,30,1,11,0,0)  --TODO: DELETE GOD
--	ScriptManager:spawnUnit(0,30,1,12,0,0)  --TODO: DELETE GOD
	--EnterTrigger for secondary mission
	
	for y = 0, 17 do
		ScriptManager:addOnEnterTileTrigger(10,y,0,-1,-1,true,"unitEnterTile","unitEnterTile")	
	end					--Create 14* Unit enter tile trigger on x6 line up 
	for x = 0, 7 do
		ScriptManager:addOnEnterTileTrigger(10+x,17,0,-1,-1,true,"unitEnterTile","unitEnterTile")
	end
	
	--SpawnSouthDepot units once
	
	for i = 1, 6 do
		ScriptManager:storeValue(string.format("r%i_counter", i), 0);
	end
	
	for i = 1, 3 do
		ScriptManager:storeValue(string.format("hangarKilledCounter_%i", i), 0);
	end
	
	waitspawn_1()

	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"checkForEnd","checkForEnd")
		
	return 1
end

function checkForEnd()
	if ScriptManager:noUnitsLeft(0) or Unit:getUnitById(0) == nil then
		ScriptManager:runForPlayer(0, "endGameWait")
	end
end

function endGameWait()
	ScriptManager:continueAfterCutscene("MissionFailed")
end

--HideDialogue

function HideDialogue()
	ScriptManager:dismissSubtitle()
end

--Game End Check
function CheckForGameEnd()
	MainGoalAccomplished(Missions.MISSION_MAIN,onMissionAccomplished,MissionFailed)		--Main Mission ID, Script to start if Accomplished, Script to start if Failed
end

--END

--Create Secondary Mission

function onTargetAttacked(attacker, defender)		
	targetID = -1
	if attacker:getTemplateId() == Units.UNIT_SU_HOWITZER then				
		targetID = attacker:getId()
	end
	if defender:getTemplateId() == Units.UNIT_SU_HOWITZER then
		targetID = defender:getId()
	end
	ScriptManager:removeTrigger("onTargetAttacked")
	if ScriptManager:getMissionProgress(11) == MissionStatus.NOT_STARTED then
		ScriptManager:runForPlayer(0, "MoveCamToTarget")
	end
end

function MoveCamToTarget()
	ScriptManager:disableEndTurnButton()
	ScriptManager:enableSkipCutsceneButton()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,2,"CamOnTarget")
end

function CamOnTarget()
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,true)
	ScriptManager:showMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_MISSION_SECONDARY_2)
	ScriptManager:sleep(5,"HideDialogue")
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,3,"ZoomCamOutAndEndScript")
end

function ZoomCamOutAndEndScript()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.8,2,"EndMetaCutScene")
	ScriptManager:hideMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,false)
end

function EndMetaCutScene()
	ScriptManager:setMissionStatus(11,MissionStatus.IN_PROGRESS)
	ScriptManager:disableSkipCutsceneButton()
	ScriptManager:enableEndTurnButton()
end

--END

--COUNTER

function artilleryDestroyed()														--Tank destroyed! x/5
	--print(string.format("[SCRIPT]showCounter"))
	ScriptManager:preparePopupText();
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(11))
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_MISSION_SECONDARY_2_COUNTER)
	ScriptManager:sleep(3,"HideDialogue")
end

function onArtilleryDestroyed(unit)																--Kill tank counter, secondary mission progress
	if ScriptManager:getMissionStatus(11) == MissionStatus.NOT_STARTED then
	ScriptManager:setMissionStatus(11,MissionStatus.IN_PROGRESS)
	end
	ScriptManager:setMissionProgress(11, ScriptManager:getMissionProgress(11) + 1);
	if ScriptManager:getMissionProgress(11) == 3 then
		ScriptManager:setMissionStatus(11, MissionStatus.ACCOMPLISHED);
		ScriptManager:removeTrigger("onArtilleryDestroyed");
		return
	end
	artilleryDestroyed()
end

--END


--START SECONDARY MISSION 1

function unitEnterTile(x, y, playerId, templateID, unitID)	
													--remove 14* main mission 1 triggers
--	for i = 0, 24 do
	ScriptManager:removeTrigger("unitEnterTile")
--	end											--set main mission 1 to accomplished
	ScriptManager:sleep(1,"SecondaryMission")
	ScriptManager:storeValue("cameraX",x)
	ScriptManager:storeValue("cameraY",y)

end

--Secondary mission cutscene

function SecondaryMission()																--Start cutscene
	ScriptManager:startCutscene()		
	ScriptManager:moveCamera(13,23,0.9,2,"RevealFowDepot")
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
end

function RevealFowDepot()
	ScriptManager:revealFogOfWar(13,23,2,true);
	ScriptManager:showMarkerAt(13,23)														--Reveal fog, show marker, create subtitle, move units
	ScriptManager:sleep(1,"SpawnInfantry1")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_DIALOGUE_06)
end

function SpawnInfantry1()
	ScriptManager:spawnUnit(1, Units.UNIT_SU_RIFLE, 13, 24, 66, AiState.ATTACK_AGGRESSIVE);
	ScriptManager:sleep(0.5,"SpawnInfantry2")
end

function SpawnInfantry2()
	ScriptManager:spawnUnit(1, Units.UNIT_SU_RIFLE, 13, 23, 66, AiState.ATTACK_AGGRESSIVE);
	ScriptManager:sleep(0.5,"SpawnInfantry3")
end

function SpawnInfantry3()
	ScriptManager:spawnUnit(1, Units.UNIT_SU_RIFLE, 13, 22, 66, AiState.ATTACK_AGGRESSIVE);
	ScriptManager:sleep(0.5,"wait_1")
end

function wait_1()
	ScriptManager:hideMarkerAt(13,23)
	ScriptManager:sleep(1,"HideMainMission")
end

function HideMainMission()
	HideDialogue()
	ScriptManager:revealFogOfWar(13,23,2,false);																					--Move cam to last unit
	ScriptManager:moveCamera(ScriptManager:getValue("cameraX"),
	ScriptManager:getValue("cameraY"),0.9,2,"EndMainCutscene_")												--Move Camera to last unit
end

function EndMainCutscene_()
	ScriptManager:stopCutscene();
	ScriptManager:continueAfterCutscene("Mission2Timer")
end

function Mission2Timer()
	ScriptManager:sleep(1,"createMainMission2")
end

function createMainMission2()
	ScriptManager:setMissionStatus(Missions.MISSION_SECONDARY, MissionStatus.IN_PROGRESS);
	ScriptManager:enableEndTurnButton()
	ScriptManager:blockUI(false)
	
end

--END



--START MAIN MISSION CUTSCENE

function IntroCutscene()
	ScriptManager:startCutscene()
	--TODO:Screenshots
	--ScriptManager:spawnUnit(0,30,11,4,-1,-1)
	--ScriptManager:spawnUnit(0,30,11,4,-1,-1)
--	ScriptManager:moveCamera(0,0,0.77,0,"")
	ScriptManager:moveCamera(15,23,0.9,2,"SpawnPlanes1")
end

function SpawnPlanes1()
	ScriptManager:sleep(1,"showdiealogue1")
	ScriptManager:revealFogOfWar(15,23,2,true);
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_FIGHTER, 14, 25, 30, AiState.AIRPLANE);
	ScriptManager:moveUnit(unit:getId(),16 ,23 , "FighterinPosition")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar1captured")
end

function FighterinPosition()
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_FIGHTER, 17, 21, 30, AiState.AIRPLANE);
	ScriptManager:moveUnit(unit:getId(),16 ,22 , "Fighter2inPosition")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar1captured")
end

function Fighter2inPosition()
	ScriptManager:sleep(1.5,"MoveCam_3")
end

function MoveCam_3()
	ScriptManager:revealFogOfWar(15,23,2,false);
	ScriptManager:moveCamera(5,19,0.7,2.0,"Reveal_AA")
end

function Reveal_AA()
	ScriptManager:sleep(1,"ShowDielaogue4")
	ScriptManager:revealFogOfWar(5,19,2,true);
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_FIGHTER, 5, 15, 31, AiState.WAIT);
	ScriptManager:moveUnit(unit:getId(),6 ,18 , "Fighter3inPosition")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar2captured")
end

function showdiealogue1()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_DIALOGUE_03)
	ScriptManager:sleep(3,"HideDialogue")
end

function Fighter3inPosition()
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_BOMBER, 7, 22, 31, AiState.WAIT);
	ScriptManager:moveUnit(unit:getId(),6 ,19 , "Bomber1inPostion")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar2captured")
end

function Bomber1inPostion()
	ScriptManager:sleep(0.5,"MoveCam_4")
end

function MoveCam_4()
	ScriptManager:revealFogOfWar(5,19,2,false);
	ScriptManager:moveCamera(5,7,0.7,2.0,"MoveCam_5")
end

function MoveCam_5()
	ScriptManager:revealFogOfWar(5,7,2,true);
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_FIGHTER, 6, 9, 32, AiState.WAIT);
	ScriptManager:moveUnit(unit:getId(),6 ,7 , "Fighter4inPosition")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar3captured","unitHangar3captured")
end

function ShowDielaogue4()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_DIALOGUE_04)
	ScriptManager:sleep(5,"HideDialogue")
end

function Fighter4inPosition()
	local unit = ScriptManager:spawnUnit(1, Units_Templates.UNIT_TEMP_BOMBER, 5, 4, 32, AiState.WAIT);
	ScriptManager:moveUnit(unit:getId(),6 ,6 , "Bomber2inPostion")
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"unitHangar3captured","unitHangar3captured")
end

function unitHangar1captured()
	local planeCounter = ScriptManager:getValue("hangarKilledCounter_1") + 1
	if planeCounter == 2 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2, "SpawnEnemyReinforcements_1", "SpawnEnemyReinforcements_1");
		ScriptManager:removeTrigger("unitHangar1captured")
		--print(string.format("[SCRIPT] RESPAWN PLANES 1"));
	else 
		ScriptManager:storeValue("hangarKilledCounter_1",planeCounter)
	end
end

function unitHangar2captured()
	local planeCounter = ScriptManager:getValue("hangarKilledCounter_2") + 1
	if planeCounter == 2 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+3, "SpawnEnemyReinforcements_2", "SpawnEnemyReinforcements_2");
		ScriptManager:removeTrigger("unitHangar2captured")
		--print(string.format("[SCRIPT] RESPAWN PLANES 2"));
	else 
		ScriptManager:storeValue("hangarKilledCounter_2",planeCounter)
	end
end

function unitHangar3captured()
	local planeCounter = ScriptManager:getValue("hangarKilledCounter_3") + 1
	if planeCounter == 2 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+5, "SpawnEnemyReinforcements_3", "SpawnEnemyReinforcements_3");
		ScriptManager:removeTrigger("unitHangar3captured")
		--print(string.format("[SCRIPT] RESPAWN PLANES 3"));
	else 
		ScriptManager:storeValue("hangarKilledCounter_3",planeCounter)
	end
end

function Bomber2inPostion()
	ScriptManager:sleep(1.5,"MoveCam_6")
end

function MoveCam_6()
	ScriptManager:revealFogOfWar(5,7,2,false);
	ScriptManager:sleep(1,"UnitsReadyDialogue")
	ScriptManager:moveCamera(14,11,0.8,6.0,"EndMainCutscene")
end

function UnitsReadyDialogue()
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_DIALOGUE_02)
	ScriptManager:sleep(6,"HideDialogue")
end

function EndMainCutscene()
	ScriptManager:sleep(2,"EndMAinMissionCutscene")
end

function EndMAinMissionCutscene()
	ScriptManager:stopCutscene()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 14, 11 );
	end
	ScriptManager:sleep(1,"startMissionMain")
end

function startMissionMain()
	ScriptManager:setMissionStatus(Missions.MISSION_MAIN,MissionStatus.IN_PROGRESS)
	
	ScriptManager:sleep(10,"startMissionMain2")
end

function startMissionMain2()
	ScriptManager:setMissionStatus(Missions.MISSION_MAIN2,MissionStatus.IN_PROGRESS)
end 

--END INTROCUTSCENE

function waitspawn_1()
	local unit1 = ScriptManager:spawnUnit(
		1 ,17, --PLAYER, UNIT
		3 ,4 , --X, Y
		20, 6); -- SQUADID, STATE
	local unit2 = ScriptManager:spawnUnit(
		1 ,17, --PLAYER, UNIT
		3 ,5 , --X, Y
		20, 6); -- SQUADID, STATE
end

function MoveCam_8()
	ScriptManager:revealFogOfWar(2,5,1,false);
	ScriptManager:moveCamera(15,12,0.7,9.0,"ToStart_Intro")
end

function ToStart_Intro()
	ScriptManager:stopCutscene();
	ScriptManager:setMissionStatus(Missions.MISSION_MAIN2, MissionStatus.IN_PROGRESS);		
end

function onHangarCaptured()
	
	ScriptManager:preparePopupText();
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(Missions.MISSION_MAIN))
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_3_INTRO_MISSION_MAIN_COUNTER)
	ScriptManager:sleep(3,"HideDialogue")
	
	if 	ScriptManager:getMissionProgress(Missions.MISSION_MAIN) == 3 then
		ScriptManager:setMissionStatus(Missions.MISSION_MAIN, MissionStatus.ACCOMPLISHED);
		ScriptManager:setMissionStatus(Missions.MISSION_MAIN2, MissionStatus.ACCOMPLISHED);
		ScriptManager:sleep(3,"OutroText")
		
	end

end

function onHangar1DestroyedOrCaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_1) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_1, MissionStatus.ACCOMPLISHED);
		ScriptManager:setMissionProgress(Missions.MISSION_MAIN,ScriptManager:getMissionProgress(Missions.MISSION_MAIN)+1)
		onHangarCaptured()
		
		--print(string.format("[SCRIPT] HQ_1 Destroyed..."));
	end
end

function onHangar2DestroyedOrCaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_2) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_2, MissionStatus.ACCOMPLISHED);
		ScriptManager:setMissionProgress(Missions.MISSION_MAIN,ScriptManager:getMissionProgress(Missions.MISSION_MAIN)+1)
		onHangarCaptured()

		--print(string.format("[SCRIPT] HQ_2 Destroyed..."));
	end
end

function onHangar3DestroyedOrCaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_3) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_HANGAR_3, MissionStatus.ACCOMPLISHED);
		ScriptManager:setMissionProgress(Missions.MISSION_MAIN,ScriptManager:getMissionProgress(Missions.MISSION_MAIN)+1)
		onHangarCaptured()
	
		--print(string.format("[SCRIPT] HQ_3 Destroyed..."));
	end
end

--MISSION FAIL TRIGGER END MISSION when the airfields are destroyed instead of captured
--TODO MISSION FAIL TRIGGER

function AirfieldDestroyed()		--changed from depotdestroyed to airfield destroyed
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_1) == MissionStatus.IN_PROGRESS then
--		ScriptManager:setMissionStatus(Missions.MISSION_MAIN,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"Failedtext")
	elseif ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_2) == MissionStatus.IN_PROGRESS then
--		ScriptManager:setMissionStatus(Missions.MISSION_MAIN,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"Failedtext")
	elseif ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_3) == MissionStatus.IN_PROGRESS then
--		ScriptManager:setMissionStatus(Missions.MISSION_MAIN,MissionStatus.FAILED)
		ScriptManager:runForPlayer(0,"Failedtext")
	end
end

function displayWarning(attacker, defender)
	hangerId = defender:getId()
	ScriptManager:runForPlayer(0, "ShowWarningg")
end

function ShowWarningg()
if Unit:getUnitById( hangerId ) ~= nil then
	ScriptManager:moveCamera(hangerId:getX(),hangerId:getY(),1.0,1.5,"")
	ScriptManager:showMarkerAt(hangerId:getX(),hangerId:getY())
end
	ScriptManager:displaySubtitle(Text.T_MISSION_2_3_WARNING)
	ScriptManager:sleep(3,"Endwarning")
end

function Endwarning()
	ScriptManager:removeAllMarkers()
	HideDialogue()
end

--MISSION ENDINGS---


function onMissionAccomplished()
	ScriptManager:dismissSubtitle()
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_VICTORY,"")
	--ScriptManager:sleep(2.5,"HideDialogue")
	ScriptManager:sleep(4,"EndGame")
end

function OutroText()
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_2_3_INTRO_DIALOGUE_08,"")
	ScriptManager:sleep(5,"onMissionAccomplished")
end

function Failedtext()
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_3_2_MISSIONFAILEDTEXT,"MissionFailed")
	ScriptManager:setMissionStatus(Missions.MISSION_MAIN,MissionStatus.FAILED)
	ScriptManager:setMissionStatus(Missions.MISSION_MAIN2,MissionStatus.FAILED)

end

function MissionFailed()
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitle(Text.T_MISSION_FAILED)
	ScriptManager:sleep(3,"HideDialogue")
	ScriptManager:sleep(5,"EndGame")
	
end

function EndGame()
	ScriptManager:endGame()
end

-- OBJECTIVES UPDATED---


function onBase1Destroyedorcaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_1) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_BASE_1, MissionStatus.ACCOMPLISHED);
		update_depot_mission()
	end
end

function onBase2Destroyedorcaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_2) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_BASE_2, MissionStatus.ACCOMPLISHED);
		update_depot_mission()
	end
end

function onBase3Destroyedorcaptured(unit)
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_3) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(Missions.MISSION_BASE_3, MissionStatus.ACCOMPLISHED);
		update_depot_mission()
	end
end



-- Show the counter for depots

function update_depot_mission()		
															-- x/3
	ScriptManager:setMissionProgress(Missions.MISSION_SECONDARY, ScriptManager:getMissionProgress(Missions.MISSION_SECONDARY) + 1);
	if ScriptManager:getMissionProgress(Missions.MISSION_SECONDARY) == 3 then
		ScriptManager:setMissionStatus(Missions.MISSION_SECONDARY, MissionStatus.ACCOMPLISHED);
	end
	
	ScriptManager:preparePopupText();
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(Missions.MISSION_SECONDARY))
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_2_2_MAIN_2_COUNTER)
	ScriptManager:sleep(3,"HideDialogue")
end


--ENEMY SPAWNER SCRIPTS


EnemySpawnHangar_1 = --unit,x,y,squadID
{
	{Units.UNIT_SU_FIGHTER,16,23,200,AiState.AIRPLANE},
	{Units.UNIT_SU_FIGHTER,16,22,200,AiState.AIRPLANE},
}

EnemySpawnHangar_2 = --unit,x,y,squadID
{
	{Units.UNIT_SU_FIGHTER,6,19,201,AiState.AIRPLANE},
	{Units.UNIT_SU_BOMBER,6,18,201,AiState.AIRPLANE},
}

EnemySpawnHangar_3 = --unit,x,y,squadID
{
	{Units.UNIT_SU_FIGHTER,6,6,202,AiState.AIRPLANE},
	{Units.UNIT_SU_BOMBER,6,7,202,AiState.AIRPLANE},
}

EnemySpawn1 = --unit,x,y,squadID
{
	{Units.UNIT_SU_RIFLE,13,23,20,AiState.ATTACK_AGGRESSIVE},
	{Units.UNIT_SU_MORTAR,13,23,20,AiState.ATTACK_AGGRESSIVE},
	{Units.UNIT_SU_TANK_T34,13,23,20,AiState.ATTACK_AGGRESSIVE},
}

EnemySpawn2 = --unit,x,y,squadID
{
	{Units.UNIT_SU_TANK_T34,3,23,30,AiState.ATTACK_AGGRESSIVE},
	{Units.UNIT_SU_TANK_T34,3,23,30,AiState.ATTACK_AGGRESSIVE},
	{Units.UNIT_SU_TANK_DESTROYER,3,23,30,AiState.ATTACK_AGGRESSIVE},
}

EnemySpawn3 = --unit,x,y,squadID
{
	{Units.UNIT_SU_TANK_T34,2,5,40,AiState.ATTACK_AGGRESSIVE},
	{Units.UNIT_SU_TANK_KV1,2,5,40,AiState.ATTACK_AGGRESSIVE},
}
-- Spawns #wave enemies and creates 3 trigger
function spawnWave(wave, respawnCallback) 
	ScriptManager:removeTrigger(respawnCallback);
	for i = 1, #wave do
		local data = wave[i];
		local spawnedUnit = ScriptManager:spawnUnit(1, data[1], data[2], data[3], data[4], data[5]);
		ScriptManager:addOnUnitDestroyedTrigger(1, -1, spawnedUnit:getId(), respawnCallback, respawnCallback);
	end
end

--check if base is still alive
function SpawnEnemyReinforcements_1(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_1"));
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_1) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawnHangar_1, "respawnEnemyReinforcements_1");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_1()
	local enemyCounter = ScriptManager:getValue("r1_counter") + 1;
	if enemyCounter == 2 then
		--print(string.format("[SCRIPT]resetSpawnEnemy1"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2, "SpawnEnemyReinforcements_1", "SpawnEnemyReinforcements_1");
		ScriptManager:storeValue("r1_counter", 0);
	else
		ScriptManager:storeValue("r1_counter", enemyCounter);
	end
end


_missionsID = 
{
	{Missions.MISSION_HANGAR_2, EnemySpawnHangar_2, 20}
}

function SpawnenemyReinforcements_01()
	
end

--check if base is still alive
function SpawnEnemyReinforcements_2(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_2"));
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_2) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawnHangar_2, "respawnEnemyReinforcements_2");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_2()
	local enemyCounter = ScriptManager:getValue("r2_counter") + 1;
	if enemyCounter == 2 then
		--print(string.format("[SCRIPT]resetSpawnEnemy2"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+3, "SpawnEnemyReinforcements_2", "SpawnEnemyReinforcements_2");
		ScriptManager:storeValue("r2_counter", 0);
	else
		ScriptManager:storeValue("r2_counter", enemyCounter);
	end
end

--check if base is still alive
function SpawnEnemyReinforcements_3(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_3"));
	if ScriptManager:getMissionStatus(Missions.MISSION_HANGAR_3) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawnHangar_3, "respawnEnemyReinforcements_3");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_3()
	local enemyCounter = ScriptManager:getValue("r3_counter") + 1;
	if enemyCounter == 2 then
		--print(string.format("[SCRIPT]resetSpawnEnemy3"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+4, "SpawnEnemyReinforcements_3", "SpawnEnemyReinforcements_3");
		ScriptManager:storeValue("r3_counter", 0);
	else
		ScriptManager:storeValue("r3_counter", enemyCounter);
	end
end

--check if base is still alive
function SpawnEnemyReinforcements_4(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_4"));
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_1) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawn1, "respawnEnemyReinforcements_4");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_4()
	local enemyCounter = ScriptManager:getValue("r4_counter") + 1;
	if enemyCounter == 2 then
		--print(string.format("[SCRIPT]resetSpawnEnemy4"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+3, "SpawnEnemyReinforcements_4", "SpawnEnemyReinforcements_4");
		ScriptManager:storeValue("r4_counter", 0);
	else
		ScriptManager:storeValue("r4_counter", enemyCounter);
	end
end

--check if base is still alive
function SpawnEnemyReinforcements_5(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_5"));
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_2) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawn2, "respawnEnemyReinforcements_5");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_5()
	local enemyCounter = ScriptManager:getValue("r5_counter") + 1;
	if enemyCounter == 3 then
		--print(string.format("[SCRIPT]resetSpawnEnemy5"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+5, "SpawnEnemyReinforcements_5", "SpawnEnemyReinforcements_5");
		ScriptManager:storeValue("r5_counter", 0);
	else
		ScriptManager:storeValue("r5_counter", enemyCounter);
	end
end

--check if base is still alive
function SpawnEnemyReinforcements_6(playerId, turnId, roundId)
	--print(string.format("[SCRIPT]spawnEnemyWaveDepot_6"));
	if ScriptManager:getMissionStatus(Missions.MISSION_BASE_3) == MissionStatus.IN_PROGRESS and
	ScriptManager:getCurrentRound() < 20 then	
		spawnWave(EnemySpawn3, "respawnEnemyReinforcements_6");
	end
end

--respawns units if all spawned units are dead
function respawnEnemyReinforcements_6()
	local enemyCounter = ScriptManager:getValue("r6_counter") + 1;
	if enemyCounter == 3 then
		--print(string.format("[SCRIPT]resetSpawnEnemy6"));
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+5, "SpawnEnemyReinforcements_6", "SpawnEnemyReinforcements_6");
		ScriptManager:storeValue("r6_counter", 0);
	else
		ScriptManager:storeValue("r6_counter", enemyCounter);
	end
end

function SwitchAIState_Hangar2()
		Unit:changeSquadState(1,31,AiState.AIRPLANE)
end

function SwitchAIState_Hangar3()
		Unit:changeSquadState(1,32,AiState.AIRPLANE)
end