require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"


-- mission stuff
missionIds = {
	freeTroops 			= 1, -- primary_01
	ambushConvoyOne		= 2, -- primary_02
	ambushConvoyTwo		= 3, -- primary_03
	captureDepot		= 4, -- primary_04
	AmbushConvoyThree	= 5, -- secondary_01
	
};

-- missionId, primary( boolean ), textkey, xpReward
missions = {
	{ missionIds.freeTroops, 			true, 	Text.T_MAP_DE_4_1_MISSION_PRIMARY_01,			75 },
	{ missionIds.ambushConvoyOne, 		true, 	Text.T_MAP_DE_4_1_MISSION_PRIMARY_02,	 		100 },
	{ missionIds.ambushConvoyTwo,		true,	Text.T_MAP_DE_4_1_MISSION_PRIMARY_03, 			100 },
	{ missionIds.captureDepot,			true,	Text.T_MAP_DE_4_1_MISSION_PRIMARY_04,			75 },
	{ missionIds.AmbushConvoyThree,		false, 	Text.T_MAP_DE_4_1_MISSION_SECONDARY_01,			75 },


};


enemySquadIds = {

depot		= 1,

airfield	= 2,

prison		= 3,

planes		= 4,

convoyOne	= 5,

convoyTwo	= 6,

mgNestDepot	= 7,

bunkerDepot	= 8,

bunkerBridgeNorth = 9,

bunkerAirfield = 10, 

mgNestPrison = 11,

mgNestBridgeSouthRight = 12,

mgNestBridgeSouthLeft = 13,

howitzerSouth = 14,

howitzerMiddle = 15,

howitzerNorth = 16,

convoyThree	= 17,

partisansNorth = 18,

partisansSouth = 19,

partisansMiddleRight = 20,

partisansMiddleLeft = 21,

TankAtHQ		= 22,

FLAKsouth = 23,

TankMediumSouth = 24,

};

depotIds 		= { 17, 18, 19, 20, 33, };
airfieldIds		= { 21, 22, 23, 24, 31, };
prisonIds		= { 25, 26, 29, 30, 32, };
planesIds		= { 27, 34 };
convoyOneIds	= {};
convoyTwoIds	= {};
mgNestDepotIds	= { 6 };
bunkerDepotIds	= { 3 };
bunkerBridgeNorthIds = { 5 };
bunkerAirfieldIds = { 8 };
mgNestPrisonIds = { 7 };
mgNestBridgeSouthRightIds = { 4 };
mgNestBridgeSouthLeftIds = { 10 };
howitzerSouthIds = { 37 };
howitzerMiddleIds = { 38 };
howitzerNorthIds = { 36 };
convoyThreeIds = {};
partisansNorthIds = { 39, 40, 41 };
partisansSouthIds = { 42, 43, 58, 44  };
partisansMiddleRightIds = { 46, 47, 48, 49 };
partisansMiddleLeft = { 50, 51 };


enemyBuildingIds = {

enemyDepot 		= 1;
enemyAirfield	= 2;
enemyPrison		= 0;

};

convoyIds = {};

indexOne = 0;
convoyOneWaypoints = { { 19, 27 }, { 10, 15 }, { 16, 7 }, { 20, 7 }, { 22, 17 }, { 19, 25 } };

indexTwo = 0;
convoyTwoWaypoints = { { 27, 23 }, { 24, 18 }, { 26, 9 }, { 24, 5 }, { 21, 6 }, { 14, 11 }, { 10, 16 }, { 15, 21 } };

indexThree = 0;
convoyThreeWaypoints = { { 23, 17 }, { 20, 7 }, { 12, 6 }, { 13, 13 }, { 10, 16 }, { 15, 21 }, { 21, 24 } };



convoyOneUnits = {
-- playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_SU_SUPPLY_TRUCK,	22, 32, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE};
	{ 1, Units.UNIT_SU_RIFLE,			21, 32, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_MOBILE_AA,		20, 31, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_KATYUSHA,		21, 31, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_ANTI_INFANTRY,	22, 31, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_TANK_KV1,		21, 33, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_MORTAR,			22, 30, enemySquadIds.convoyOne, AiState.MOVE_AGGRESSIVE };
};

convoyTwoUnits = {
-- playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_SU_SUPPLY_TRUCK,	24, 26, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_RIFLE,			24, 25, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_TANK_T34,		23, 25, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_MORTAR,			23, 26, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_KATYUSHA,		23, 27, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_TANK_DESTROYER,	24, 27, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_MOBILE_AA,		25, 26, enemySquadIds.convoyTwo, AiState.MOVE_AGGRESSIVE };		
};

convoyThreeUnits = {
-- playerId, templateID, tileX, tileY, squadId, AiState
	
	{ 1, Units.UNIT_SU_MOBILE_AA,		26, 23, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_RIFLE,			27, 22, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_TANK_T34,		27, 24, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_TANK_KV1,		28, 24, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };
	{ 1, Units.UNIT_SU_MORTAR,			28, 23, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };	
	{ 1, Units.UNIT_SU_SUPPLY_TRUCK,	27, 23, enemySquadIds.convoyThree, AiState.MOVE_AGGRESSIVE };
};



convoyOneIds = { };

convoysToDestroy = 2;

convoyOneUnitsToDestroy = 7;

convoyTwoUnitsToDestroy = 7;

convoyThreeUnitsToDestroy = 6;

-- BEGIN Init


function onGameStart()
	CreateMissions( missions );
	setTriggers();
	storeValues();
		
	ScriptManager:gainGold( 0, 1200 );
	ScriptManager:fortifyUnit( 44 );
	
	-- start intro cutscene
	ScriptManager:sleep( 0, "startIntroCutscene" ); -- without sleep player turn popup shows
end

function storeValues()
	ScriptManager:storeValue( "indexOne", indexOne )
	ScriptManager:storeValue( "indexTwo", indexTwo )
	ScriptManager:storeValue( "indexThree", indexThree )
	saveValuesFromTableIntoSavefile( "convoyIds",convoyIds );
	
end

function setTriggers()
	-- load all needed values after loading
	ScriptManager:addOnGameResumeTrigger( "loadValues", "loadValues", false );
	
	-- check if the player has units left
	ScriptManager:addOnUnitDestroyedTrigger( 0, -1, -1, "checkForEnd", "checkForEnd" , false );
	
	-- reduces the action points of the convoy units
--	ScriptManager:addOnTurnStartTrigger( 1, -1, -1, "onEnemyTurnStart", "onEnemyTurnStart", false );
			
	-- enemy prison captured
	ScriptManager:addOnUnitCapturedTrigger( 0, Units.UNIT_DE_PRISON, enemyBuildingIds.enemyPrison, "onPrisonCaptured", "onPrisonCaptured", false );
	
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_DE_PRISON, enemyBuildingIds.enemyPrison, "missionFailed", "missionFailed", false );
		
	-- triggers the enemy depot cutscene/mission		
	
	local y
	for y = 20, 33 do
	ScriptManager:addOnEnterTileTrigger( 14, y, 0, -1, -1, true, "onDepotSighted", "onDepotSighted", false );
	end
	
	local x
	for x = 14, 29 do
	ScriptManager:addOnEnterTileTrigger( x, 20, 0, -1, -1, true, "onDepotSighted", "onDepotSighted", false );
	end
	
	-- enemy depot captured
	ScriptManager:addOnUnitCapturedTrigger(  0, Units.UNIT_SU_HQ, enemyBuildingIds.enemyDepot, "onDepotCaptured", "onDepotCaptured", false );
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_SU_HQ, enemyBuildingIds.enemyDepot, "onDepotCaptured", "onDepotCaptured", false );
	
	--when a unit from the convoyOne table was destroyed
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "onConvoyOneUnitDestroyed", "onConvoyOneUnitDestroyed", false );
	
	--when a unit from the convoyTwo table was destroyed
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "onConvoyTwoUnitDestroyed", "onConvoyTwoUnitDestroyed",false );		
	
	--when a unit from the convoyTwo table was destroyed	
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "onConvoyThreeUnitDestroyed", "onConvoyThreeUnitDestroyed", false );


	-- when a supply truck was destroyed
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_SU_SUPPLY_TRUCK, -1, "onSupplyTruckdestroyed", "onSupplyTruckdestroyed", false );
	
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "onEnemyDestroyed", "onEnemyDestroyed", false );
		
end

function loadValues()
	indexOne	= ScriptManager:getValue( "indexOne" );
	indexTwo	= ScriptManager:getValue( "indexTwo" );
	indexThree	= ScriptManager:getValue( "indexThree" );
	convoyIds	= loadValuesFromSavefileIntoEmptytable( "convoyIds" );

end

function spawnConvoyOne( spawnTable )
	local unit = ScriptManager:spawnUnit( spawnTable[1], spawnTable[2], spawnTable[3], spawnTable[4], spawnTable[5], spawnTable[6] );
	table.insert( convoyIds, unit:getId() );
	saveValuesFromTableIntoSavefile( "convoyIds",convoyIds );
end


function spawnConvoyTwo( spawnTable )
	local unit = ScriptManager:spawnUnit( spawnTable[1], spawnTable[2], spawnTable[3], spawnTable[4], spawnTable[5], spawnTable[6] );
	table.insert( convoyIds, unit:getId() );
	saveValuesFromTableIntoSavefile( "convoyIds",convoyIds );	
end


function spawnConvoyThree( spawnTable )
	local unit = ScriptManager:spawnUnit( spawnTable[1], spawnTable[2], spawnTable[3], spawnTable[4], spawnTable[5], spawnTable[6] );
	table.insert (convoyIds, unit:getId() );
	saveValuesFromTableIntoSavefile( "convoyIds",convoyIds );	
end


function onEnemyDestroyed( unit )
	local squadId = unit:getSquadId();
	local unitId  = unit:getId()
	
	if  squadId == enemySquadIds.convoyOne or
		squadId == enemySquadIds.convoyTwo or
		squadId == enemySquadIds.convoyThree then
		
		for i = 1, #convoyIds do
			if unitId == convoyOneIds[i] then
				table.remove( convoyIds, i );
				saveValuesFromTableIntoSavefile( "convoyIds",convoyIds );				
			end
		end
	end
end


-- END Init

-- saves all values from a table into single save file entries by their value
function saveValuesFromTableIntoSavefile( saveName, table )
	-- highest number used to know exactly how far to search when loading the table
	local highestNumber = 0;
	for i = 1, #table do
		-- need to save the ids in the name cause otherwise there might get holes into the coutn if i just go 1++
		ScriptManager:storeValue( string.format( "%s_%i", saveName, table[i] ), table[i] );
		if table[i] > highestNumber then
			highestNumber = table[i];
		end
	end
	ScriptManager:storeValue( string.format( "%s_highest", saveName ), highestNumber );
end


-- loads a otherwise table from single values in the save file; format: "saveName_*counter*"
function loadValuesFromSavefileIntoEmptytable( saveName )
	local value = 0;
	local returnTable = {};
	local searchNumber = ScriptManager:getValue( string.format( "%s_highest", saveName ) );
	if searchNumber == 0 then
		print( "search index = 0!!" );
	
	else
		for i = 1, searchNumber do
			value = ScriptManager:getValue( string.format( "%s_%i", saveName, i ) );
			
			if value ~= nil and value ~= -1 then
				print( string.format("%i inserted", value ) );
				table.insert( returnTable, value );
			end
		end
	end
	
	return returnTable;
end

-- BEGIN Intro Cutscene

function startIntroCutscene()
	StartCutscene();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_01 );
	ScriptManager:wait( 3 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_02 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_03 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_04 );
	ScriptManager:moveCameraEx( 27, 8, 0.7, 3, true );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_05 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_06 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:moveCameraEx( 1, 15, 0.7, 3, true );
 	
 	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_07 );
 	ScriptManager:wait( 7 );
 	ScriptManager:dismissSubtitle();
 	
 	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_08 );
 	ScriptManager:wait( 7 );
 	ScriptManager:dismissSubtitle();
 	
 	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_09 );
 	ScriptManager:wait( 6 );
 	ScriptManager:dismissSubtitle();
 	
 	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_10 );
	ScriptManager:wait( 4 );
	
	ScriptManager:dismissSubtitle()
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_INTRO_FLAVOR_11 ); 	
 	ScriptManager:wait( 3 );
 	ScriptManager:dismissSubtitle();
 	
	EndCutscene();
	
	spawnTheConvoys();
	
	startTheMission();
end

-- END Intro Cutscene

function spawnTheConvoys()
	ScriptManager:removeTrigger( "spawnTheConvoys" );
	
	for i = 1, #convoyOneUnits do
		spawnConvoyOne( convoyOneUnits[i] );
	end
	
	for i = 1, #convoyTwoUnits do
		spawnConvoyTwo ( convoyTwoUnits[i] );
	end
	
	-- set the maximal action points of the convoy units to 8
	local unit
	for i = 1, #convoyIds do
		unit = Unit:getUnitById( convoyIds[i] );		
		
		if unit ~= nil then
			unit:setMaxActionPoints ( 8 );
		end
	end	
	
	
	-- set the action points to 8 when the units spawn at the beginning
	local unit;
	for i = 1, #convoyIds do
		unit = Unit:getUnitById( convoyIds[i] );
				
		if unit ~= nil then
			unit:setActionPoints( 8 );
		end
	end	
	
	onConvoyOneWaypointReached();
	
	onConvoyTwoWaypointReached();
		
end



function startTheMission()
	ScriptManager:setMissionStatus( missionIds.freeTroops, MissionStatus.IN_PROGRESS );
	
	ScriptManager:setMissionStatus(missionIds.ambushConvoyOne, MissionStatus.IN_PROGRESS );
	
	ScriptManager:setMissionStatus(missionIds.ambushConvoyTwo, MissionStatus.IN_PROGRESS );
	
	ScriptManager:fortifyUnit( 18 );
	ScriptManager:fortifyUnit( 19 );
	ScriptManager:fortifyUnit( 33 );
	ScriptManager:fortifyUnit( 22 );
	ScriptManager:fortifyUnit( 29 );
	ScriptManager:fortifyUnit( 52 );
	ScriptManager:fortifyUnit( 55 );		
	--TODO: remove this function!
--	testing();
--	removeSquads();
	--ScriptManager:addOnUnitSelectedTrigger( 1, -1, -1, "showParameters", "showParameters",false)
end

function testing()
	ScriptManager:spawnUnit( 0, Units.GOTT, 1, 2, 42, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.GOTT, 2, 2, 42, AiState.WAIT );
end

function removeSquads()
	--for i = 1, # do
	--	ScriptManager:removeUnitEx( [i], false );
	--end
	for i = 1, #depotIds do
	ScriptManager:removeUnitEx( depotIds[i], false );
	end
	
	for i = 1, #airfieldIds do
	ScriptManager:removeUnitEx( airfieldIds[i], false );
	end
	
	for i = 1, #prisonIds do
	ScriptManager:removeUnitEx( prisonIds[i], false );
	end
	
	for i = 1, #planesIds do
	ScriptManager:removeUnitEx( planesIds[i], false );
	end

	for i = 1, #convoyOneIds do
	ScriptManager:removeUnitEx( convoiOneIds[i], false );
	end
	
	for i = 1, #convoyTwoIds do
	ScriptManager:removeUnitEx( convoiTwoIds[i], false );
	end
	
	for i = 1, #mgNestDepotIds do
	ScriptManager:removeUnitEx( mgNestDepotIds[i], false );
	end

	for i = 1, #bunkerDepotIds do
	ScriptManager:removeUnitEx( bunkerDepotIds[i], false );
	end
	
	for i = 1, #bunkerBridgeNorthIds do
	ScriptManager:removeUnitEx( bunkerBridgeNorthIds[i], false );
	end
	
	for i = 1, #bunkerAirfieldIds do
	ScriptManager:removeUnitEx( bunkerAirfieldIds[i], false );
	end

	for i = 1, #mgNestPrisonIds do
	ScriptManager:removeUnitEx( mgNestPrisonIds[i], false );
	end
	
	for i = 1, #mgNestBridgeSouthRightIds do
	ScriptManager:removeUnitEx( mgNestBridgeSouthRightIds[i], false );
	end

	for i = 1, #mgNestBridgeSouthLeftIds do
	ScriptManager:removeUnitEx( mgNestBridgeSouthLeftIds[i], false );
	end

	for i = 1, #howitzerSouthIds do
	ScriptManager:removeUnitEx( howitzerSouthIds[i], false );
	end
	
	for i = 1, #howitzerMiddleIds do
	ScriptManager:removeUnitEx( howitzerMiddleIds[i], false );
	end
	
	for i = 1, #howitzerNorthIds do
	ScriptManager:removeUnitEx( howitzerNorthIds[i], false );
	end

	for i = 1, #convoyThreeIds do
	ScriptManager:removeUnitEx( convoyThreeIds[i], false );
	end
	
	for i = 1, #partisansNorthIds do
	ScriptManager:removeUnitEx( partisansNorthIds[i], false );
	end
	
	for i = 1, #partisansSouthIds do
	ScriptManager:removeUnitEx( partisansSouthIds[i], false );
	end
	
	for i = 1, #partisansMiddleRightIds do
	ScriptManager:removeUnitEx( partisansMiddleRightIds[i], false );
	end
	
	for i = 1, #partisansMiddleLeft do
	ScriptManager:removeUnitEx( partisansMiddleLeft[i], false );
	end
end

function showParameters( selectedUnit )
	--print( string.format( "[] %s", selectedUnit:get() ) );
end


-- BEGIN


-- insert missionstuff here


function onConvoyOneUnitDestroyed( unit )	
	local unit = unit:getSquadId()
		
	if unit == enemySquadIds.convoyOne then
	ScriptManager:setMissionProgress(missionIds.ambushConvoyOne, ScriptManager:getMissionProgress(missionIds.ambushConvoyOne) +1 );
	ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.ambushConvoyOne ), Text.T_MAP_DE_4_1_MISSION_PRIMARY_02_COUNTER );
	unit = Unit:changeSquadState( 1, enemySquadIds.convoyOne, AiState.ATTACK_AGGRESSIVE );
		if ScriptManager:getMissionProgress( missionIds.ambushConvoyOne ) >= convoyOneUnitsToDestroy then
--	 	DisablePlayerInteraction();
	 	ScriptManager:setMissionStatus(missionIds.ambushConvoyOne, MissionStatus.ACCOMPLISHED );
	 	ScriptManager:removeTrigger( "onConvoyOneUnitDestroyed" );		
		
		checkForVictory()
		end	
	end
--	EnablePlayerInteraction();
end


function onConvoyTwoUnitDestroyed( unit )
	local unit = unit:getSquadId();
	
	if unit == enemySquadIds.convoyTwo then
	ScriptManager:setMissionProgress( missionIds.ambushConvoyTwo, ScriptManager:getMissionProgress(missionIds.ambushConvoyTwo) + 1 );
	ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.ambushConvoyTwo ), Text.T_MAP_DE_4_1_MISSION_PRIMARY_03_COUNTER );
	unit = Unit:changeSquadState( 1, enemySquadIds.convoyTwo, AiState.ATTACK_AGGRESSIVE );
		if ScriptManager:getMissionProgress( missionIds.ambushConvoyTwo ) >= convoyTwoUnitsToDestroy then
--		DisablePlayerInteraction();
		
		DisablePlayerInteraction();
		
		ScriptManager:setMissionStatus( missionIds.ambushConvoyTwo, MissionStatus.ACCOMPLISHED );
		ScriptManager:removeTrigger( "onConvoyTwoUnitDestroyed" );
		
		checkForVictory()

	-- spawn the units of convoy three	
		for i = 1, # convoyThreeUnits do
		spawnConvoyThree ( convoyThreeUnits[i] );
	

	-- set the action points to 8 when the units spawn 
		
	local unit;
	for i = 1, #convoyIds do
	unit = Unit:getUnitById( convoyIds[i] );
				
		if unit ~= nil then
			unit:setActionPoints( 8 );
		end
	end	
			
	onConvoyThreeWaypointReached();	
	end
	
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_SECONDARY_01_FLAVOR_01 );
	ScriptManager:wait( 7 );
	ScriptManager:dismissSubtitle();
	ScriptManager:stopCutscene();
	
	ScriptManager:setMissionStatus( missionIds.AmbushConvoyThree, MissionStatus.IN_PROGRESS );	
	end
	end
	EnablePlayerInteraction();
end


function onConvoyThreeUnitDestroyed( unit )
	local unit = unit:getSquadId();
	
	if unit == enemySquadIds.convoyThree then
	ScriptManager:setMissionProgress( missionIds.AmbushConvoyThree, ScriptManager:getMissionProgress(missionIds.AmbushConvoyThree) + 1 );
	ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.AmbushConvoyThree ), Text.T_MAP_DE_4_1_MISSION_SECONDARY_01_COUNTER );
	unit = Unit:changeSquadState( 1, enemySquadIds.convoyThree, AiState.ATTACK );
		if ScriptManager:getMissionProgress( missionIds.AmbushConvoyThree ) >= convoyThreeUnitsToDestroy then
--		DisablePlayerInteraction();
		ScriptManager:setMissionStatus( missionIds.AmbushConvoyThree, MissionStatus.ACCOMPLISHED );
		ScriptManager:removeTrigger( "onConvoyThreeUnitDestroyed" );
		checkForVictory()
		end
	end
--	EnablePlayerInteraction();
end


function onSupplyTruckdestroyed()
	ScriptManager:removeTrigger( "onSupplyTruckdestroyed" );
	ScriptManager:runForPlayer( 0, "playSupplyTruckCutscene" );
end


function playSupplyTruckCutscene()

	ScriptManager:startCutscene();
	
	ScriptManager:wait( 1 );
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_02_FLAVOR_01 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_02_FLAVOR_02 );
	ScriptManager:wait( 7 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_02_FLAVOR_03 );
	ScriptManager:wait( 6 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();
end


function onPrisonCaptured()
	ScriptManager:removeTrigger( "onPrisonCaptured" );
	
	StartCutscene();
	
	ScriptManager:moveCameraEx( 27, 8, 0.7, 2, true );
	
	ScriptManager:spawnUnit( 0, Units.UNIT_DE_MP40, 26, 9, -1, AiState.DEFEND );
	ScriptManager:spawnUnit( 0, Units.UNIT_DE_PANZERFAUST, 27, 9, -1, AiState.DEFEND );
	ScriptManager:spawnUnit( 0, Units.UNIT_DE_ANTI_INFANTRY, 28, 8, -1, AiState.DEFEND );
	ScriptManager:spawnUnit( 0, Units.UNIT_DE_MP40, 27, 10, -1, AiState.DEFEND );
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_01_FLAVOR_01 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();

	EndCutscene();
	
	ScriptManager:setMissionStatus( missionIds.freeTroops, MissionStatus.ACCOMPLISHED );
	
	if ScriptManager:getMissionStatus( missionIds.captureDepot ) == MissionStatus.NOT_STARTED then
		
		ScriptManager:wait( 1 );
		
		onDepotSighted()
	end
	
	checkForVictory()
end


function onDepotSighted()
	ScriptManager:removeTrigger( "onDepotSighted" );
	
	DisablePlayerInteraction()
	
	ScriptManager:startCutscene()
	
	ScriptManager:moveCameraEx( 19, 28, 0.7, 2, true );
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_04_FLAVOR_01 );
	ScriptManager:wait( 7 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();
	
	ScriptManager:setMissionStatus( missionIds.captureDepot, MissionStatus.IN_PROGRESS );
	
	EnablePlayerInteraction();
	
	ScriptManager:addOnTurnStartTrigger ( 1, -1, -1, "spawnDepotReinforcement", "spawnDepotReinforcement", false );
end


function spawnDepotReinforcement()

	ScriptManager:removeTrigger( "spawnDepotReinforcement" );

	local depot = enemyBuildingIds.enemyDepot
	
	if depot ~= nil then
	ScriptManager:spawnUnit( 1, Units.UNIT_SU_ANTI_INFANTRY, 18, 29, -1, AiState.ATTACK_AGGRESSIVE );
	ScriptManager:spawnUnit( 1, Units.UNIT_SU_RIFLE, 19, 27, -1, AiState.ATTACK_AGGRESSIVE );
	end
end


function onDepotCaptured()
	ScriptManager:removeTrigger( "onDepotCaptured" );
	ScriptManager:setMissionStatus( missionIds.captureDepot, MissionStatus.ACCOMPLISHED );
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_PRIMARY_04_FLAVOR_02 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
	checkForVictory()
end


function onConvoyOneWaypointReached()
	indexOne = waypointReached( "onConvoyOneWaypointReached", indexOne, convoyOneWaypoints, enemySquadIds.convoyOne );
	print( indexOne );
	ScriptManager:storeValue( "indexOne", indexOne );	
end


function onConvoyTwoWaypointReached()	
	indexTwo = waypointReached ( "onConvoyTwoWaypointReached", indexTwo, convoyTwoWaypoints, enemySquadIds.convoyTwo );
	print ( indexTwo );
	ScriptManager:storeValue( "indexTwo", indexTwo );
end


function onConvoyThreeWaypointReached()
	indexThree = waypointReached ( "onConvoyThreeWaypointReached", indexThree, convoyThreeWaypoints, enemySquadIds.convoyThree );
	print ( indexThree )
	ScriptManager:storeValue( "indexThree", indexThree );
end


function waypointReached( triggerName, index, waypointTable, squadId )
		
	ScriptManager:removeTrigger( triggerName );
	
	if index == #waypointTable then
		index = 1;
		
	else
		index = index + 1;
	end
	ScriptManager:wait( 1 );
	ScriptManager:setTargetTile( 1, squadId, waypointTable[index][1], waypointTable[index][2] );
	ScriptManager:addOnEnterTileTrigger( waypointTable[index][1], waypointTable[index][2], 1, -1, -1, false, triggerName, triggerName, false );
	
	return index;
end


-- BEGIN Victory


function checkForVictory()
	if 	ScriptManager:getMissionStatus( missionIds.ambushConvoyOne )	== MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus( missionIds.ambushConvoyTwo )	== MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus( missionIds.captureDepot )		== MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus( missionIds.freeTroops )			== MissionStatus.ACCOMPLISHED then	
		
		startVictoryCutscene()
	end
end


function startVictoryCutscene()
	StartCutscene();
	
	ScriptManager:displaySubtitle( Text.T_MAP_DE_4_1_MISSION_OUTRO_FLAVOR_01 );
	ScriptManager:wait( 4 );
	HideDialogue();
	
	EndCutscene();
	
	victoryEndGame();
end

function victoryEndGame()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens

	-- accomplish secondary missions that are accomplished when the game is finished with certain condition
	
	
	ScriptManager:displaySubtitle( Text.T_MISSION_VICTORY );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
end


-- END Victory
-- BEGIN Defeated


function checkForEnd()
	if ScriptManager:noUnitsLeft( 0 ) then
		ScriptManager:runForPlayer( 0, "missionFailed" )
	end
end

function missionFailed()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens
	
	ScriptManager:displaySubtitle( Text.T_MISSION_FAILED );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
end


-- END Defeated


function endGame()
	ScriptManager:endGame()
end