require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

-- mission stuff
-- Zuweisung der MissionIds in einer Tabelle (Bei Tabellen die Zeile mit einem Komma abschliessen!)
-- Assignment of the missionIds in a table (close the end of the line with a comma!)

missionIds = {
	moveAA 				= 1,			-- PrimaryMission: 		Move AA Guns
	destroyPlanes 		= 2,			-- PrimaryMission: 		Shoot down five German Planes
	captureAirfields 	= 3,			-- PrimaryMission: 		Capture or destroy the German Airfields
	captureHQ			= 4,			-- SecondaryMission: 	Capture or destroy the depot near the mountain pass
	destroyBunkers		= 5, 			-- SecondaryMission:	Destroy the bunkers in the mountain pass
	captureDepot 		= 6 			-- PrimaryMission: 		Capture or destroy the German HQ
};

AAsToMove = 2;

planesToDestroy = 5;

airfieldsToCapture = 2;

bunkersToDestroy = 2;

-- missionId, primary( boolean ), textkey, xpReward
missions = {
	{missionIds.moveAA, 			true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_01,				75 }, 		-- Mission_Primary_01		
	{missionIds.destroyPlanes, 		true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_02,				100},		-- Mission_Primary_02
	{missionIds.captureAirfields, 	true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_03,				100},		-- Mission_Primary_03
	{missionIds.captureHQ, 			true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_04,				200},		-- Mission_Primary_04
	{missionIds.destroyBunkers, 	false,	Text.T_MAP_SU_5_1_MISSION_SECONDARY_01,				75 },		-- Mission_Secondary_01
	{missionIds.captureDepot, 		false, 	Text.T_MAP_SU_5_1_MISSION_SECONDARY_02,				100},		-- Mission_Secondary_02
};
-- Fuer Texte:
-- !!! Makros einfuegen (greifen auf Excel-Tabelle zu) fuer multi-language Unterstuetzung
-- !!! Fill in Macros (they access the Excel-table) for multi-language-support


-- all enemy squad / unit Ids:

-- enemy building Ids

buildingIds = {

	airfieldNorth 		= 4,
	airfieldNortheast 	= 5,
	depotMountainPass	= 3,
	germanHQ			= 1
}

-- enemy unit Ids

enemySquadIds = {
	city 							= 1,
	airfieldNorth 					= 2,
	airfieldNortheast 				= 3,
	depotMountainPass 				= 4,
	lake							= 5,
	germanHQ 						= 6,
	planeAttackWave 				= 7,
	planeAttackWave2				= 8,
	AttackWave						= 9,
	AttackWave2 					= 10,
}

playerDepot = 2;

-- Ids der Units und wo sie sich befinden, fuer den (schnellen) Test koennen die Tabellen spaeter auskommentiert werden, damit man sich nicht durch jeden Squad/Unit kaempfen muss.
-- Ids of the units and where they are located, for the (quick) test, the tables can be commented out, so you won't have to fight through every squad/unit


cityIds 				= {50, 51, 52, 53, 55, 61, 62, 63,}
airfieldNorthIds 		= {10, 13, 14, 15, 17, 42, 43, 48, 49, 69, 71 }
airfieldNortheastIds 	= {35, 36, 38, 39, 40, 41,}
depotMountainPassIds 	= {0, 9, 11, 16, 37, 44, 45, 46, 47, 54, 57, 65, 66, 67, 68, 70 }
lakeIds 				= {58, 59, 60, 64}
germanHQIds				= {8, 12, 27, 28, 29, 30, 31, 32, 33, 34, 56, 72, 73}
aaInTown				= -1;


-- Trigger tiles in the city (mission moveAA), all tiles in the city which are marked as 'village' in the tile layer

cityTriggerTiles = {
	{4, 17},
	{5, 17},
	{5, 16},
	{6, 16},
	{7, 16},
	{8, 16},
	{9, 16},
	{5, 15},
	{6, 15},
	{7, 15},
	{8, 15},
	{5, 14},
	{6, 14},
	{7, 14},
	{8, 14},
	{5, 13},
	{6, 11},
	{6, 12},
	{6, 13},
	{7, 13},
	{7, 12},
	{8, 12},
		
}

--HQ trigger line --> soll die cutscene "zerstoere das deutsche HQ" und die Mission" zerstoere das deutsche HQ" ausloesen 

HQTriggerTiles = {		
	{13, 0},
	{13, 1},
	{14, 2},
	{14, 3},
	{15, 4},
	{15, 5},
	{16, 6},
	{16, 7},
	{17, 8},
	{17, 9},
	{18, 10},
	{18, 11},
	{19, 11},
	{20, 11},
	{21, 11},
	{22, 11},
	
}


-- Spawn for the plane waves

airfieldNorthSpawnTiles = {
	{9, 24},
	{9, 23},
	{10, 24},
}

airfieldNortheastSpawnTiles = {
	{18, 23},
	{18, 22},
	{19, 22},
}

-- Spawn for the attack waves

depotMountainPassSpawnTiles = {
	{12, 8},
	{13, 7},
	{13, 9}

}

germanHQSpawnTiles = {
	{20, 4},
	{21, 4},
	{21, 3},

}

spawnPlaneWaves				= 0						-- 0 == false; 1 == true; can't save booleans so I have to use numbers
planeWaveRespawnInterval 	= 3						-- defines how often waves will spawn
lastPlaneWaveSpawnedInRound	= -4; 					-- indicates the round in which the last wave spawned
planeAttackWaveUnits = {

-- Bsp.: germanHQSpawntiles [1][1], germanHQSpawntiles [1][2]
-- --> greift auf die Tabelle "germanHQSpawntiles" zurueck, aus der dann die x und y Position fuer den Spawnpoint gelesen werden - [1] [1] 
-- --> erste Zeile, erste Spalte [1] [2] --> erste Zeile, zweite Spalte usw.  


--	playerId, templateID, 				tileX,					 	tileY,							 squadId,					AiState
	--{ 1, Units.UNIT_DE_FIGHTER,		airfieldNorthSpawnTiles[1][1], airfieldNorthSpawnTiles[1][2], enemySquadIds.planeAttackWave, AiState.AIRPLANE },
	{ 1, Units.UNIT_DE_FIGHTER,		airfieldNorthSpawnTiles[2][1], airfieldNorthSpawnTiles[2][2], enemySquadIds.planeAttackWave, AiState.AIRPLANE },
	{ 1, Units.UNIT_DE_DESTROYER, 	airfieldNorthSpawnTiles[3][1], airfieldNorthSpawnTiles[3][2], enemySquadIds.planeAttackWave, AiState.AIRPLANE }
};

spawnPlaneWaves2					= 0
planeWaveRespawnInterval2			= 2
lastPlaneWaveSpawnedInRound2		= -3;
planeAttackWaveUnits2 = {
--	playerId, templateID, 				tileX,					 		tileY,								 squadId,							AiState
	--{1, Units.UNIT_DE_FIGHTER, 		airfieldNortheastSpawnTiles [1] [1], airfieldNortheastSpawnTiles [1] [2], enemySquadIds.planeAttackWave2, AiState.AIRPLANE },
	--{1, Units.UNIT_DE_DESTROYER, 	airfieldNortheastSpawnTiles [2] [1], airfieldNortheastSpawnTiles [2] [2], enemySquadIds.planeAttackWave2, AiState.AIRPLANE },
	{1, Units.UNIT_DE_DESTROYER, 	airfieldNortheastSpawnTiles [3] [1], airfieldNortheastSpawnTiles [3] [2], enemySquadIds.planeAttackWave2, AiState.AIRPLANE },
}
	
spawnAttackWavesMountain				= 0
AttackWaveMountainRespawnInterval 		= 3
lastAttackWaveMountainSpawnedInRound 	= -4
AttackWaveUnitsMountain	= {
--	playerId, templateID, 				tileX,					 			tileY,								 squadId,							AiState
	{1, Units.UNIT_DE_MP40, 		depotMountainPassSpawnTiles [1] [1], depotMountainPassSpawnTiles [1] [2], enemySquadIds.AttackWave, AiState.ATTACK_AGGRESSIVE },
	--{1, Units.UNIT_DE_PANZERFAUST, 	depotMountainPassSpawnTiles [2] [1], depotMountainPassSpawnTiles [2] [2], enemySquadIds.AttackWave, AiState.ATTACK_AGGRESSIVE},
	{1, Units.UNIT_DE_TANK_3, 		depotMountainPassSpawnTiles [3] [1], depotMountainPassSpawnTiles [3] [2], enemySquadIds.AttackWave, AiState.ATTACK_AGGRESSIVE},
}	


spawnAttackWavesHQ				= 0
AttackWaveHQRespawnInterval 	= 3
lastAttackWaveHQSpawnedInRound 	= -4
AttackWaveUnitsHQ = {
--	playerId, templateID, 				tileX,					 			tileY,					squadId,				AiState
	--{1, Units.UNIT_DE_MP40, 		germanHQSpawnTiles [1] [1], germanHQSpawnTiles [1] [2], enemySquadIds.AttackWave2, AiState.ATTACK_AGGRESSIVE },
	{1, Units.UNIT_DE_PANZERFAUST, 	germanHQSpawnTiles [2] [1], germanHQSpawnTiles [2] [2], enemySquadIds.AttackWave2, AiState.ATTACK_AGGRESSIVE },
	{1, Units.UNIT_DE_TANK_3, 		germanHQSpawnTiles [3] [1], germanHQSpawnTiles [3] [2], enemySquadIds.AttackWave2, AiState.ATTACK_AGGRESSIVE },
}

-- BEGIN Init




function onGameStart()
	CreateMissions( missions );
	
-- delete create missions below


	--ScriptManager:spawnUnit( 0, Units.UNIT_SU_AA, 4, 14, 0, 0 );
	--ScriptManager:spawnUnit( 0, Units.UNIT_SU_AA, 4, 13, 0, 0 );
	setTriggers();
	storeValues();
	

	ScriptManager:gainGold( 0, 2200 );
	
	-- start intro cutscene
	ScriptManager:sleep( 0, "startIntroCutscene" ); -- without sleep player turn popup shows
	
	removeUnits()
--[[
	ScriptManager:fortifyUnit( 45 );
	ScriptManager:fortifyUnit( 43 );
	ScriptManager:fortifyUnit( 65 );
	ScriptManager:fortifyUnit( 70 );
	ScriptManager:fortifyUnit( 77 );
	ScriptManager:fortifyUnit( 23 );
	ScriptManager:fortifyUnit( 28 );
]]


	--TODO: remove this function!
	--testing();
	--ScriptManager:addOnUnitSelectedTrigger( -1, -1, -1, "showParameters", "showParameters",false)
end

function showParameters( selectedUnit )
	print( string.format( "[squadId] %s", selectedUnit:getSquadId() ) );
	print( string.format( "[aistate] %s", selectedUnit:getAiState() ) );
end

function testing()
	ScriptManager:spawnUnit( 0, Units.GOTT, 1, 11, 0, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.GOTT, 1, 2, 0, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_AA, 4, 14, 0, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_AA, 4, 13, 0, AiState.WAIT );
end

function storeValues()
		
	ScriptManager:storeValue( "AAsToMove", 							AAsToMove );
	ScriptManager:storeValue( "planesToDestroy", 					planesToDestroy );
	ScriptManager:storeValue( "airfieldsToCapture", 				airfieldsToCapture );
	ScriptManager:storeValue( "bunkersToDestroy", 					bunkersToDestroy );
		
	ScriptManager:storeValue( "spawnPlaneWaves", 					spawnPlaneWaves );
	ScriptManager:storeValue( "lastPlaneWaveSpawnedInRound",		lastPlaneWaveSpawnedInRound );
	
	ScriptManager:storeValue( "spawnPlaneWaves2", 					spawnPlaneWaves2 );
	ScriptManager:storeValue( "lastPlaneWaveSpawnedInRound2", 		lastPlaneWaveSpawnedInRound2 );
	
	ScriptManager:storeValue( "spawnAttackWavesMountain", 			spawnAttackWavesMountain );
	ScriptManager:storeValue("lastAttackWaveMountainSpawnedInRound",lastAttackWaveMountainSpawnedInRound);
	
	ScriptManager:storeValue( "spawnAttackWavesHQ", 				spawnAttackWavesHQ );
	ScriptManager:storeValue("lastAttackWaveHQSpawnedInRound", 		lastAttackWaveHQSpawnedInRound);

	ScriptManager:storeValue( "aaInTown", 							aaInTown );
	
end

function setTriggers()
	-- load all needed values after loading
	ScriptManager:addOnGameResumeTrigger( "loadValues", "loadValues", false );
	
	-- check if the player has units left
	ScriptManager:addOnUnitDestroyedTrigger( 0, -1, -1, "checkForEnd", "checkForEnd" , false );
	

	-- trigger for enemy wave spawn
	
	ScriptManager:addOnTurnStartTrigger( 1, -1, -1, "onEnemyTurnStart", "onEnemyTurnStart", false );
	
	
	
	ScriptManager:addOnUnitDestroyedTrigger( 0, Units.UNIT_SU_AA, -1, "onAAdestroyedTrigger", "onAAdestroyedTrigger", false );
	
	ScriptManager:addOnUnitSightedTrigger(1,Units.UNIT_DE_AIRFIELD,-1,true,"airfieldSighted","airfieldSighted",false) -- when either one of the airfields gets sighted --> play airfield cutscene

	-- trigger for bunkers
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_BUNKER,-1,"bunkerAttacked","bunkerAttacked",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_BUNKER,-1,"bunkerDestroyed","bunkerDestroyed",false)
	
	ScriptManager:addOnUnitSightedTrigger(1,Units.UNIT_DE_HQ,3,true,"depotSighted","depotSighted",false)

	ScriptManager:addOnUnitDestroyedTrigger(1, Units.UNIT_DE_HQ, 1, "onHQdestroyed" , "onHQdestroyed", false );

	for i = 1, 	#HQTriggerTiles  do
	ScriptManager:addOnEnterTileTrigger(HQTriggerTiles[i][1],HQTriggerTiles[i][2],0,-1,-1,true,"HQsighted","HQsighted",false)
	end

	ScriptManager:addOnUnitCapturedTrigger( 0, Units.UNIT_DE_AIRFIELD, 4, "onAirfieldNorthCaptured", "onAirfieldNorthCaptured", false );
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_DE_AIRFIELD, 4, "onAirfieldNorthDestroyed", "onAirfieldNorthDestroyed", false );
	
	
	ScriptManager:addOnUnitCapturedTrigger( 0, Units.UNIT_DE_AIRFIELD, 5, "onAirfieldNortheastCaptured", "onAirfieldNortheastCaptured", false );
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_DE_AIRFIELD, 5, "onAirfieldNortheastDestroyed", "onAirfieldNortheastDestroyed", false );


	ScriptManager:addOnUnitCapturedTrigger(0,Units.UNIT_DE_HQ,3,"depotCaptured","depotCaptured",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_HQ,3,"depotDestroyed","depotDestroyed",false)

end

function loadValues()
	
	AAsToMove 								= ScriptManager:getValue( "AAsToMove" );
	planesToDestroy 						= ScriptManager:getValue( "planesToDestroy" );
	airfieldsToCapture						= ScriptManager:getValue( "airfieldsToCapture" );
	bunkersToDestroy						= ScriptManager:getValue( "bunkersToDestroy" );
	
	spawnPlaneWaves							= ScriptManager:getValue( "spawnPlaneWaves" );
	lastPlaneWaveSpawnedInRound				= ScriptManager:getValue( "lastPlaneWaveSpawnedInRound" );
		
	spawnPlaneWaves2						= ScriptManager:getValue( "spawnPlaneWaves2" );
	lastPlaneWaveSpawnedInRound2			= ScriptManager:getValue( "lastPlaneWaveSpawnedInRound2" );	
	
	spawnAttackWavesMountain				= ScriptManager:getValue( "spawnAttackWavesMountain" );
	lastAttackWaveMountainSpawnedInRound	= ScriptManager:getValue( "lastAttackWaveMountainSpawnedInRound" );
	
	spawnAttackWavesHQ						= ScriptManager:getValue( "spawnAttackWavesHQ" );
	lastAttackWaveHQSpawnedInRound			= ScriptManager:getValue( "lastAttackWaveHQSpawnedInRound" );
	
	aaInTown 								= ScriptManager:getValue( "aaInTown" );
end





function removeUnits()
	ScriptManager:removeReinforcementsFromBase(playerDepot,Units.UNIT_SU_MOBILE_AA)
	
end

-- LOGIC FOR THE SPAWNING OF ENEMY WAVES:
function onEnemyTurnStart()
	-- set guard areas for some of the squads
	ScriptManager:setGuardArea( 1, enemySquadIds.airfieldNorth, 8, 24, 1 );
	ScriptManager:setGuardArea( 1, enemySquadIds.airfieldNortheast, 18, 21, 1 );
	ScriptManager:setGuardArea( 1, enemySquadIds.germanHQ, 20, 3, 2 );

	-- spawn logic for planeWaves
	if spawnPlaneWaves == 1 then -- should waves spawn? 1 == yes, 0 == no , in diesem Fall ist 1 = true, da "true" nicht im safefile gespeichert wird
		-- check if a wave spawns this round
		if lastPlaneWaveSpawnedInRound + planeWaveRespawnInterval <= ScriptManager:getCurrentRound() then
			-- spawn the units
			for i = 1, #planeAttackWaveUnits do
				spawnWaveUnit( planeAttackWaveUnits[i] );
			end
			
			lastPlaneWaveSpawnedInRound = ScriptManager:getCurrentRound(); -- reset round count
			ScriptManager:storeValue( "lastPlaneWaveSpawnedInRound",	lastPlaneWaveSpawnedInRound );			
		end
	end


	-- spawn logic for planeWaves 2
	if spawnPlaneWaves2 == 1 then
		-- check if a wave spawns this round
		if lastPlaneWaveSpawnedInRound2 + planeWaveRespawnInterval2 <= ScriptManager:getCurrentRound() then
			-- spawn the units
			for i = 1, #planeAttackWaveUnits2 do
				spawnWaveUnit (planeAttackWaveUnits2 [i])
			end
			
			lastPlaneWaveSpawnedInRound2 = ScriptManager:getCurrentRound();
			ScriptManager:storeValue(("lastPlaneWaveSpawnedInRound2"), lastPlaneWaveSpawnedInRound2)
			
		end
	end
	

	-- spawn logic for AttackWavesMountain
	if spawnAttackWavesMountain == 1 then 	-- should waves spawn? 1 == yes, 0 == no , in diesem Fall ist 1 = true, da "true" nicht im safefile gespeichert wird	
		-- check if a wave spawns this round
		if lastAttackWaveMountainSpawnedInRound + AttackWaveMountainRespawnInterval <= ScriptManager:getCurrentRound() then
			-- spawn the units
			for i = 1, #AttackWaveUnitsMountain do
				spawnWaveUnit( AttackWaveUnitsMountain[i] );
			end
			
			lastAttackWaveMountainSpawnedInRound = ScriptManager:getCurrentRound(); -- reset round count
			ScriptManager:storeValue( "lastAttackWaveMountainSpawnedInRound",	lastAttackWaveMountainSpawnedInRound );			
		end
	end



	-- spawn logic for AttackWavesHQ
	if spawnAttackWavesHQ	 == 1 then 	-- should waves spawn? 1 == yes, 0 == no , in diesem Fall ist 1 = true, da "true" nicht im safefile gespeichert wird	
		-- check if a wave spawns this round
		if lastAttackWaveHQSpawnedInRound + AttackWaveHQRespawnInterval <= ScriptManager:getCurrentRound() then
			-- spawn the units
			for i = 1, #AttackWaveUnitsHQ  do
				spawnWaveUnit( AttackWaveUnitsHQ [i] );
			end
			
			lastAttackWaveHQSpawnedInRound = ScriptManager:getCurrentRound(); -- reset round count
			ScriptManager:storeValue( "lastAttackWaveHQSpawnedInRound",	lastAttackWaveHQSpawnedInRound );			
		end
	end
end

function spawnWaveUnit( spawnData )
	local unit = ScriptManager:spawnUnit( spawnData[1], spawnData[2], spawnData[3], spawnData[4], spawnData[5], spawnData[6] );
	
end




-- cutscene1: planes attacking the city and two Soviet units
function startIntroCutscene()
	StartCutscene();
	--ScriptManager:startCutscene()
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_INTRO_FLAVOR_01 )
	ScriptManager:wait(5)
	ScriptManager:dismissSubtitle()
	
	ScriptManager:moveCameraEx(6,15,0.7,2,true)
	
	ScriptManager:revealFogOfWar(6,15,2,true)
	ScriptManager:wait(2)
	ScriptManager:moveUnitEx(13,7,16,true)
	ScriptManager:moveUnitEx(15,6,16,true)
	ScriptManager:attackUnitEx(13,7,true)
	ScriptManager:wait(1)
	ScriptManager:removeUnitEx(7,true)
	ScriptManager:attackUnitEx(15,14,true)
	ScriptManager:wait(1)
	ScriptManager:removeUnitEx(14,true)
	ScriptManager:moveUnitEx(13,7,21,true)
	ScriptManager:moveUnitEx(15,6,21,true)
	ScriptManager:removeUnitEx(13,true)
	ScriptManager:removeUnitEx(15,true)
	ScriptManager:revealFogOfWar(6,15,2,false)
	
	ScriptManager:moveCameraEx(2,2,0.7,2,true)
	
	ScriptManager:wait(1)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_INTRO_FLAVOR_02 )
	ScriptManager:wait(5)
	ScriptManager:dismissSubtitle()
	
	EndCutscene()
	--ScriptManager:stopCutscene()
	
	moveAA() -- Move AAs into the city

end

function onAAdestroyedTrigger()

	ScriptManager:runForPlayer( 0, "onAADestroyed" );

end


function onAADestroyed()
	ScriptManager:displaySubtitle( Text. T_MAP_SU_5_1_MISSION_INTRO_FLAVOR_03 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	ScriptManager:removeTrigger( "onAAdestroyedTrigger" );
end
	
-- when the airfields are captured, the spawning of planes stops
function onAirfieldNorthCaptured()
	spawnPlaneWaves = 0;
	ScriptManager:storeValue( "spawnPlaneWaves", spawnPlaneWaves );
end


function onAirfieldNorthDestroyed()
	
	spawnPlaneWaves = 0;
	ScriptManager:storeValue( "spawnPlaneWaves", spawnPlaneWaves );

end


function onAirfieldNortheastCaptured()
	spawnPlaneWaves2 = 0;	
	ScriptManager:storeValue( "spawnPlaneWaves2", spawnPlaneWaves2 );
end

--[[	
		ScriptManager:setMissionProgress(missionIds.captureAirfields,ScriptManager:getMissionProgress(missionIds.captureAirfields) + 1)	

	if  ScriptManager:getMissionProgress(missionIds.captureAirfields) >= airfieldsToCapture then
		DisablePlayerInteraction();
		
		ScriptManager:setMissionStatus(missionIds.captureAirfields, MissionStatus.ACCOMPLISHED)
		
	else
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.captureAirfields ), Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_COUNTER )
	end
	
	spawnPlaneWaves2 = 0;
	
end

]]


function onAirfieldNortheastDestroyed()
		spawnPlaneWaves2 = 0;
	ScriptManager:storeValue( "spawnPlaneWaves2", spawnPlaneWaves2 );
end

--[[	
		ScriptManager:setMissionProgress(missionIds.captureAirfields,ScriptManager:getMissionProgress(missionIds.captureAirfields) + 1)	

	if  ScriptManager:getMissionProgress(missionIds.captureAirfields) >= airfieldsToCapture then
		DisablePlayerInteraction();
		
		ScriptManager:setMissionStatus(missionIds.captureAirfields, MissionStatus.ACCOMPLISHED)
		
	else
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.captureAirfields ), Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_COUNTER )
		
	end
	
	spawnPlaneWaves2 = 0;
	ScriptManager:storeValue( "spawnPlaneWaves2", spawnPlaneWaves2 );
end
]]

--Alternatives: if the player goes directly for the airfields, bunkers, depot or HQ
	
function airfieldSighted()
	destroyPlanes()
	ScriptManager:removeTrigger("airfieldSighted")


end


function bunkerAttacked()
	ScriptManager:runForPlayer(0,"destroyBunkers")
	ScriptManager:removeTrigger("bunkerAttacked")
end



function depotSighted()
	captureDepot()
	ScriptManager:removeTrigger("depotSighted")
end


function HQsighted()
	destroyHQ()
	ScriptManager:removeTrigger("HQsighted")
end

	
function moveAA() -- Move AAs into the city

	ScriptManager:setMissionStatus(missionIds.moveAA,MissionStatus.IN_PROGRESS)
	
	for i = 1, #cityTriggerTiles do
	ScriptManager:addOnEnterTileTrigger( cityTriggerTiles[i][1], cityTriggerTiles[i][2], 0, Units.UNIT_SU_AA, -1, true, "AAmoved", "AAmoved", false)
	
	
	end

end

function AAmoved( posX, posY, playerId, templateid, unitId )

	
	if aaInTown ~= unitId then
		ScriptManager:setMissionProgress( missionIds.moveAA, ScriptManager:getMissionProgress(missionIds.moveAA) + 1 );
		aaInTown = unitId;	
		ScriptManager:storeValue( "aaInTown", aaInTown );
	
		if ScriptManager:getMissionProgress( missionIds.moveAA ) >= AAsToMove then	
			
			ScriptManager:setMissionStatus( missionIds.moveAA,MissionStatus.ACCOMPLISHED );
			ScriptManager:removeTrigger("AAmoved")
			
			spawnPlaneWaves = 1;
			ScriptManager:storeValue( "spawnPlaneWaves", spawnPlaneWaves );
			
			if checkForVictory() == false then
				
				if ScriptManager:getMissionStatus( missionIds.destroyPlanes ) == MissionStatus.NOT_STARTED then
				shootDownPlanes();
				end
			end
		end
	end

	ScriptManager:storeValue( "spawnPlaneWaves", spawnPlaneWaves );
end



function shootDownPlanes() -- Destroy 5 German planes
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_01_FLAVOR_01 )
	ScriptManager:wait(6)
	ScriptManager:dismissSubtitle()
	ScriptManager:stopCutscene()
	ScriptManager:removeTrigger("shootDownPlanes")
	ScriptManager:wait(1)
	ScriptManager:setMissionStatus(missionIds.destroyPlanes,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionProgress(missionIds.destroyPlanes,0)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_DESTROYER,-1,"planeDestroyed","planeDestroyed",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_FIGHTER,-1,"planeDestroyed","planeDestroyed",false)

end



function planeDestroyed()
	ScriptManager:setMissionProgress(missionIds.destroyPlanes, ScriptManager:getMissionProgress( missionIds.destroyPlanes ) + 1 );
	
	ScriptManager:runForPlayer( 0, "showPlaneDestroyedProgress" );
end

function showPlaneDestroyedProgress()
	if  ScriptManager:getMissionProgress(missionIds.destroyPlanes) >= planesToDestroy then
		DisablePlayerInteraction();
		
		ScriptManager:setMissionStatus(missionIds.destroyPlanes, MissionStatus.ACCOMPLISHED)
		ScriptManager:removeTrigger("planeDestroyed")
		ScriptManager:removeTrigger("airfieldSighted")
		ScriptManager:wait( 2 );
		
		EnablePlayerInteraction();
		
		if checkForVictory() == false then
			if ScriptManager:getMissionStatus( missionIds.captureAirfields ) == MissionStatus.NOT_STARTED then
				destroyPlanes();
				ScriptManager:removeTrigger( "destroyPlanes" )
			end
		end
		
	else
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.destroyPlanes ), Text.T_MAP_SU_5_1_MISSION_PRIMARY_02_COUNTER );
		
	end
	
	
		
end

function destroyPlanes()
	
	-- cutscene shows the two airfields and the two new AA units
	
	ScriptManager:startCutscene() 
	
	ScriptManager:wait(2)
	
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_02_FLAVOR_01 )
	
	ScriptManager:moveCameraEx(8,24,0.7,2,true)
	ScriptManager:revealFogOfWar(8,24,1,true)
	ScriptManager:showMarkerAt(8,24)
	ScriptManager:wait(2)
	
	ScriptManager:moveCameraEx(18,21,0.7,2,true)
	ScriptManager:revealFogOfWar(18,21,1,true)
	ScriptManager:showMarkerAt(18,21)
	ScriptManager:wait(2)
	
	ScriptManager:dismissSubtitle()
	
	ScriptManager:moveCameraEx(4,9,0.7,2,true)	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_02_FLAVOR_02 ) -- 1x Mortar, 1x Rifle, 1x T34 and 2 new mobile AA Units spawn near the bridge
	ScriptManager:wait(6)
	ScriptManager:dismissSubtitle()
	ScriptManager:revealFogOfWar(4,9,2,true)
	ScriptManager:revealFogOfWar(8,24,1,false)
	ScriptManager:revealFogOfWar(18,21,1,false)	
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_MOBILE_AA,	4, 9, -1, AiState.WAIT ) 
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_MOBILE_AA,	4, 9, -1, AiState.WAIT )
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_MORTAR,		4, 9, -1, AiState.WAIT )
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE,		4, 9, -1 ,AiState.WAIT )
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_TANK_T34,		4, 9, -1, AiState.WAIT )
	ScriptManager:wait(2)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_02_FLAVOR_03 )
	ScriptManager:wait(3)
	ScriptManager:dismissSubtitle()
	ScriptManager:removeAllMarkers()
	ScriptManager:stopCutscene()
	
	ScriptManager:spawnUnit( 1, Units.UNIT_DE_FIGHTER, 18, 22, 0, AiState.AIRPLANE );
	ScriptManager:spawnUnit( 1, Units.UNIT_DE_FIGHTER, 18, 23, 0, AiState.AIRPLANE );
	
	spawnPlaneWaves2			= 1
	ScriptManager:storeValue( "spawnPlaneWaves2", spawnPlaneWaves2 );
	
	if ScriptManager:getMissionStatus( missionIds.captureAirfields ) == MissionStatus.NOT_STARTED then
		captureAirfields();
	end

	respawnDepot()
end	

function respawnDepot()
	local depot = Unit:getUnitById( playerDepot );
	local health = depot:getHealth();
	local tileX = depot:getX();
	local tileY = depot:getY();
	ScriptManager:removeUnitEx(playerDepot, true );
	
	local newDepot = ScriptManager:spawnUnit( 0, Units.UNIT_SU_HQ,2,2, 0, AiState.DEFEND );
	newDepot:setHealth( health );
end





function captureAirfields() -- capture or destroy the two airfields	
	ScriptManager:setMissionStatus(missionIds.captureAirfields,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionProgress(missionIds.captureAirfields,0)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03 )
	ScriptManager:wait(3)
	ScriptManager:dismissSubtitle()
	
	ScriptManager:addOnUnitCapturedTrigger	(0,Units.UNIT_DE_AIRFIELD,-1,"airfieldCaptured","airfieldCapturedDestroyed",false)
	ScriptManager:addOnUnitDestroyedTrigger	(1,Units.UNIT_DE_AIRFIELD,-1,"airfieldDestroyed","airfieldCapturedDestroyed",false)


end	


function airfieldCaptured( capturer, airfield )
	airfieldDestroyed( airfield )
end


function airfieldDestroyed( airfield )
	local airfieldId = airfield:getId();
	
	if buildingIds.airfieldNorth == airfieldId then
	spawnPlaneWaves = 0
	ScriptManager:storeValue("spawnPlaneWaves",spawnPlaneWaves)
	
	elseif buildingIds.airfieldNortheast == airfieldId then
	spawnPlaneWaves2 = 0
	ScriptManager:storeValue("spawnPlaneWaves2",spawnPlaneWaves2)
	
	end

	ScriptManager:setMissionProgress(missionIds.captureAirfields,ScriptManager:getMissionProgress(missionIds.captureAirfields) + 1)	

	if  ScriptManager:getMissionProgress(missionIds.captureAirfields) >= airfieldsToCapture then
		DisablePlayerInteraction();
		
		ScriptManager:setMissionStatus(missionIds.captureAirfields, MissionStatus.ACCOMPLISHED)
		if ScriptManager:getMissionStatus( missionIds.destroyPlanes ) ~= MissionStatus.ACCOMPLISHED then
			ScriptManager:setMissionStatus( missionIds.destroyPlanes, MissionStatus.ACCOMPLISHED );
			ScriptManager:removeTrigger( "planeDestroyed" );
			
		end
		ScriptManager:removeTrigger("airfieldCapturedDestroyed")
		
		
		
		ScriptManager:wait( 2 );
		EnablePlayerInteraction();
		ScriptManager:startCutscene()
		ScriptManager:wait(2)
		ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_FLAVOR_01 )
		ScriptManager:wait(2)
		ScriptManager:dismissSubtitle()
		
		
		if ScriptManager:getMissionStatus( missionIds.destroyBunkers ) == MissionStatus.NOT_STARTED then
			bunkerCutsceneContent()
		end
		
		if ScriptManager:getMissionStatus( missionIds.captureDepot ) == MissionStatus.NOT_STARTED then
			depotCutsceneContent()
		end
		
		if ScriptManager:getMissionStatus( missionIds.captureDepot ) == MissionStatus.NOT_STARTED then
			hqCutsceneContent()
		end
		
		ScriptManager:stopCutscene()
		
		if checkForVictory() == false then
			if ScriptManager:getMissionStatus( missionIds.captureHQ ) == MissionStatus.NOT_STARTED then
				destroyHQ();
				ScriptManager:removeTrigger( "HQsighted" )
			end
		end

		if ScriptManager:getMissionStatus( missionIds.destroyBunkers ) == MissionStatus.NOT_STARTED then
			destroyBunkers() -- destroy bunkers
			ScriptManager:removeTrigger( "bunkerAttacked" )
		end
		
		if ScriptManager:getMissionStatus( missionIds.captureDepot ) == MissionStatus.NOT_STARTED then
			captureDepot()
			ScriptManager:removeTrigger( "depotSighted" )
		end
		
	else
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.captureAirfields ), Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_COUNTER )
		
	end
	
	
	local depot = Unit:getUnitById( buildingIds.depotMountainPass )
	
	if depot ~= nil then
		if depot:getPlayerId() == 1 then
			spawnAttackWavesMountain = 1;
			ScriptManager:storeValue( "spawnAttackWavesMountain", spawnAttackWavesMountain );
		end
	end
	
end

function bunkerCutsceneContent()
	ScriptManager:moveCameraEx(12,12,0.7,2,false )
	
	ScriptManager:wait(1)
	ScriptManager:revealFogOfWar(12,12,1,true)
	ScriptManager:wait(2)
	ScriptManager:showMarkerAt(13,12)
	ScriptManager:showMarkerAt(11,11)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_FLAVOR_02 )
	ScriptManager:wait(6)
	ScriptManager:dismissSubtitle()	
			
	
	
	ScriptManager:wait(2)
	ScriptManager:removeAllMarkers()
	ScriptManager:revealFogOfWar(12,12,1,false)
	
end

function depotCutsceneContent()
	ScriptManager:moveCameraEx(13,8,0.7,2,true)
			
	ScriptManager:revealFogOfWar(13,8,1,true)
	ScriptManager:wait(1)
	ScriptManager:showMarkerAt(13,8)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_FLAVOR_03 )
	ScriptManager:wait(6)
	ScriptManager:removeAllMarkers()
	ScriptManager:revealFogOfWar(13,8,1,false)
	
	ScriptManager:dismissSubtitle();
end

function hqCutsceneContent()
	ScriptManager:moveCameraEx(20,3,0.7,2,true)
		
	ScriptManager:revealFogOfWar(20,3,1,true)
	ScriptManager:showMarkerAt(20,3)
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_FLAVOR_04 )
	ScriptManager:wait( 7 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_PRIMARY_03_FLAVOR_05 );
	ScriptManager:wait( 5 ) 
	ScriptManager:dismissSubtitle();	
		
	ScriptManager:moveCameraEx(18,23,0.7,2,true)
		
	ScriptManager:wait(1)
		
		
	ScriptManager:revealFogOfWar(20,3,1,false)
	ScriptManager:removeAllMarkers()
end

function destroyBunkers() -- destroy bunkers
	ScriptManager:removeTrigger( "bunkerAttacked" );
	ScriptManager:startCutscene();
	bunkerCutsceneContent();
	ScriptManager:stopCutscene()
	--destroyBunkers()
	ScriptManager:setMissionStatus(missionIds.destroyBunkers,MissionStatus.IN_PROGRESS)
		
end


function bunkerDestroyed()		
	  	ScriptManager:setMissionProgress(missionIds.destroyBunkers,ScriptManager:getMissionProgress(missionIds.destroyBunkers) + 1)	
		ScriptManager:runForPlayer( 0, "bunkerProgress" );
		
end

function bunkerProgress()
	if	ScriptManager:getMissionProgress(missionIds.destroyBunkers) >= bunkersToDestroy then
		
		DisablePlayerInteraction();
		ScriptManager:displaySubtitle(Text.T_MAP_SU_5_1_MISSION_SECONDARY_01_FLAVOR_01)
		ScriptManager:wait(3)
		ScriptManager:dismissSubtitle()
		ScriptManager:setMissionStatus(missionIds.destroyBunkers,MissionStatus.ACCOMPLISHED)
		ScriptManager:removeTrigger("bunkerDestroyed")
		EnablePlayerInteraction()
		
		if ScriptManager:getMissionStatus( missionIds.captureDepot ) == MissionStatus.NOT_STARTED then
			captureDepot() -- capture or destroy depot
			ScriptManager:removeTrigger( "depotSighted" )
		end
		
	
	else 
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.destroyBunkers ), Text.T_MAP_SU_5_1_MISSION_SECONDARY_01_COUNTER );
		
	end

end


function captureDepot() --capture or destroy depot
	ScriptManager:removeTrigger( "depotSighted" );
	ScriptManager:setMissionStatus(missionIds.captureDepot,MissionStatus.IN_PROGRESS)
	
	

end


function onHQdestroyed()
	
	if ScriptManager:getMissionStatus( missionIds.captureAirfields ) == MissionStatus.NOT_STARTED then
		captureAirfields()	
	end
	
	spawnAttackWavesHQ = 0;
	ScriptManager:storeValue( "spawnAttackWavesHQ", spawnAttackWavesHQ );
	ScriptManager:setMissionStatus( missionIds.captureHQ, MissionStatus.ACCOMPLISHED );
end


function depotCaptured()
	
	DisablePlayerInteraction()
	
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_SECONDARY_02_FLAVOR_01 )
	ScriptManager:wait(3)
	ScriptManager:dismissSubtitle()
	ScriptManager:setMissionStatus(missionIds.captureDepot,MissionStatus.ACCOMPLISHED)
	
	
	spawnAttackWavesMountain = 0;
	
	local depot = Unit:getUnitById( buildingIds.germanHQ )
	
	if depot ~= nil then
		if depot:getPlayerId() == 1 then
			spawnAttackWavesHQ = 1	
			ScriptManager:storeValue( "spawnAttackWavesMountain", spawnAttackWavesMountain );
		end
	end
	
	ScriptManager:storeValue( "spawnAttackWavesHQ", spawnAttackWavesHQ );
	EnablePlayerInteraction()
	
end


function depotDestroyed()
	spawnAttackWavesMountain = 0;
	ScriptManager:storeValue( "spawnAttackWavesMountain", spawnAttackWavesMountain );
	local depot = Unit:getUnitById( buildingIds.germanHQ )
	
	if depot ~= nil then
		if depot:getPlayerId() == 1 then
			spawnAttackWavesHQ = 1	
		end
	end
	
	ScriptManager:setMissionStatus( missionIds.captureDepot, MissionStatus.ACCOMPLISHED );

end



function destroyHQ() -- capture or destroy HQ
	ScriptManager:removeTrigger( "HQSighted" )
	ScriptManager:setMissionStatus(missionIds.captureHQ,MissionStatus.IN_PROGRESS)
	ScriptManager:addOnUnitCapturedTrigger(0,Units.UNIT_DE_HQ,1,"HQcaptured","HQcaptured",false)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_HQ,1,"HQcaptured","HQcaptured",false)
	
	
end


function checkForVictory()

	if  
	ScriptManager:getMissionStatus(missionIds.moveAA) 			== MissionStatus.ACCOMPLISHED 	and
	ScriptManager:getMissionStatus(missionIds.destroyPlanes) 	== MissionStatus.ACCOMPLISHED 	and
	ScriptManager:getMissionStatus(missionIds.captureAirfields) == MissionStatus.ACCOMPLISHED 	and
	ScriptManager:getMissionStatus(missionIds.captureHQ) 		== MissionStatus.ACCOMPLISHED 	then	

	startVictoryCutscene()
	return true;

	end
	
	
	return false;
end

--[[
	{missionIds.moveAA, 			true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_01,				75 }, 		-- Mission_Primary_01		
	{missionIds.destroyPlanes, 		true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_02,				100},		-- Mission_Primary_02
	{missionIds.captureAirfields, 	true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_03,				100},		-- Mission_Primary_03
	{missionIds.captureHQ, 			true, 	Text.T_MAP_SU_5_1_MISSION_PRIMARY_04,				200},		-- Mission_Primary_04

]]



function HQcaptured()
		
	if ScriptManager:getMissionStatus( missionIds.captureAirfields ) == MissionStatus.NOT_STARTED then
		captureAirfields()	
	end
	
	
	spawnAttackWavesHQ = 0;
	ScriptManager:storeValue( "spawnAttackWavesHQ", spawnAttackWavesHQ );
	spawnAttackWavesMountain = 0;
	ScriptManager:storeValue( "spawnAttackWavesMountain", spawnAttackWavesMountain );
	
	ScriptManager:setMissionStatus(missionIds.captureHQ,MissionStatus.ACCOMPLISHED)
	
	if checkForVictory() == false then
			if ScriptManager:getMissionStatus( missionIds.captureHQ ) == MissionStatus.NOT_STARTED then
				destroyHQ();
				ScriptManager:removeTrigger( "HQcaptured" )
			end
		end
	
end


--[[	
function startVictoryCutscene()
	
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle( Text.T__MAP_SU_5_1_MISSION_OUTRO_FLAVOR_01 )
	ScriptManager:wait(3)
	ScriptManager:dismissSubtitle()
	
	ScriptManager:wait(2)
	
	checkForVictory()
	
		
end
]]


function checkForEnd()
	if ScriptManager:noUnitsLeft( 0 ) then
		ScriptManager:runForPlayer( 0, "missionFailed" )
	end
end

function missionFailed()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens
	
	ScriptManager:displaySubtitle( Text.T_MISSION_FAILED );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
	
end


function endGame()
	ScriptManager:endGame()
end



function startVictoryCutscene()
	StartCutscene();
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle( Text.T_MAP_SU_5_1_MISSION_OUTRO_FLAVOR_01 );
	ScriptManager:wait( 5 );
	HideDialogue();
	
	EndCutscene();
	
	--checkForVictory()
	
	victoryEndGame();
end



function victoryEndGame()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens

	-- accomplish secondary missions that are accomplished when the game is finished with certain condition
	
	
	ScriptManager:displaySubtitle( Text.T_MISSION_VICTORY );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
end