require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"


-- mission stuff
missionIds = {

--		doNotLoseNorthernDepot 	= 1,
--		doNotLoseSouthernDepot	= 2,
		
		defendNorthernBridge	= 1,
		defendSouthernBridge	= 2,
		CaptureGermanHQ			= 3,
		killEnemiesWithElite	= 4,
		escortAA				= 5,
		protectAirfield			= 6,
};

-- missionId, primary( boolean ), textkey, xpReward
missions = {
	{ missionIds.defendNorthernBridge, 	true, Text.T_MAP_SU_6_3_MISSION_PRIMARY_01, 75 }, -- do not lose the northern depot
	{ missionIds.defendSouthernBridge, 	true, Text.T_MAP_SU_6_3_MISSION_PRIMARY_02, 75 }, -- do not lose the southern depot
	
--	{missionIds.doNotLoseNorthernDepot, true, Text.T_MAP_SU_6_3_MISSION_PRIMARY_01, 75 },
--	{missionIds.doNotLoseSouthernDepot, true, Text.T_MAP_SU_6_3_MISSION_PRIMARY_02, 75 },	
	
	{ missionIds.CaptureGermanHQ, 		true, Text.T_MAP_SU_6_3_MISSION_PRIMARY_03, 50 },
	{ missionIds.killEnemiesWithElite,	false,Text.T_MAP_SU_6_3_MISSION_SECONDARY_01, 25 },
	{ missionIds.escortAA, 				false,Text.T_MAP_SU_6_3_MISSION_SECONDARY_02, 25 },
	{ missionIds.protectAirfield,		false,Text.T_MAP_SU_6_3_MISSION_SECONDARY_03, 25 },		
};



playerBuildingIds = {

depotNorth	= 0,
depotSouth 	= 1,
airfield	= 2,

};


enemySquadIds = {

attackWave1 = 1,
attackWave2	= 2,
attackWave3	= 3,
attackWave4	= 4,
attackWave5	= 5,
attackWave6	= 6,

planes		= 7,
bombersquad = 8,
AntiAirsHQ	= 9,

squadNorth1 = 10,
squadNorth2 = 11,
squadMiddle = 12,
squadMiddle2 = 13,
squadSouth = 14,
artilleryNorth = 15,
artillerySouth = 16,

bunkerSouth = 17,
bunkerNorth = 18,


AntiAir1 = 19,
AntiAir2 = 20,
AntiAir3 = 21,
AntiAir4 = 22,

fighterplane1 = 23,

fighterplane2 = 24,

};


attackWave1 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			14, 32, enemySquadIds.attackWave1, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	14, 32, enemySquadIds.attackWave1, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_3, 			14, 32, enemySquadIds.attackWave1, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	14, 32, enemySquadIds.attackWave1, AiState.ATTACK_AGGRESSIVE };
};


attackWave2 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			22, 9, enemySquadIds.attackWave2, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	22, 9, enemySquadIds.attackWave2, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_4, 			22, 9, enemySquadIds.attackWave2, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	22, 9, enemySquadIds.attackWave2, AiState.ATTACK_AGGRESSIVE };
};


attackWave3 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			14, 32, enemySquadIds.attackWave3, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	14, 32, enemySquadIds.attackWave3, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_4, 			14, 32, enemySquadIds.attackWave3, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	14, 32, enemySquadIds.attackWave3, AiState.ATTACK_AGGRESSIVE };
};


attackWave4 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			22, 9, enemySquadIds.attackWave4, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	22, 9, enemySquadIds.attackWave4, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_3, 			22, 9, enemySquadIds.attackWave4, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	22, 9, enemySquadIds.attackWave4, AiState.ATTACK_AGGRESSIVE };
};

attackWave5 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			14, 32, enemySquadIds.attackWave5, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	14, 32, enemySquadIds.attackWave5, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_3, 			14, 32, enemySquadIds.attackWave5, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	14, 32, enemySquadIds.attackWave5, AiState.ATTACK_AGGRESSIVE };
};


attackWave6 = {
--	 playerId, templateID, tileX, tileY, squadId, AiState
	{ 1, Units.UNIT_DE_MP40, 			22, 9, enemySquadIds.attackWave6, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_PANZERFAUST, 	22, 9, enemySquadIds.attackWave6, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_TANK_3, 			22, 9, enemySquadIds.attackWave6, AiState.ATTACK_AGGRESSIVE };
	{ 1, Units.UNIT_DE_ANTI_INFANTRY, 	22, 9, enemySquadIds.attackWave6, AiState.ATTACK_AGGRESSIVE };
};



-- waves that spawn

-- I spawn either one destroyer or one Bomber depending on the number of spawns and the round count
-- ( every x turns I spawn a plane wave (Destroyer) and every y turns the bomber spawns instead of fighters )
spawnPlaneWaves				=  0; -- 0 == false; 1 == true; can't save booleans so I have to use numbers
planeWaveRespawnInterval	=  4; -- defines how often waves will spawn
numberOfPlaneWavesSpawned	=  0; -- the number of plane waves that have already spawned in this game
lastPlaneWaveSpawnedInRound	= -3; -- indicates the round in which the last wave spawned 
planeWaveUnits = {
--	playerId,		 templateID, 			tileX, 		tileY,		squadID			AiState
	{ 1,			Units.UNIT_DE_FIGHTER,		21,			20,		  	enemySquadIds.planes, AiState.ATTACK_AGGRESSIVE },
	{ 1,			Units.UNIT_DE_DESTROYER,	29,			3,			enemySquadIds.planes, AiState.ATTACK_AGGRESSIVE },		
}

planeWave1 = {
--	playerId, 	templateID, 	tileX, tileY, squadID,	AiState
	{ 1, Units.UNIT_DE_FIGHTER, 21, 20, enemySquadIds.planes, AiState.ATTACK_AGGRESSIVE },
};

planeWave2 = {
--	playerId, 	templateID, 	tileX, tileY, squadID,	AiState
	{ 1, Units.UNIT_DE_DESTROYER, 20, 19, enemySquadIds.planes, AiState.ATTACK_AGGRESSIVE },
};

planeWave3 = {
--	playerId, 	templateID, 	tileX, tileY, squadID,	AiState
	{ 1, Units.UNIT_DE_FIGHTER, 21, 19, enemySquadIds.planes, AiState.ATTACK_AGGRESSIVE },
};


bomberSquad = {
--	playerId, 	templateID, 	tileX, tileY, squadID,	AiState
	{ 1, Units.UNIT_DE_BOMBER, 21, 20, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE },
	{ 1, Units.UNIT_DE_BOMBER, 20, 19, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE },
	{ 1, Units.UNIT_DE_BOMBER, 21, 19, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE },
};



enemyHQ = 4;
enemyAirfield = 3;

attackersToKillNorthernBridge = 10;
attackersToKillSouthernBridge = 10;

unitsKilledbyElite = 10;
antiAirsEscorted = 2;


--SubtitleQueue = {}

attackersNorthKilled = {}
attackersSouthKilled = {}


attackersToDestroy = 13;


-- BEGIN Init


function onGameStart()
	CreateMissions( missions );
	setTriggers();
	storeValues();
	
	ScriptManager:gainGold( 0, 1000 );
	
	ScriptManager:fortifyUnit( 14 );
	ScriptManager:fortifyUnit( 12 );
	ScriptManager:fortifyUnit( 13 );
	ScriptManager:fortifyUnit( 15 );
	ScriptManager:fortifyUnit( 27 );
	ScriptManager:fortifyUnit( 28 );
	ScriptManager:fortifyUnit( 21 );
	ScriptManager:fortifyUnit( 31 );
	ScriptManager:fortifyUnit( 22 );
	ScriptManager:fortifyUnit( 25 );
	ScriptManager:fortifyUnit( 20 );	
	
--	local depotNorth = playerBuildingIds.depotNorth
--	local depotSouth = playerBuildingIds.depotSouth
--	
--	depotNorth:setHealth( depotNorth:getHealth() * 0.55 );
--	depotSouth:setHealth( depotSouth:getHealth() * 0.55 );


--	playerBuildingIds.depotNorth:setHealth(playerBuildingIds.depotNorth:getHealth() * 0.55 );
--	playerBuildingIds.depotSouth:setHealth(playerBuildingIds.depotSouth:getHealth() * 0.55 ); --TODO Fix this shit!
	


	-- start intro cutscene
	ScriptManager:sleep( 0, "startIntroCutscene" ); -- without sleep player turn popup shows
end


function storeValues()
--	
--	ScriptManager:storeValue( "attackersNorthKilled", attackersNorthKilled );
--	ScriptManager:storeValue( "attackersSouthKilled", attackersSouthKilled );
end
	



function setTriggers()
	-- load all needed values after loading
	ScriptManager:addOnGameResumeTrigger( "loadValues", "loadValues", false );
	
	-- check if the player has units left
	ScriptManager:addOnUnitDestroyedTrigger( 0, -1, -1, "checkForEnd", "checkForEnd" , false );
	
	-- starts the waves of attackers
	ScriptManager:addOnTurnStartTrigger( 1, -1, -1, "onEnemyTurnStart", "onEnemyTurnStart", false );
	
	
	-- if one of the depots get destroyed
	ScriptManager:addOnUnitDestroyedTrigger( 0, Units.UNIT_SU_HQ, 0, "onDepotDestroyed", "onDepotDestroyed", false );
	ScriptManager:addOnUnitDestroyedTrigger( 0, Units.UNIT_SU_HQ, 1, "onDepotDestroyed", "onDepotDestroyed", false );	
	
	
	-- set target tiles for the attacking waves
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave1, 8, 23 );
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave3, 8, 23 );
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave5, 8, 23 );
	
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave2, 8, 8 );
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave4, 8, 8 );	
	ScriptManager:setTargetTile( 1, enemySquadIds.attackWave6, 8, 8 );
	
	-- when units of the attacking waves at the northern bridge get destroyed
--	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "AttackerNorth", "AttackerNorth", false );
	
	-- when enemy units at the southern bridge get destroyed
--	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "AttackerSouth", "AttackerSouth", false );

	-- when an attacker gets detroyed
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, -1, "onAttackerDestroyed", "onAttackerDestroyed", false );
	
		
	-- when a unit is killed by a elite unit (in the player turn)
	ScriptManager:addOnUnitHasAttackedTrigger( -1, Units.UNIT_SU_RIFLE_ELITE, 		-1, "onKilledByElite", "onKilledByElite", false );
	ScriptManager:addOnUnitHasAttackedTrigger( -1, Units.UNIT_SU_MORTAR_ELITE, 		-1, "onKilledByElite", "onKilledByElite", false );
	ScriptManager:addOnUnitHasAttackedTrigger( -1, Units.UNIT_SU_ANTI_INFANTRY_ELITE,-1, "onKilledByElite", "onKilledByElite", false );	

	-- when a unit is killed by a elite unit (in the player turn)	
	ScriptManager:addOnUnitHasAttackedTrigger( -1, -1, -1, "onKilledByEliteEnemyTurn", "onKilledByEliteEnemyTurn", false );
	
	
	ScriptManager:addOnUnitDestroyedTrigger( 0, Units.UNIT_SU_MOBILE_AA, -1, "onMobileAAdestroyed", "onMobileAAdestroyed", false );

		
	-- when the AA guns have reached the airfield
	local x
	for x = 1, 7 do
		ScriptManager:addOnEnterTileTrigger( x, 27, 0, Units.UNIT_SU_MOBILE_AA, -1, false, "onAAenteredCity", "onAAenteredCity", false );
	end
	
	local y
	for y = 27, 32 do
		ScriptManager:addOnEnterTileTrigger( 7, y, 0, Units.UNIT_SU_MOBILE_AA, -1, false, "onAAenteredCity", "onAAenteredCity", false );
	end
	
	
	-- when the enemy airfield is captured or destroyed
	ScriptManager:addOnUnitCapturedTrigger( 0, Units.UNIT_DE_AIRFIELD, enemyAirfield, "onAirfieldCaptured", "onAirfieldCaptured", false );
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_DE_AIRFIELD, enemyAirfield, "onAirfieldCaptured", "onAirfieldCaptured", false );
	
	-- when he players airfield is destroyed
	ScriptManager:addOnUnitDestroyedTrigger( 0, Units.UNIT_SU_AIRFIELD, playerBuildingIds.airfield, "onPlayerAirfieldDestroyed", "onPlayerAirfieldDestroyed", false );
	
	-- triggers the German HQ cutscene/Mission
	local y
	for y = 6, 29 do
	ScriptManager:addOnEnterTileTrigger(15, y, 0, -1, -1, true, "playAlternativeHQCutscene", "playAlternativeHQCutscene", false );
	end
	
	local x
	for x = 15, 23 do
	ScriptManager:addOnEnterTileTrigger( x, 29, 0, -1, -1, true, "playAlternativeHQCutscene", "playAlternativeHQCutscene", false );
	end
	
	local x
	for x = 15, 23 do
	ScriptManager:addOnEnterTileTrigger( x, 7, 0, -1, -1, true, "playAlternativeHQCutscene", "playAlternativeHQCutscene", false );
	end
	
	-- when the German HQ gets captured/destroyed
	ScriptManager:addOnUnitCapturedTrigger( 0, Units.UNIT_DE_HQ, -1, "onHQcaptured", "onHQcaptured", false );
	ScriptManager:addOnUnitDestroyedTrigger( 1, Units.UNIT_DE_HQ, -1, "onHQcaptured", "onHQcaptured", false );
		
end

function loadValues()
	
end


-- END Init
-- BEGIN Intro Cutscene


function startIntroCutscene()
	StartCutscene();
	
	-- start at the left mapborder
	
	ScriptManager:revealFogOfWar( 2, 16, 2, true );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_INTRO_FLAVOR_01 );
	ScriptManager:wait( 6 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_INTRO_FLAVOR_02 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();

	-- move camera to the northern depot
	ScriptManager:moveCameraEx( 9, 25, 0.7, 2, true );
	ScriptManager:revealFogOfWar( 9, 25, 3, true );
		
	ScriptManager:wait( 1 );
	
	local attacker1 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_TANK_4, 13, 26, -1, AiState.ATTACK ):getId();
	local defender1 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_MORTAR_ELITE, 8, 24, -1, AiState.WAIT ):getId();
	local defender2 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_ANTI_INFANTRY_ELITE, 9, 23, -1, AiState.WAIT ):getId();
	
	
	ScriptManager:moveUnitEx( attacker1, 9, 25, true );
	ScriptManager:attackUnitEx( attacker1, playerBuildingIds.depotNorth, true );
	
	ScriptManager:wait( 1 );
	
	
	ScriptManager:attackUnitEx( defender1, attacker1, true );
	
	
	ScriptManager:attackUnitEx( defender2, attacker1, true );
	
	ScriptManager:moveUnitEx( attacker1, 16, 27, true );
	
	ScriptManager:revealFogOfWar( 9, 25, 3, false );
	
	ScriptManager:wait( 1 );
	
	--move camera to the southern depot
	ScriptManager:moveCameraEx( 10, 8, 0.7, 3, true );
	
	ScriptManager:revealFogOfWar( 10, 8, 3, true );
	
	local attacker2 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_MP40, 12, 7, -1, AiState.WAIT ):getId();
	local attacker3 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_PANZERFAUST, 13, 8, -1, AiState.WAIT ):getId();
	local defender3 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE_ELITE, 8, 9, -1, AiState.WAIT ):getId();
	local defender4 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE_ELITE, 8, 7, -1, AiState.WAIT ):getId();
	
	ScriptManager:moveUnitEx( attacker2, 9, 9, true );
	ScriptManager:moveUnitEx( attacker3, 10, 8, true );
	
	ScriptManager:attackUnitEx( attacker2, playerBuildingIds.depotSouth, true );
	ScriptManager:attackUnitEx( attacker3, playerBuildingIds.depotSouth, true );
	
	ScriptManager:attackUnitEx( defender3, attacker2, true );
	ScriptManager:attackUnitEx( defender4, attacker3, true );
	
	ScriptManager:moveUnitEx( attacker2, 14, 9, true );
	ScriptManager:moveUnitEx( attacker3, 15, 8, true );
		
	ScriptManager:revealFogOfWar( 10, 8, 3, false );
	
	ScriptManager:wait( 1 );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_INTRO_FLAVOR_03 );
		
	ScriptManager:wait( 1 );
	
	ScriptManager:moveCameraEx( 11, 7, 0.7, 3, true );
	
	ScriptManager:revealFogOfWar( 11, 7, 1, true );
	ScriptManager:wait( 2 );
	
	ScriptManager:moveCameraEx( 12, 26, 0.7, 3, true );
	
	ScriptManager:revealFogOfWar( 12, 26, 1, true );

	ScriptManager:wait( 2 );

	
	ScriptManager:revealFogOfWar( 11, 7, 1, false );
	ScriptManager:revealFogOfWar( 12, 26, 1, false );

	ScriptManager:wait( 2 );
	ScriptManager:dismissSubtitle();
	
	
	ScriptManager:moveCameraEx( 2, 16, 0.7, 2, true );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_INTRO_FLAVOR_04 );
	ScriptManager:wait( 6 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:revealFogOfWar( 2, 16, 2, false );
		
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE_ELITE, 7, 23, -1, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_MORTAR_ELITE, 7, 8, -1, AiState.WAIT );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_ANTI_INFANTRY_ELITE, 7, 7, -1, AiState.WAIT );
		
	EndCutscene();
	
	startTheMission();
end

function startTheMission()
	ScriptManager:setMissionStatus( missionIds.defendNorthernBridge, MissionStatus.IN_PROGRESS );
	ScriptManager:setMissionStatus( missionIds.defendSouthernBridge, MissionStatus.IN_PROGRESS );
	ScriptManager:setMissionStatus( missionIds.killEnemiesWithElite, MissionStatus.IN_PROGRESS );
	
		-- when a enemy unit tries to cross the northern bridge
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_MP40, -1, true, 			"playBridgeWarning", "playBridgeWarning", false );
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_PANZERFAUST, -1, true, 	"playBridgeWarning", "playBridgeWarning", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TANK_3, -1, true, 		"playBridgeWarning", "playBridgeWarning", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TANK_4, -1, true,			"playBridgeWarning", "playBridgeWarning", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TRANSPORT_TRUCK, -1, true,"playBridgeWarning", "playBridgeWarning", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_ANTI_INFANTRY, -1, true, 	"playBridgeWarning", "playBridgeWarning", false );
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TIGER, -1, true, 			"playBridgeWarning", "playBridgeWarning", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_SUPPLY_TRUCK, -1, true, 	"playBridgeWarning", "playBridgeWarning", false );	


	-- when a enemy unit tries to cross the northern bridge
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_MP40, -1, true, 			"playBridgeWarning2", "playBridgeWarning2", false );
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_PANZERFAUST, -1, true, 	"playBridgeWarning2", "playBridgeWarning2", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TANK_3, -1, true, 		"playBridgeWarning2", "playBridgeWarning2", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TANK_4, -1, true,			"playBridgeWarning2", "playBridgeWarning2", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TRANSPORT_TRUCK, -1, true,"playBridgeWarning2", "playBridgeWarning2", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_ANTI_INFANTRY, -1, true, 	"playBridgeWarning2", "playBridgeWarning2", false );
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_TIGER, -1, true, 			"playBridgeWarning2", "playBridgeWarning2", false );	
	ScriptManager:addOnEnterTileTrigger( 12, 26, 1, Units.UNIT_DE_SUPPLY_TRUCK, -1, true, 	"playBridgeWarning2", "playBridgeWarning2", false );	
	

	--ScriptManager:addOnUnitSelectedTrigger( 1, -1, -1, "showParameters", "showParameters",false)
end



function removeSquads()
	--for i = 1, # do
	--	ScriptManager:removeUnitEx( [i], false );
	--end
end

function showParameters( selectedUnit )
	--print( string.format( "[] %s", selectedUnit:get() ) );
end


-- END Intro Cutscene
-- BEGIN


-- insert missionstuff here


function onDepotDestroyed()	
	ScriptManager:removeTrigger( "onDepotDestroyed" );
	ScriptManager:runForPlayer( 0, "missionFailed" );
end


function onEnemyTurnStart()

	local currentRound = ScriptManager:getCurrentRound();
		
	if currentRound == 1 then
		for i = 1, #attackWave1 do
		spawnWave( attackWave1[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave1, 8, 23 );
		end
	

	elseif currentRound == 2 then
		local airfield = Unit:getUnitById( enemyAirfield );
		if airfield ~= nil then		
		local fighter1 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_FIGHTER, 21, 19, enemySquadIds.fighterplane1, AiState.ATTACK_AGGRESSIVE );
		ScriptManager:setTargetTile( 1, enemySquadIds.fighterplane1, 4, 30 );
		end

		for i = 1, #attackWave2 do
		spawnWave( attackWave2[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave2, 8, 8 );
		end
	
	elseif currentRound == 3 then
		ScriptManager:runForPlayer( 0, "playAACutscene")


	elseif currentRound == 4 then
		for i = 1, #attackWave3 do
		spawnWave( attackWave3[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave3, 8, 23 );	
		
		startRandomPlaneSpawn() -- start the plane waves
		ScriptManager:runForPlayer( 0, "playReinforcementCutscene" );
		end
	

	elseif currentRound == 5 then
		for i = 1, #attackWave4 do
		spawnWave( attackWave4[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave4, 8, 8 );	
		end

	
	elseif currentRound == 6 then	
		local airfield = Unit:getUnitById( enemyAirfield );
		if airfield ~= nil then		
		local fighter1 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_FIGHTER, 21, 19, enemySquadIds.fighterplane1, AiState.ATTACK_AGGRESSIVE );
		ScriptManager:setTargetTile( 1, enemySquadIds.fighterplane1, 4, 30 );
		end

	
	elseif currentRound == 7 then
		for i = 1, #attackWave5 do
		spawnWave( attackWave5[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave5, 8, 23 );
		end
	
	
	elseif currentRound == 8 then		
		local airfield = Unit:getUnitById( enemyAirfield );
		if airfield ~= nil then
		local fighter2 = ScriptManager:spawnUnit( 1, Units.UNIT_DE_FIGHTER, 21, 19, enemySquadIds.fighterplane2, AiState.ATTACK_AGGRESSIVE );
		ScriptManager:setTargetTile( 1, enemySquadIds.fighterplane2, 4, 30 );
		end
	
	
	elseif currentRound == 9 then
		for i = 1, #attackWave6 do
		spawnWave( attackWave6[i] );
		ScriptManager:setTargetTile( 1, enemySquadIds.attackWave6, 8, 8 );
		end	
	
	elseif currentRound == 10 then
		ScriptManager:runForPlayer( 0, "playReinforcementCutscene2" );
	end	
end



function spawnWave( spawnData )
	ScriptManager:spawnUnit( spawnData[1], spawnData[2], spawnData[3], spawnData[4],spawnData[5], spawnData[6] )
end


function playBridgeWarning()

	ScriptManager:removeTrigger( "playBridgeWarning" );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_FLAVOR_01 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
end



function playBridgeWarning2()
	ScriptManager:removeTrigger( "playBridgeWarning2" );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_FLAVOR_02 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
end


function onAttackerDestroyed()

	ScriptManager:setMissionProgress(missionIds.defendNorthernBridge, ScriptManager:getMissionProgress(missionIds.defendNorthernBridge) + 1 );
	
	if ScriptManager:getMissionProgress( missionIds.defendNorthernBridge ) >= attackersToDestroy then
		
		playHQCutscene()
	end 
end



function AttackerNorth( unit )
	
	if 	unit:getTemplateId() ~= Units.UNIT_DE_BOMBER	or
		unit:getTemplateId() ~= Units.UNIT_DE_DESTROYER or
		unit:getTemplateId() ~= Units.UNIT_DE_FIGHTER 	or
		
		unit:getSquadId() == enemySquadIds.attackWave1 	or
		unit:getSquadId() == enemySquadIds.attackWave3	or
		unit:getSquadId() == enemySquadIds.attackWave5	then
			
--		print ("beep")
		
		ScriptManager:setMissionProgress( missionIds.defendNorthernBridge, ScriptManager:getMissionProgress(missionIds.defendNorthernBridge) +1 );
--		ScriptManager:storeValue( "attackersNorthKilled", attackersNorthKilled );
	
		ScriptManager:runForPlayer( 0, "onAttackerNorthDestroyed" );
	
end


function onAttackerNorthDestroyed()
	table.insert( cutsceneQueue, startAttackerNorthCutscene );
--	SubtitleQueue()
end


function startAttackerNorthCutscene()
			
		ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.defendNorthernBridge ), Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_COUNTER );
		end	
	
	if ScriptManager:getMissionProgress( missionIds.defendNorthernBridge ) >= attackersToKillNorthernBridge then	
	
	ScriptManager:removeTrigger( "AttackerNorth" );
	ScriptManager:setMissionStatus( missionIds.defendNorthernBridge, MissionStatus.ACCOMPLISHED );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_FLAVOR_04 ); 
	
	startHQMission()
	end
end


function AttackerSouth( unit )
	
	if 	unit:getTemplateId() ~= Units.UNIT_DE_BOMBER 	and
		unit:getTemplateId() ~= Units.UNIT_DE_DESTROYER and
		unit:getTemplateId() ~= Units.UNIT_DE_FIGHTER 	then

		if 	unit:getSquadId() == enemySquadIds.attackWave2 	or
			unit:getSquadId() == enemySquadIds.attackWave4	or
			unit:getSquadId() == enemySquadIds.attackWave6	then
		
			ScriptManager:setMissionProgress( missionIds.defendSouthernBridge,ScriptManager:getMissionProgress(missionIds.defendSouthernBridge) +1 );
--			ScriptManager:storeValue( "attackersSouthKilled", attackersSouthKilled );
					
	ScriptManager:runForPlayer( 0, "onAttackerSouthDestroyed" );
		end
	end
end


function onAttackerSouthDestroyed()
	table.insert( cutsceneQueue, startAttackerSouthCutscene );
--	SubtitleQueue()
end

function startAttackerSouthCutscene()
	
	ShowMissionProgressPopup( ScriptManager:getMissionProgress( missionIds.defendSouthernBridge ), Text.T_MAP_SU_6_3_MISSION_PRIMARY_02_COUNTER );
			
	if ScriptManager:getMissionProgress( missionIds.defendSouthernBridge ) >= attackersToKillSouthernBridge then		
	ScriptManager:removeTrigger( "AttackerSouth" );
	ScriptManager:setMissionStatus( missionIds.defendSouthernBridge, MissionStatus.ACCOMPLISHED );
		
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_02_FLAVOR_01 );
			
		startHQMission()
		end
--	end	
end


function startHQMission()

	if ScriptManager:getMissionStatus( missionIds.defendNorthernBridge ) == MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus( missionIds.defendSouthernBridge ) == MissionStatus.ACCOMPLISHED then
	end
	
	if ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.IN_PROGRESS and
	   ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.ACCOMPLISHED then
	
		playHQCutscene()
	end
end


-- when the elite kills a unit in player turn
function onKilledByElite(attacker,attacked)
	
	
	if attacked:getHealth() <= 0 then


	if 	attacker:getTemplateId() == Units.UNIT_SU_RIFLE_ELITE 	or
		attacker:getTemplateId() == Units.UNIT_SU_MORTAR_ELITE 	or
		attacker:getTemplateId() == Units.UNIT_SU_ANTI_INFANTRY_ELITE then
		

	ScriptManager:setMissionProgress( missionIds.killEnemiesWithElite, ScriptManager:getMissionProgress( missionIds.killEnemiesWithElite) +1 );
--	SubtitleQueue()
	 ScriptManager:runForPlayer( 0, "displayEliteKills" );
	end
	end 
end


-- when the elite kills a unit during the enemy turn
function onKilledByEliteEnemyTurn(attacker, attacked)

	if attacker:getHealth() <= 0 then
	
	if 	attacked:getTemplateId() == Units.UNIT_SU_RIFLE_ELITE or
		attacked:getTemplateId() == Units.UNIT_SU_MORTAR_ELITE or
		attacked:getTemplateId() == Units.UNIT_SU_ANTI_INFANTRY_ELITE then
		
	ScriptManager:setMissionProgress( missionIds.killEnemiesWithElite, ScriptManager:getMissionProgress( missionIds.killEnemiesWithElite) +1 );
	ScriptManager:runForPlayer( 0, "displayEliteKills" );
	end
	end
end


function displayEliteKills()


	ShowMissionProgressPopup( ScriptManager:getMissionProgress ( missionIds.killEnemiesWithElite ), Text.T_MAP_SU_6_3_MISSION_SECONDARY_01_COUNTER );
	
	if ScriptManager:getMissionProgress( missionIds.killEnemiesWithElite ) >= unitsKilledbyElite then	
		ScriptManager:removeTrigger( "onKilledByElite" );	
		ScriptManager:removeTrigger( "onKilledByEliteEnemyTurn" );
					
		ScriptManager:setMissionStatus( missionIds.killEnemiesWithElite, MissionStatus.ACCOMPLISHED );
	end
end


function playReinforcementCutscene()

	ScriptManager:removeTrigger( "playReinforcementCutscene" );

	ScriptManager:startCutscene()
	
	ScriptManager:moveCameraEx( 2, 16, 0.7, 2, true );
	
	ScriptManager:wait( 2 );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_FLAVOR_03 );
	
	ScriptManager:wait( 2 );
	
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE, 1, 16, -1, AiState.WAIT );
	ScriptManager:wait( 1 );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_TANK_T34, 1, 15, -1, AiState.WAIT );
	ScriptManager:wait( 1 );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_MORTAR, 1, 17, -1, AiState.WAIT );
	
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();
end



function playReinforcementCutscene2()

	ScriptManager:removeTrigger( "playReinforcementCutscene2" );

	ScriptManager:startCutscene()
	
	ScriptManager:moveCameraEx( 2, 16, 0.7, 2, true );
	
	ScriptManager:wait( 2 );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_01_FLAVOR_03 );
	
	ScriptManager:wait( 2 );
	
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_RIFLE, 1, 16, -1, AiState.WAIT );
	ScriptManager:wait( 1 );
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_TANK_DESTROYER, 1, 15, -1, AiState.WAIT );
	
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();
end



function onAirfieldCaptured()
	spawnPlaneWaves = 0;
	ScriptManager:removeTrigger( "startRandomPlaneSpawn" )
end


function playAACutscene()

	ScriptManager:startCutscene();
	
	ScriptManager:moveCameraEx( 22, 20, 0.7, 2, true );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_SECONDARY_02_FLAVOR_01 );
	ScriptManager:wait( 7 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:moveCameraEx( 5, 11, 0.7, 3, true );
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_SECONDARY_02_FLAVOR_02 );
	
	local AA1 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_MOBILE_AA, 5, 2, -1, AiState.WAIT ):getId();
	local AA2 = ScriptManager:spawnUnit( 0, Units.UNIT_SU_MOBILE_AA, 5, 1, -1, AiState.WAIT ):getId();
	
	ScriptManager:moveUnitEx( AA1, 3, 12, true );
	ScriptManager:moveUnitEx( AA2, 3, 11, true );
	
	Unit:getUnitById( AA1 ):setFuel( 100 );
	Unit:getUnitById( AA2 ):setFuel( 100 );
	

	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:moveCameraEx( 4, 28, 0.7, 3, true );
	
	ScriptManager:spawnUnit( 0, Units.UNIT_SU_FIGHTER, 3, 29, -1, AiState.WAIT );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_SECONDARY_02_FLAVOR_03 );
	ScriptManager:wait( 4 );
	
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();

	ScriptManager:setMissionStatus( missionIds.escortAA, MissionStatus.IN_PROGRESS );
	ScriptManager:setMissionStatus( missionIds.protectAirfield, MissionStatus.IN_PROGRESS );
	
	ScriptManager:runForPlayer( 1, "spawnTheBombers" );
end


function spawnTheBombers()

	ScriptManager:spawnUnit( 1, Units.UNIT_DE_BOMBER, 21, 20, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE );
	ScriptManager:spawnUnit( 1, Units.UNIT_DE_BOMBER, 20, 19, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE );
	ScriptManager:spawnUnit( 1, Units.UNIT_DE_BOMBER, 21, 19, enemySquadIds.bombersquad, AiState.ATTACK_AGGRESSIVE );
	
	ScriptManager:setTargetTile( 1, enemySquadIds.bombersquad, 4, 30 );

end



function onMobileAAdestroyed()
	ScriptManager:removeTrigger( "onMobileAAdestroyed" );
	ScriptManager:runForPlayer( 0, "setAAmissionFailed" );
end

function setAAmissionFailed()
	ScriptManager:setMissionStatus( missionIds.escortAA, MissionStatus.FAILED );
end


function onAAenteredCity()

	if ScriptManager:getMissionStatus( missionIds.escortAA ) ~= MissionStatus.FAILED then
	
	ScriptManager:setMissionProgress( missionIds.escortAA, ScriptManager:getMissionProgress(missionIds.escortAA ) +1 );
	ShowMissionProgressPopup( ScriptManager:getMissionProgress (missionIds.escortAA ), Text.T_MAP_SU_6_3_MISSION_SECONDARY_02_COUNTER );
	end
	
	if ScriptManager:getMissionProgress( missionIds.escortAA ) >= antiAirsEscorted then
	ScriptManager:removeTrigger( "onAAenteredCity" );
	ScriptManager:removeTrigger( "onPlayerAirfieldDestroyed" );
	ScriptManager:removeTrigger( "onMobileAAdestroyed" );
	ScriptManager:setMissionStatus( missionIds.escortAA , MissionStatus.ACCOMPLISHED );
	
--	playAACutscene()
	end
end


function onPlayerAirfieldDestroyed()
	ScriptManager:setMissionStatus( missionIds.escortAA, MissionStatus.FAILED );
	ScriptManager:setMissionStatus( missionIds.protectAirfield, MissionStatus.FAILED );
end


function playHQCutscene()

	ScriptManager:removeTrigger( "onAttackerDestroyed" )

	HQcutscenePlayed = 1;
	ScriptManager:storeValue( "HQcutscenePlayed", HQcutscenePlayed );

	if ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.IN_PROGRESS and
	   ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.ACCOMPLISHED then

	ScriptManager:startCutscene();
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_03_FLAVOR_01 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
			
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_03_FLAVOR_02 );
	ScriptManager:wait( 3 );
	ScriptManager:dismissSubtitle();

	ScriptManager:moveCameraEx( 21, 16, 0.7, 2, true );
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_03_FLAVOR_03 );
	ScriptManager:wait( 5 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:stopCutscene();
	
	ScriptManager:setMissionStatus( missionIds.CaptureGermanHQ, MissionStatus.IN_PROGRESS );
	end
end



function playAlternativeHQCutscene(TileX, TileY, PlayerID, UnitTemplateID, UnitID)

	if ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.IN_PROGRESS  and
	   ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) ~= MissionStatus.ACCOMPLISHED then

	ScriptManager:removeTrigger( "playAlternativeHQCutscene" );
	
		if UnitTemplateID ~= Units.UNIT_SU_FIGHTER then
		
		ScriptManager:startCutscene();
		
		ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_03_FLAVOR_04 );
		ScriptManager:wait( 4 );
		ScriptManager:dismissSubtitle();
		
		ScriptManager:moveCameraEx( 21, 16, 0.7, 2, true );
		
		ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_PRIMARY_03_FLAVOR_05 );
		ScriptManager:wait( 4 );
		ScriptManager:dismissSubtitle();
		
		ScriptManager:stopCutscene();
		
		ScriptManager:setMissionStatus( missionIds.CaptureGermanHQ, MissionStatus.IN_PROGRESS );
		end
	end
end


function onHQcaptured()

	ScriptManager:removeTrigger( "onHQcaptured" );
	ScriptManager:setMissionStatus( missionIds.CaptureGermanHQ, MissionStatus.ACCOMPLISHED );

	checkForVictory()
	
end


function startRandomPlaneSpawn()

	spawnPlaneWaves = 1;

	if lastPlaneWaveSpawnedInRound + planeWaveRespawnInterval <= ScriptManager:getCurrentRound() then
	
		local rnd = math.random( 0, 2 );
		local spawnTable = 0;
	
		if rnd == 0 then
		spawnTable = planeWave1;
	
		elseif rnd == 1 then
		spawnTable = planeWave2;
	
		elseif rnd == 2 then
		spawnTable = planeWave3;
	end
	
		for i = 1, #spawnTable do
		spawnWave(spawnTable[i] );
		
		ScriptManager:setTargetTile( 1, enemySquadIds.planes, 4, 30 );
		end
	
	-- set counter for next spawn
	lastPlaneWaveSpawnedInRound = ScriptManager:getCurrentRound();
	ScriptManager:storeValue ( "lastPlaneWaveSpawnedInRound", lastPlaneWaveSpawnedInRound );
	end
end



function checkForVictory()
	if 
--		ScriptManager:getMissionStatus( missionIds.defendNorthernBridge )	== MissionStatus.ACCOMPLISHED and
--		ScriptManager:getMissionStatus( missionIds.defendSouthernBridge ) 	== MissionStatus.ACCOMPLISHED and
		ScriptManager:getMissionStatus( missionIds.CaptureGermanHQ ) 		== MissionStatus.ACCOMPLISHED then
		
		ScriptManager:displaySubtitle( Text.T_MAP_SU_6_2_MISSION_SECONDARY_02_FLAVOR_05 );
		ScriptManager:wait( 3 );
		ScriptManager:dismissSubtitle();
		
				
		local depot1 = playerBuildingIds.depotNorth
		local depot2 = playerBuildingIds.depotSouth
		
		if 	depot1 ~= nil and
			depot2 ~= nil then
			
			ScriptManager:setMissionStatus( missionIds.defendNorthernBridge, MissionStatus.ACCOMPLISHED );
			ScriptManager:setMissionStatus( missionIds.defendSouthernBridge, MissionStatus.ACCOMPLISHED );
			
			local unit = playerBuildingIds.airfield
			if unit ~= nil then
			ScriptManager:setMissionStatus( missionIds.protectAirfield, MissionStatus.ACCOMPLISHED );
			end
			
			ScriptManager:wait( 3 );
		end
		
		startVictoryCutscene()
	end
end


-- END
-- BEGIN Victory


function startVictoryCutscene()
	StartCutscene();
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_OUTRO_FLAVOR_01 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_OUTRO_FLAVOR_02 );
	ScriptManager:wait( 4 );
	ScriptManager:dismissSubtitle();
	
	ScriptManager:displaySubtitle( Text.T_MAP_SU_6_3_MISSION_OUTRO_FLAVOR_03 );
	ScriptManager:wait( 4 );
	HideDialogue();
	
	EndCutscene();
	

	
	ScriptManager:wait( 1 );
	
	victoryEndGame();
end

function victoryEndGame()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens

	-- accomplish secondary missions that are accomplished when the game is finished with certain condition
	
	
	ScriptManager:displaySubtitle( Text.T_MISSION_VICTORY );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
end


-- END Victory
-- BEGIN Defeated


function checkForEnd()
	if ScriptManager:noUnitsLeft( 0 ) then
		ScriptManager:runForPlayer( 0, "missionFailed" )
	end
end

function missionFailed()
	DisablePlayerInteraction();
	HideDialogue(); -- remove possible texts on the screens
	
	ScriptManager:displaySubtitle( Text.T_MISSION_FAILED );
	ScriptManager:wait( 4 );
	HideDialogue();
	endGame();
end


-- END Defeated


function endGame()
	ScriptManager:endGame()
end