require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

function onGameStart()
--starting gold

	ScriptManager:gainGold(0,1000)
	
	-----------------------------------------------------------------------------
	--ScriptManager:spawnUnit(0,30,11,19,-1,-1)		--TODO: DELETE
	-----------------------------------------------------------------------------
	
	ScriptManager:preparePopupText()
	-- RESPAWNING ENEMIES --
	
	
	RespawnPlane_1()
	RespawnPlane_2()
	RespawnPlane_3()
	
	-- Mission objectives--
	
	ScriptManager:createMission(1,true,Text.T_MISSION_MAP_3_1_PRIMARY_OBJ_01_LOG) 							--move through the mountains
	ScriptManager:setMissionXp(1,100)
	ScriptManager:createMission(2,false,Text.T_MISSION_MAP_3_1_SECONDARY_OBJ_01_LOG)						-- Destroy airfield
	ScriptManager:setMissionXp(2,100)
	ScriptManager:createMission(3,true,Text.T_MISSION_MAP_3_1_PRIMARY_OBJ_02_LOG)							-- Destroy/captured base
	ScriptManager:setMissionXp(3,200)
	ScriptManager:createMission(4,false,Text.T_MISSION_MAP_3_1_SECONDARY_OBJ_02_LOG)						-- destroy aa
	ScriptManager:setMissionXp(4,150)
	
	--Trigger if player main depot is attacked
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_SU_HQ,-1,"ProtectTheSupplyDepotHint","ProtectTheSupplyDepotHint")
	
	-- Enable destroy AAs objective when you attack an AA --
	
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_AA,-1,"OnenemyAAdestroyed","OnenemyAAdestroyed")
	ScriptManager:addOnUnitHasAttackedTrigger(1,Units.UNIT_DE_AA,-1,"startaamission","startaamission")
	-- when first base is captured or destroyed, reinforcements will arrive
	
	--reinforcements base
	ScriptManager:addOnUnitCapturedTrigger(0, -1, 45, "onHq1_Captured", "onHq1_Captured");
	
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_AIRFIELD,-1,"onAirfieldDestroyed","Airfielddisabledtrigger")
	ScriptManager:addOnUnitCapturedTrigger(-1, 14, 15, "onAirfieldCaptured","Airfielddisabledtrigger");
	
	--main base triggers
	
	--ScriptManager:addOnUnitDestroyedTrigger(-1, 13, Units.UNIT_DE_HQ, "onHqDestroyedOrCaptured")
	ScriptManager:addOnUnitCapturedTrigger(-1, 13, 7, "onHqDestroyedOrCaptured")
	ScriptManager:addOnUnitDestroyedTrigger(-1, 13, 7, "onHqDestroyedOrCaptured");
	
	
	
	--planes trigger triggers, when a german plane attacks you
	
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_FIGHTER,-1,"onTargetAttacked","OnenemyPlanespotted")
	ScriptManager:addOnUnitHasAttackedTrigger(-1,Units.UNIT_DE_BOMBER,-1,"onTargetAttacked","OnenemyPlanespotted")
	
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_FIGHTER,-1,"onTargetAttacked","OnenemyPlanespotted")
	ScriptManager:addOnUnitDestroyedTrigger(-1,Units.UNIT_DE_BOMBER,-1,"onTargetAttacked","OnenemyPlanespotted")
	
	--crossing the line trigger "move through mountains"
	
	for x = 0, 13 do
		ScriptManager:addOnEnterTileTrigger(x,15,0,-1,-1,true,"unitCrossedTheLine","unitCrossedTheLine")
	end
	
	--second cutscene starts on the second turn: hidden pass hint!--
	
	ScriptManager:moveCamera(9,8,1.1,0,"")
	ScriptManager:sleep(0,"StartCutscene")
	ScriptManager:addOnTurnStartTrigger(0,-1,1,"showmountainpass_text", "showmountainpass_text" );
	
	--Check if player units or base is dead
	ScriptManager:addOnUnitDestroyedTrigger(0,-1,-1,"checkForEnd","checkForEnd")
	
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"CheckForGameEnd")
		
end

function checkForEnd()
	if ScriptManager:noUnitsLeft(0) or Unit:getUnitById(6) == nil then
		ScriptManager:runForPlayer(0,"MissionFailed")
	end
end

--Game End Check
function CheckForGameEnd()
	MainGoalAccomplished(3,Next_mission_teaser,MissionFailed)		--Main Mission ID, Script to start if Accomplished, Script to start if Failed
end


function StartCutscene()
	ScriptManager:startCutscene()
	ScriptManager:sleep(2,"MoveUnits")
	MoveCamera()
end

--			BEGINNING CUTSCENE UNITS MOVING INTO MG FIRE 		--


function MoveUnits()
	Unit:getUnitById(34):setHealth(50)
	ScriptManager:moveUnit(34,8,12,"BunkerAttack_1")
end

function BunkerAttack_1()
	ScriptManager:attackUnit(0,34,"MoveUnit_Infantry_10")
end

function MoveUnit_Infantry_10()	
	Unit:getUnitById(10):setHealth(50)
	ScriptManager:moveUnit(10,9,12,"BunkerAttack_2")
end

function BunkerAttack_2()
	ScriptManager:attackUnit(2,10,"MoveUnit_Infantry_11")
end

function MoveUnit_Infantry_11()	
	Unit:getUnitById(11):setHealth(50)
	ScriptManager:moveUnit(11,7,11,"MGAttack_1")
end

function MGAttack_1()
	ScriptManager:attackUnit(0,11,"")
end


--Moves camera to bunkers

function KillDialogue()				-- Function to disable the dialog for texts
	ScriptManager:dismissSubtitle()
end

function MoveCamera()
	ScriptManager:moveCamera(8,12,0.9,6,"Cutscene_MoveCam_Sleep_1")
end

--Camera waits after infantry is killed by the bunkers
function Cutscene_MoveCam_Sleep_1()
	ScriptManager:sleep(5,"Cutscene_MoveCam_Start")
	--"This road is heavily defended!"
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_3_1_INTRO_DIALOGUE_02,"")

end

function Cutscene_MoveCam_Start()

	ScriptManager:moveCamera(11,4,1.0,6,"Cutscene_MoveCam_Sleep_2")
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_3_1_INTRO_DIALOGUE_03,"")			--"Move your army through the mountains and conquer the village on the other side!"

end

function Cutscene_MoveCam_Sleep_2()

	ScriptManager:sleep(2,"Cutscene_MoveCam_end_1")

end

function Cutscene_MoveCam_end_1()
	
	ScriptManager:stopCutscene()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 11, 4 );
	end
	ScriptManager:continueAfterCutscene("startMainmission")
		
	--TODO:SCREENSHOT
	---------------------------------------------------------
--	ScriptManager:spawnUnit(0,30,12,12,0,0) --TODO:DELETE GOD
--	ScriptManager:spawnUnit(0,30,10,12,0,0) --TODO:DELETE GOD
--	ScriptManager:moveCamera(0,0,0.77,0,"")
--	---------------------------------------------------------
end

--	CUTSCENE STOP	--
function startMainmission()
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	ScriptManager:blockUI(false)
end
--	MOUNTAINPASS TEXT AT ROUND 2: HIDDEN PASS	--

function showmountainpass_text()

	ScriptManager:startCutscene()
	Cutscene_MoveCam_Start_01()
	ScriptManager:removeTrigger( "showmountainpass_text" );-- TODO
end

function Cutscene_MoveCam_Start_01()		--CAMERA MOVEMENT TOWARDS THE PASS--

	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_3_1_INTRO_DIALOGUE_04,"")				--"There is a hidden mountain pass!\n Use it to move around the bunkers!"
	ScriptManager:moveCamera(2,7,1.0,6,"Cutscene_MoveCam_mountainpass_sleep")
	
end

function Cutscene_MoveCam_mountainpass_sleep()
	
	ScriptManager:sleep(2,"notice_base")

end

function notice_base()

	ScriptManager:dismissSubtitle()
	ScriptManager:revealFogOfWar(2,4,4,true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MAP_3_1_BASE_NOTE,"")	
	ScriptManager:moveCamera(2,4,1.0,2,"sleep_end_warning")
	ScriptManager:showMarkerAt(2,4)
	
end

function sleep_end_warning()

	ScriptManager:sleep(2,"end_warning")
	
		
end

function end_warning()

	ScriptManager:stopCutscene()
	ScriptManager:continueAfterCutscene("CutsceneEnd_1")
	ScriptManager:revealFogOfWar(2,4,4,false)
	
end

function hideMarkers()
	ScriptManager:removeAllMarkers()
	
end

function CutsceneEnd_1()
	
	ScriptManager:moveCamera(7,7,1.0,2,"KillDialogue")
	hideMarkers()
	
end

function onHq1_Captured()

	ScriptManager:runForPlayer(0,"onHq1_Captured_1")

end

function onHq1_Captured_1()		-- when hq is captured, reinforcements arrive from the west

	ScriptManager:startCutscene()
	ScriptManager:moveCamera(1,5,0.8,4,"")
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_REINFORCEMENTS,"onHq1_Captured_cutscene_end")	
	ScriptManager:spawnUnit(0,Units.UNIT_SU_TANK_KV1,1,6,-1,-1)
	ScriptManager:spawnUnit(0,Units.UNIT_SU_AA,1,5,-1,-1)
	ScriptManager:spawnUnit(0,Units.UNIT_SU_TANK_DESTROYER,1,4,-1,-1)
	
end

function onHq1_Captured_cutscene_end()
		
	ScriptManager:stopCutscene()
	ScriptManager:continueAfterCutscene("SpawnTank_1")

end



-- Trigger that is triggered when your units cross the mountains 

function unitCrossedTheLine()
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	for i = 0, 13 do
		ScriptManager:removeTrigger("unitCrossedTheLine")
	end
	
	ScriptManager:removeTrigger("SpawnTank_1")
	ScriptManager:removeTrigger("tankspawn")
	ScriptManager:sleep(2,"Cutscene_MoveCam_HQ")
	
end

function Cutscene_MoveCam_HQ()			-- CAMERA MOVEMENT TOWARDS THE ENEMY HQ	--
	
	ScriptManager:startCutscene()
	ScriptManager:revealFogOfWar(2,19,4,true)
	ScriptManager:showMarkerAt(2,19)
	ScriptManager:moveCamera(2,19,0.8,4,"wait_2")
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_3_1_PRIMARY_OBJ_02_LOG,"")					--"Destroy or capture the German base!"
	
end

function wait_2()

	ScriptManager:sleep(2,"objective_updated_1")

end

function objective_updated_1()													--Primary objective updated

	ScriptManager:stopCutscene()
	ScriptManager:createMission(3,true,Text.T_MISSION_MAP_3_1_PRIMARY_OBJ_02_LOG) 		--"Destroy or capture the German base!"
	ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
	ScriptManager:revealFogOfWar(2,19,4,false)
	hideMarkers()
end


function onHqDestroyedOrCaptured()												-- move to mission complete when primary objective is fulfilled
	DisableEndTurnButton()
	
	ScriptManager:setMissionStatus(3,MissionStatus.ACCOMPLISHED)
	ScriptManager:sleep(2,"Next_mission_teaser")
	ScriptManager:blockUI(true)
	if ScriptManager:getMissionStatus(1) ~= MissionStatus.ACCOMPLISHED then
		ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	end	
	if ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
	end																					-- Bonus objectives are set to failed when not fulfilled when the primary objective is completed!
	if ScriptManager:getMissionStatus(4) == MissionStatus.IN_PROGRESS then
		ScriptManager:setMissionStatus(4,MissionStatus.FAILED)
	end

end

function Next_mission_teaser()														-- teaser for the next mission!
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_C03M01_TEASER,"Mission_completed")						--"Our allies defending the capital are only a stone's throw from here!\n We have to press on...
end

function Mission_completed()														-- Mission END!--
	
	ScriptManager:blockUI(true)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_VICTORY,"endgame")	
	
	
end

function endgame()
	
	ScriptManager:endGame()

end
--TODO AIRFIELD DESTROYED OR CAPTURED
function onAirfieldDestroyed()		-- Bonus objective completed!
ScriptManager:removeTrigger("Airfielddisabledtrigger")
print(string.format("[SCRIPT] Airfield destroyed()..."));
	ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
	ScriptManager:removeTrigger("OnenemyPlanespotted")
		
end

function onAirfieldCaptured()		-- Bonus objective completed!
ScriptManager:removeTrigger("Airfielddisabledtrigger")
print(string.format("[SCRIPT] Airfield captured()..."));
	ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
	ScriptManager:removeTrigger("OnenemyPlanespotted")
		
end

-- Spawn enemy Plane 1 & starting respawn function when destroyed --

function SpawnPlane_1()
	local status = ScriptManager:getMissionStatus(2);
	if (status == MissionStatus.NOT_STARTED or status == MissionStatus.IN_PROGRESS) then
		local unit = ScriptManager:spawnUnit(1,Units.UNIT_DE_BOMBER,10,17,30,AiState.AIRPLANE)
		ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"RespawnPlane_1","RespawnPlane_1")
		
		
	end
	ScriptManager:removeTrigger("SpawnPlane_1")
end

-- Respawn enemy plane 1 after 2 Turns if mission 2 in progress

function RespawnPlane_1()
	if ScriptManager:getCurrentRound() < 15 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+1,"SpawnPlane_1")
	end
end

-- Spawn enemy Plane 2 & starting respawn function when destroyed --

function SpawnPlane_2()
	if ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS then
		local unit  = ScriptManager:spawnUnit(1,Units.UNIT_DE_FIGHTER,11,17,30,AiState.AIRPLANE)
		ScriptManager:storeValue("EnemyPlane_2",unit:getId());
		local unit = ScriptManager:getValue("EnemyPlane_2")
		ScriptManager:addOnUnitDestroyedTrigger(1,-1,unit,"RespawnPlane_2","RespawnPlane_2")
	end
end

-- Respawn enemy plane 2 after 3 Turns if mission 2 in progress

function RespawnPlane_2()
	if ScriptManager:getCurrentRound() < 15 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+2,"SpawnPlane_2")
	end
end

-- Spawn enemy Plane 3 & starting respawn function when destroyed --

function SpawnPlane_3()
	if ScriptManager:getMissionStatus(2) == MissionStatus.IN_PROGRESS then
		local unit  = ScriptManager:spawnUnit(1,Units.UNIT_DE_FIGHTER,12,18,30,AiState.AIRPLANE)
		ScriptManager:storeValue("EnemyPlane_3",unit:getId());
		local unit = ScriptManager:getValue("EnemyPlane_3")
		ScriptManager:addOnUnitDestroyedTrigger(1,-1,unit,"RespawnPlane_3","RespawnPlane_3")
	end
end

-- Respawn enemy plane 3 after 4 Turns if mission 2 in progress

function RespawnPlane_3()
	if ScriptManager:getCurrentRound() < 15 then
		ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+3,"SpawnPlane_3")
	end
end

-- Create new bonus objective when attacked by enemy planes --														
																				--TODO:

function OnenemyPlanespotted()				--Start cutscene that moves to the airfield and shows the new secondary objective

	ScriptManager:runForPlayer(0, "show_text")
		
end

function show_text()

	ScriptManager:startCutscene()
	--to stop enemy air raids, destroy or capture the airfield in the north!"
	ScriptManager:moveCamera(11,18,0.8,4,"Cutscene_MoveCam_Airbase_start")
	
end

--	move back to the unit the player had selected


function onTargetAttacked(attacker, defender)		
	targetID = -1
	if attacker:getTemplateId() == Units.UNIT_DE_BOMBER or attacker:getTemplateId() == Units.UNIT_DE_FIGHTER then				
		targetID = attacker:getId()
	end
	if defender:getTemplateId() == Units.UNIT_DE_BOMBER or defender:getTemplateId() == Units.UNIT_DE_FIGHTER then
		targetID = defender:getId()
	end
	ScriptManager:removeTrigger("onTargetAttacked")
	ScriptManager:runForPlayer(0, "MoveCamToTarget")
end

function MoveCamToTarget()
	ScriptManager:disableEndTurnButton()
	ScriptManager:enableSkipCutsceneButton()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,2,"CamOnTarget")
end

function CamOnTarget()
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,true)
	ScriptManager:showMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:displaySubtitle(Text.T_MAP_3_2_MISSION_SECONDARY_SUB)
	ScriptManager:sleep(5,"HideDialogue")
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.9,3,"ZoomCamOutAndEndScript")
end

function ZoomCamOutAndEndScript()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.8,2,"EndMetaCutScene")
	ScriptManager:hideMarkerAt(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY())
	ScriptManager:revealFogOfWar(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),1,false)
end

function EndMetaCutScene()
	ScriptManager:runForPlayer(0,"OnenemyPlanespotted")
	ScriptManager:disableSkipCutsceneButton()
	ScriptManager:enableEndTurnButton()
end





	-- CAMERA STOPS AT THE Airfield	--

function Cutscene_MoveCam_Airbase_start()

ScriptManager:continueAfterCutscene("Cutscene_MoveCam_Airbase")
ScriptManager:enableSkipCutsceneButton()
end


function Cutscene_MoveCam_Airbase()			-- only happens in the player turn
	
	ScriptManager:runForPlayer(0, "Cutscene_MoveCam_Airbase_2")
	ScriptManager:removeTrigger("OnenemyPlanespotted")
end

function Cutscene_MoveCam_Airbase_2()			-- CAMERA MOVEMENT TOWARDS THE ENEMY Airbase	--

	
	ScriptManager:dismissSubtitle()
	ScriptManager:revealFogOfWar(11,18,4,true)
	ScriptManager:showMarkerAt(11,18)
	ScriptManager:startCutscene()
	waitatbase()
end

function waitatbase()
	
	ScriptManager:moveCamera(9,17,1.0,5,"cutscene_end_2")
	ScriptManager:displaySubtitle(Text.T_MISSION_MAP_3_1_SECONDARY_OBJ_01)		
	ScriptManager:removeTrigger("Cutscene_MoveCam_Airbase")	
end

function cutscene_end_2()
--TODO: move camera back to the unit the player had selected
	
	ScriptManager:hideMarkerAt(11,18)
	ScriptManager:stopCutscene()
	ScriptManager:sleep(2,"KillDialogue")
	ScriptManager:revealFogOfWar(11,18,4,false)
	ScriptManager:continueAfterCutscene("set_mission")
end
--move back to players unit
function set_mission()
	ScriptManager:moveCamera(Unit:getUnitById(targetID):getX(),Unit:getUnitById(targetID):getY(),0.8,2,"KillDialogue")
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)

end

--Create bonus objective when an AA has been destroyed --

--TODO:AA MISSION

function startaamission()
	ScriptManager:runForPlayer(0,"OnenemyAAsighted")
	ScriptManager:removeTrigger("startaamission")
end

function OnenemyAAsighted()
	ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
end	

	
function OnenemyAAdestroyed()

	if 	ScriptManager:getMissionStatus(4) ~= MissionStatus.IN_PROGRESS and 
		ScriptManager:getMissionStatus(4) ~= MissionStatus.ACCOMPLISHED	then
		ScriptManager:setMissionStatus(4, MissionStatus.IN_PROGRESS);
	end
							
	ScriptManager:setMissionProgress(4,1)				--Add progress +1 because you just killed one AA
	ScriptManager:removeTrigger("OnenemyAAdestroyed")	-- Destroy trigger so the progress doesn't start all over again each time you kill an AA
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_DE_AA,-1,"OnenemyAAdestroyed_1","OnenemyAAdestroyed_1")
	showprogresstext()
	
end

function showprogresstext()

	ScriptManager:preparePopupText()
	ScriptManager:addPopupTextParameter("x",ScriptManager:getMissionProgress(4))
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_MAP_3_1_INTRO_DIALOGUE_01,"")					--"Anti air positions destroyed:\n{x}/4"		
end

function OnenemyAAdestroyed_1()
	ScriptManager:setMissionProgress(4,ScriptManager:getMissionProgress(4)+1)				--Update on mission progress when one AA is destroyed
	showprogresstext()
	if ScriptManager:getMissionProgress(4) == 4 then
		ScriptManager:setMissionStatus(4,MissionStatus.ACCOMPLISHED)
end

end

-- Spawning tanks on the upper right map border	--

function tankspawn()
	if ScriptManager:getCurrentRound() < 15 then
		ScriptManager:addOnTurnStartTrigger(0,-1,ScriptManager:getCurrentRound()+2,"SpawnTank_1","SpawnTank_1")
		
	end 
end

function SpawnTank_1()
	ScriptManager:removeTrigger("SpawnTank_1")
	local unit  = ScriptManager:spawnUnit(1,Units.UNIT_DE_TANK_4,7,20,140,AiState.ATTACK_AGGRESSIVE)
	ScriptManager:storeValue("Enemy_Tank_1",unit:getId());
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,unit:getId(),"tankspawn","tankspawn")
	ScriptManager:camouflageUnit(unit:getId())
	--showspawn()
	
end

--mission fail conditions 

function MissionFailed()
	ScriptManager:disableEndTurnButton()
	ScriptManager:blockUI(true)
	ScriptManager:dismissSubtitle()
	ScriptManager:setMissionStatus(1,MissionStatus.FAILED)
	ScriptManager:setMissionStatus(3,MissionStatus.FAILED)
	ScriptManager:displaySubtitleAutoWithCallback(Text.T_MISSION_FAILED,"Showmessage")
end

function Showmessage()
	ScriptManager:dismissSubtitle()
	ScriptManager:sleep(2,"endgame_sleep")
end

function endgame_sleep()
	ScriptManager:endGame()
end

