require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

Mission = {
	capAndHoldDepot = 1
}

depotId			=  1;
depotUnit		=  0;
depotState		= -1; -- playerId of the state
p1EndState		= -2; -- state on p1 turn end
p2EndState		= -2; -- state on p2 turn end
pointsP1		=  0;
pointsP2		=  0;
pointsForWin	=  5;

function onGameStart()
	--print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:createMission(Mission.capAndHoldDepot, true, Text.T_MULTIPLAYER_GAMEMODE_KOTH_DESCR);
	ScriptManager:setMissionStatus(Mission.capAndHoldDepot, MissionStatus.IN_PROGRESS);
	
	depotUnit = Unit:getUnitById( 1 );
	
	ScriptManager:addOnTurnStartTrigger( 0, -1, -1, "onPlayer1TurnStart", "onPlayer1TurnStart", false );
	ScriptManager:addOnTurnStartTrigger( 1, -1, -1, "onPlayer2TurnStart", "onPlayer2TurnStart", false );
	
	ScriptManager:addOnTurnEndTrigger( 0, -1, -1, "onPlayer1TurnEnd", "onPlayer1TurnEnd", false );
	ScriptManager:addOnTurnEndTrigger( 1, -1, -1, "onPlayer2TurnEnd", "onPlayer2TurnEnd", false );
end

function onPlayer1TurnStart()
	print( string.format( "depotState %i", depotState) );
	print( string.format( "p1EndState %i", p1EndState) );
	goldPerTurn( 0 );
	
	if depotState ~= -1 then
		if  depotState == p1EndState and
			p1EndState == 0 then
			DisablePlayerInteraction();
			pointsP1 = pointsP1 + 1;
			print( string.format( "You have %i points!", pointsP1 ) );
			HideDialogue();
			ScriptManager:wait( 2 );
			checkForWin( pointsP1 );
			EnablePlayerInteraction();
		end
	end
	ScriptManager:displaySubtitle( string.format( "You have %i points! \n Enemy has %i points!", pointsP1, pointsP2 ) );
end

function onPlayer1TurnEnd()
	depotState = depotUnit:getPlayerId();
	p1EndState = depotState;
	print( string.format( "depotState %i", depotState) );
	print( string.format( "p1EndState %i", p1EndState) );
end

function onPlayer2TurnStart()
	print( string.format( "depotState %i", depotState) );
	print( string.format( "p2EndState %i", p2EndState) );
	goldPerTurn( 1 );
	
	if depotState ~= -1 then
		if  depotState == p2EndState and
			p2EndState == 1 then
			DisablePlayerInteraction();
			pointsP2 = pointsP2 + 1;
			print( string.format( "You have %i points!", pointsP2 ) );
			HideDialogue();
			ScriptManager:wait( 2 );
			checkForWin( pointsP1 );
			EnablePlayerInteraction();
		end
	end
	ScriptManager:displaySubtitle( string.format( "You have have %i points! \n Enemy has have %i points!", pointsP2, pointsP1 ) );
end

function onPlayer2TurnEnd()
	depotState = depotUnit:getPlayerId();
	p2EndState = depotState;
	print( string.format( "depotState %i", depotState) );
	print( string.format( "p2EndState %i", p2EndState) );
end

function goldPerTurn( playerId )
	ScriptManager:gainGold( playerId, 1000 );
end

function checkForWin( playerPoints )
	if playerPoints >= pointsForWin then
		HideDialogue();
		ScriptManager:displaySubtitle( "You have won!" );
	end
end