require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

showAdditionalSubtitle = true;

function onGameStart()
	--print( string.format( "[SCRIPT] onGameStart()..." ) );
	ScriptManager:createMission( 1, true, Text.T_MISSION_TUTORIAL_MAIN_1 );
	ScriptManager:setMissionStatus( 1, MissionStatus.IN_PROGRESS );
	ScriptManager:setMissionXp( 1, 25 );
	ScriptManager:setMedalReward( 150 );
	ScriptManager:sleep( 0,"StartIntro" );
	ScriptManager:addOnTurnStartTrigger( 1, -1, 0, "EnemyReinforcements" );
	ScriptManager:disableAICalculation();
	ScriptManager:addOnTurnStartTrigger( 0, -1, 1, "ReSupplyTiger" );
	ScriptManager:addOnTurnStartTrigger( 1, -1, 1, "EnemyReinforcementsAttack" );
	ScriptManager:moveCamera( 7, 6, 0.7, 0, "" );
	-- TODO: ENABLE AFTER TESTING!
	ScriptManager:disableSkipReplayButton();
	ScriptManager:disableSkipCutsceneButton();
	ScriptManager:preparePopupText();
	ScriptManager:addOnControllerConnectedTrigger( "onControllerConnect", "onControllerConnect", false );
	ScriptManager:addOnControllerDisconnectedTrigger( "onControllerDisconnect", "onControllerDisconnect", false );
	
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 11, 1 );
	end
	
	return 1
end

function StartIntro()
	local defender = Unit:getUnitById( 4 );
	defender:setHealth( defender:getHealth() / 2 );
	ScriptManager:startCutscene();
	--ScriptManager:sleep( 1.5,"ShowIntroText" );
	ScriptManager:sleep( 0, "MoveCamera" );
	ScriptManager:sleep( 1, "ShowIntroDialogue1" );
	ScriptManager:sleep( 0.5, "IntroUnitBattle" );
end

function MoveCamera()
	ScriptManager:moveCamera( 
	7, 6, 		--X, Y
	0.9, 7,	--ZOOM, TIME
	"MoveCamera_0"	--CallBack
	 );
	--ScriptManager:sleep( 5,"MoveCamera_0" );
end

function MoveCamera_0()
	ScriptManager:moveCamera( 
	6, 6, 		--X, Y
	1.1, 1,	--ZOOM, TIME
	""	--CallBack
	 );
	ScriptManager:sleep( 3, "MoveCamera_1" );
end

function MoveCamera_1()
	ScriptManager:moveCamera( 
	6, 7, 		--X, Y
	1, 1,	--ZOOM, TIME
	""	--CallBack
	 );
	ScriptManager:sleep( 2, "MoveCamera_2" );
end

function MoveCamera_2()
	ScriptManager:moveCamera( 
	5, 7, 		--X, Y
	1, 1,	--ZOOM, TIME
	""	--CallBack
	 );
	ScriptManager:sleep( 3, "StopCamera" );
end

function MoveCamera_3()
	ScriptManager:moveCamera( 
	5, 7, 		--X, Y
	1, 4,	--ZOOM, TIME
	"StopCamera"	--CallBack
	 );
end

function StopCamera()
	ScriptManager:sleep( 1.5, "DialogueReinforcements" )
	Reinforcement_Tank1()
	ScriptManager:moveCamera( 
	4, 5, 		--X, Y
	0.8, 6,	--ZOOM, TIME
	""	--CallBack
	 );
end

function ShowIntroDialogue1()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_0, "" );
	ScriptManager:sleep( 5, "DismissSub" );
	ScriptManager:sleep( 7, "ShowIntroDialogue2" );
end

function DismissSub()
	ScriptManager:dismissSubtitle();
end

function ShowIntroDialogue2()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_0_1, "" );
	ScriptManager:sleep( 3.5, "DismissSub" );
	ScriptManager:sleep( 5, "ShowIntroDialogue3" );
end

function ShowIntroDialogue3()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_0_2, "" );
	ScriptManager:sleep( 2.5, "DismissSub" );
end

function CutsceneEnd()
	ScriptManager:stopCutscene()
	
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 4, 5 );
	end
	
	ScriptManager:continueAfterCutscene( "SelectUnit" )	;

--TODO:SCREENSHOT
--	ScriptManager:spawnUnit( 0,30,2,2,0,0 );
--	ScriptManager:moveCamera( 0,0,0.77,0,"" );
end

function IntroUnitBattle()
	local defender2 = Unit:getUnitById( 8 );
	defender2:setHealth( 600 );
	local defender4 = Unit:getUnitById( 1 );
	defender4:setHealth( 450 );
	local defender5 = Unit:getUnitById( 0 );
	defender5:setHealth( 150 );
	local defender6 = Unit:getUnitById( 14 );
	defender6:setHealth( 250 );
	ScriptManager:moveUnit( 13, 7, 6, "Attack13" );
end

function Attack13()
	local defender1 = Unit:getUnitById( 13 );
	defender1:setHealth( defender1:getHealth() / 3 );
	ScriptManager:attackUnit( 
	13,	--ATTACKER
	1,	--DEFENDER
	"Attack2move" );
end

function Attack2move()
	ScriptManager:moveUnit( 3, 8, 4, "Attack2" )
end

function Attack2()
	local defender1 = Unit:getUnitById( 3 );
	defender1:setHealth( defender1:getHealth() / 2 );
	ScriptManager:attackUnit( 
	3,	--ATTACKER
	1, 	--DEFEND
	"AttackHeavy" );
end

function AttackHeavy()
	ScriptManager:attackUnit( 
	8,	--ATTACKER
	14,	--DEFENDER
	"MoveTank4" );
end

function MoveTank4()
	ScriptManager:moveUnit( 4, 6, 7, "Attack4" );
end

function Attack4()
	local defender7 = Unit:getUnitById( 4 );
	defender7:setHealth( 250 );
	ScriptManager:attackUnit( 
	4,	--ATTACKER
	0,	--DEFENDER
	"" );
end

function DialogueReinforcements()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_31, "" );
	ScriptManager:sleep( 3.5, "DialogueReinforcementsClose" );
end

function DialogueReinforcementsClose()
	ScriptManager:dismissSubtitle();
end

function Reinforcement_Tank1()
	local unit = ScriptManager:spawnUnit( 
	0, 3, 	--PLAYER, UNITID
	1, 3,	--X, Y
	30, 5 );	--AI
	ScriptManager:storeValue( "unitTank3", unit:getId() );
	ScriptManager:moveUnit( unit:getId(),
	2, 5,	--X, Y
	"Reinforcement_Tank2" );
end

function Reinforcement_Tank2()
	local unit = ScriptManager:spawnUnit( 
	0, 3, 	--PLAYER, UNITID
	1, 3,	--X, Y
	30, 5 );	--AI
	ScriptManager:storeValue( "unitTank2", unit:getId() );
	ScriptManager:moveUnit( unit:getId(),
	2, 3,	--X, Y
	"Reinforcement_Tank3" );
end

function Reinforcement_Tank3()
	local unit = ScriptManager:spawnUnit( 
	0, 3, 	--PLAYER, UNITID
	1, 9,	--X, Y
	30, 5 );	--AI
	ScriptManager:storeValue( "unitTank1", unit:getId() );
	ScriptManager:moveUnit( unit:getId(),
	3, 7,	--X, Y
	"Reinforcement_Tank4" );
end

function Reinforcement_Tank4()
	local unit = ScriptManager:spawnUnit( 
	0, 4, 	--PLAYER, UNITID
	1, 3,	--X, Y
	30, 5 );	--AI
	ScriptManager:storeValue( "unitTiger", unit:getId() );
	ScriptManager:moveUnit( unit:getId(),
	3, 4,	--X, Y
	"CutsceneEndWait" );
end

function CutsceneEndWait()
	ScriptManager:sleep( 1.5, "CutsceneEnd" );
end

function SelectUnit()
	ScriptManager:disableAllTilesExcept( 3, 4 );
	ScriptManager:showMarkerAt( 3, 4 );
	ScriptManager:disableEndTurnButton();
	ScriptManager:disableAllInteractionButtons();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_1, "" );
	
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, unitTiger, "TigerSelected", "TigerSelected" );
	
	if ScriptManager:isControllerConnected() then
		ScriptManager:addOnControllerSelectedTileTrigger( 3, 4, "cursorOverUnitStart", "cursorOverUnit", false );
		ScriptManager:wait( 4 );
		
		if showAdditionalSubtitle then
			ScriptManager:displaySubtitle( Text.T_TUTORIAL_CONTROLLER_MOVE_CURSOR );
		end
	
	else
		ScriptManager:showFingerAtTile( 3, 4, 1.5 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
end

function cursorOverUnitStart( tileX, tileY )
	HideDialogue();
	showAdditionalSubtitle = false;
	cursorOverUnitSinglePress( tileX, tileY );
end

function TigerSelected()
	ScriptManager:hideMarkerAt( 3, 4 );
	ScriptManager:showMarkerAt( 5, 6 );
	ScriptManager:disableAllTilesExcept( 5, 6 );
	ScriptManager:dismissSubtitle();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:addOnControllerSelectedTileTrigger( 5, 6, "cursorOverUnit", "cursorOverUnit", false );
		ScriptManager:setControllerCursorEnabled( true );
		
	else
		ScriptManager:moveFingerToTile( 5, 6 );
		ScriptManager:loopFingerClicks( 2.5 );
	end	
	
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_2, "" );
	ScriptManager:addOnTileSelectedTrigger( 5, 6, 0, "MoveSelected" );
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	--ScriptManager:addOnEnterTileTrigger( 3, 5, 0, -1, unitTiger, true, "KillSubtitle" );
	ScriptManager:addOnTileDeselectedTrigger( 5, 6, 0, "KillSubtitle", "KillSubtitle", false );
end

function KillSubtitle()
	ScriptManager:hideFinger();
	ScriptManager:dismissSubtitle();
end

function MoveSelected()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( false );
	end
	
	ScriptManager:dismissSubtitle();
	ScriptManager:removeTrigger( "TigerSelected" );
	ScriptManager:hideMarkerAt( 5, 6 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_3, "" );
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	ScriptManager:addOnEnterTileTrigger( 4, 5, 0, -1, unitTiger, true, "TigerInPosition" );
end

function TigerInPosition()
	checkControllerAndHideButton();
	
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:showMarkerAt( 6, 7 );
	ScriptManager:dismissSubtitle();
	ScriptManager:sleep( 4.5, "KillSubtitle" );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_4, "" );
	ScriptManager:sleep( 2, "TargetSelect" );
end

function TargetSelect()
	ScriptManager:disableAllTilesExcept( 6, 7 );
	ScriptManager:dismissSubtitle();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 6, 7, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 6, 7, 0 );
		ScriptManager:loopFingerClicks( 2.5 );
	end
	
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_5, "" );
	ScriptManager:addOnUnitSelectedTrigger( 1, -1, 4, "EnemySelected" );
end

function EnemySelected()
	ScriptManager:hideMarkerAt( 6, 7 );
	ScriptManager:dismissSubtitle();
	ScriptManager:wait( 0.5 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_6, "" );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 4, "EnemyTankDestroyed" );
	ScriptManager:addOnUnitDeselectedTrigger( 1, -1, 4, "EnemySelected2" );
end

function EnemySelected2()
	ScriptManager:hideFinger();
	ScriptManager:dismissSubtitle();
end

function EnemyTankDestroyed()
	checkControllerAndHideButton();
	
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_7, "" );
	ScriptManager:sleep( 4, "MoveFurther" );
end

function MoveFurther()
	ScriptManager:disableAllTilesExcept( 7, 6 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_8, "" );
	ScriptManager:showMarkerAt( 7, 6 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 7, 6, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 7, 6, 1 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	ScriptManager:addOnEnterTileTrigger( 5, 6, 0, -1, unitTiger, true, "TigerInPosition_2" );
	ScriptManager:addOnTileDeselectedTrigger( 7, 6, 0, "KillHand" );
end

function KillHand()
	ScriptManager:disableAllTilesExcept( 0, 0 )
	ScriptManager:hideFinger();
	ScriptManager:dismissSubtitle();
	ScriptManager:hideMarkerAt( 7, 6 );
end

function TigerInPosition_2()
	checkControllerAndHideButton();
	
	ScriptManager:disableAllTilesExcept( 8, 6 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_9, "" );
	ScriptManager:sleep( 2.5, "KillSubtitle" );
	ScriptManager:sleep( 3, "CanOnlyAttackOnce" );
end

function CanOnlyAttackOnce()
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_10,"" );
	ScriptManager:sleep( 5, "NextDialogue" );
end

function NextDialogue() --Take other tanks
	ScriptManager:moveCamera( 4, 7, 0.8, 1, "" );
	ScriptManager:dismissSubtitle();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 3, 7, "cursorOverUnitSinglePress", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 3, 7, 1 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:disableAllTilesExcept( 3, 7 );
	ScriptManager:showMarkerAt( 3, 7 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_11, "" );
	local unitTank1 = ScriptManager:getValue( "unitTank1" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1,unitTank1, "Tank1Selected", "Tank1Selected" );
end

function Tank1Selected()
	ScriptManager:dismissSubtitle();
	ScriptManager:hideMarkerAt( 3, 7 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_12, "" );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 5, 7, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:moveFingerToTile( 5, 7 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:showMarkerAt( 5, 7 );
	ScriptManager:sleep( 3, "KillMarker" );
	ScriptManager:disableAllTilesExcept( 5, 7 );
	ScriptManager:addOnTileDeselectedTrigger( 5, 7, 0, "MoveToForest", "MoveToForest" );
	local unitTank1 = ScriptManager:getValue( "unitTank1" );
	ScriptManager:addOnEnterTileTrigger( 5, 7, 0, -1, unitTank1, true, "Tank1InPosition", "Tank1InPosition" );
end

function KillMarker()
	ScriptManager:hideMarkerAt( 5, 7 );
	ScriptManager:hideMarkerAt( 5, 5 );
	ScriptManager:hideMarkerAt( 6, 4 );
end

function MoveToForest()
	ScriptManager:moveCamera( 5, 7, 0.8, 0.5, "" );
	ScriptManager:dismissSubtitle();
	ScriptManager:hideFinger();
end

function Tank1InPosition()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_13, "" );
	ScriptManager:showMarkerAt( 8, 6 );
	ScriptManager:disableAllTilesExcept( 8, 6 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 8, 6, "cursorOverUnit", "cursorOverUnit", false );
	end
	
	ScriptManager:addOnUnitDeselectedTrigger( 1, -1, 8, "HeavyAttacked", "HeavyAttacked" );
	ScriptManager:addOnUnitSelectedTrigger( 1, -1, 8, "HeavySelected", "HeavySelected" );
end

function HeavySelected()
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_6,"" );
end

function HeavyAttacked()
	checkControllerAndHideButton();
	
	ScriptManager:dismissSubtitle();
	ScriptManager:hideMarkerAt( 8, 6 );
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:sleep( 4, "TakeTank2" );
end

function TakeTank2()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_14,"" );
	ScriptManager:moveCamera( 3, 5, 0.8, 1, "SelectTank2" );
end

function SelectTank2()
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 2, 5, "cursorOverUnitSinglePress", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 2, 5, 1 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:disableAllTilesExcept( 2,5 );
	ScriptManager:showMarkerAt( 2, 5 );
	local unitTank3 = ScriptManager:getValue( "unitTank3" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, unitTank3, "Tank2Selected", "Tank2Selected" );
end

function Tank2Selected()
	ScriptManager:dismissSubtitle();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 5, 5, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:moveFingerToTile( 5, 5 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:hideMarkerAt( 2, 5 );
	ScriptManager:showMarkerAt( 5, 5 );
	ScriptManager:disableAllTilesExcept( 5, 5 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_15,"" );
	ScriptManager:addOnTileDeselectedTrigger( 5, 5, 0, "MoveToVillage" );
	local unitTank3 = ScriptManager:getValue( "unitTank3" );
	ScriptManager:addOnEnterTileTrigger( 5, 5, 0, -1, unitTank3, true, "Tank2InPosition" );
end

function MoveToVillage()
	ScriptManager:dismissSubtitle();
	ScriptManager:moveCamera( 5, 5, 0.8, 0.5, "" );
	ScriptManager:hideFinger();
end

function Tank2InPosition()
	ScriptManager:removeTrigger( "HeavyAttacked" );
	ScriptManager:removeTrigger( "HeavySelected" );
	ScriptManager:hideMarkerAt( 5, 5 );
	ScriptManager:showMarkerAt( 8, 6 );
	ScriptManager:showMarkerAt( 8, 4 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 8, 6, "CursorOnTank",		"cursorOverUnit", false );
		ScriptManager:addOnControllerSelectedTileTrigger( 8, 4, "CursorOnKatyusha", "cursorOverUnit", false );
	end
	
	ScriptManager:disableAllTilesExcept( 8, 6 );
	ScriptManager:enableAdditionalTile( 8, 4 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_16,"" );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 8, "HeavyTankDestroyed", "HeavyTankDestroyed" );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 3, "KatyushaDestroyed", "KatyushaDestroyed" );
end

function CursorOnTank( tileX, tileY )
	cursorOverUnit( tileX, tileY );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 8, "HeavyTankDestroyed", "HeavyTankDestroyed" );
end

function HeavyTankDestroyed()
	ScriptManager:removeTrigger( "HeavyTankDestroyed" );
	ScriptManager:removeTrigger( "KatyushaDestroyed" );
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:hideMarkerAt( 8, 6 );
	ScriptManager:hideMarkerAt( 8, 4 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
	end
	
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_17,"" );
	ScriptManager:sleep( 2.5, "HeavyTankDestroyedTakeTank3" );
end

function HeavyTankDestroyedTakeTank3()
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_18,"" );
	ScriptManager:moveCamera( 4, 4, 0.8, 0.5, "HeavyTankDestroyedSelectTank3" );
end

function HeavyTankDestroyedSelectTank3()
	ScriptManager:showMarkerAt( 2, 3 )
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 2, 3, "cursorOverUnitSinglePress", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 2, 3, 1 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:disableAllTilesExcept( 2,3 );
	local unitTank2 = ScriptManager:getValue( "unitTank2" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, unitTank2, "HeavyTankDestroyedTank3Selected", "HeavyTankDestroyedTank3Selected" );
end

function HeavyTankDestroyedTank3Selected()
	ScriptManager:dismissSubtitle();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 6, 4, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:moveFingerToTile( 6, 4 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:hideMarkerAt( 2, 3 );
	ScriptManager:showMarkerAt( 6, 4 );
	ScriptManager:disableAllTilesExcept( 6, 4 );
	ScriptManager:addOnTileDeselectedTrigger( 6, 4, 0, "MoveToPlain" );
	local unitTank2 = ScriptManager:getValue( "unitTank2" );
	ScriptManager:addOnEnterTileTrigger( 6, 4, 0, -1, unitTank2, true, "HeavyTankDestroyedTank3InPosition", "HeavyTankDestroyedTank3InPosition" );
end

function HeavyTankDestroyedTank3InPosition()
	ScriptManager:hideMarkerAt( 6, 4 );
	ScriptManager:showMarkerAt( 8, 4 );
	ScriptManager:disableAllTilesExcept( 8, 4 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 8, 4, "cursorOverUnit", "cursorOverUnit", false );
	end
	
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_20,"" );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 3, "FinalTargetDestroyed" );
end

function CursorOnKatyusha( tileX, tileY )
	cursorOverUnit( tileX, tileY );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 3, "KatyushaDestroyed", "KatyushaDestroyed" );
end

function KatyushaDestroyed()
	ScriptManager:removeTrigger( "HeavyTankDestroyed" );
	ScriptManager:removeTrigger( "KatyushaDestroyed" );
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:hideMarkerAt( 8, 6 );
	ScriptManager:hideMarkerAt( 8, 4 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_17,"" )
	ScriptManager:sleep( 1.5,"KatyushaDestroyedTakeTank3" );
end

function KatyushaDestroyedTakeTank3()
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_18,"" );
	ScriptManager:moveCamera( 4, 4, 0.8, 0.5, "KatyushaDestroyedSelectTank3" );
end

function KatyushaDestroyedSelectTank3()
	ScriptManager:showMarkerAt( 2, 3 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 2, 3, "cursorOverUnitSinglePress", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 2, 3, 1 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:disableAllTilesExcept( 2, 3 );
	local unitTank2 = ScriptManager:getValue( "unitTank2" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, unitTank2, "KatyushaDestroyedTank3Selected", "KatyushaDestroyedTank3Selected" );
end

function KatyushaDestroyedTank3Selected()
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_30,"" );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 6, 4, "cursorOverUnit", "cursorOverUnit", false );
	
	else
		ScriptManager:moveFingerToTile( 6, 4 );
		ScriptManager:loopFingerClicks( 1.5 );
	end
	
	ScriptManager:hideMarkerAt( 2, 3 );
	ScriptManager:showMarkerAt( 6, 4 );
	ScriptManager:disableAllTilesExcept( 6, 4 );
	ScriptManager:addOnTileDeselectedTrigger( 6, 4, 0, "MoveToPlain" );
	local unitTank2 = ScriptManager:getValue( "unitTank2" );
	ScriptManager:addOnEnterTileTrigger( 6, 4, 0, -1, unitTank2, true, "KatyushaDestroyedTank3InPosition", "KatyushaDestroyedTank3InPosition" );
end

function MoveToPlain()
	ScriptManager:dismissSubtitle();
	ScriptManager:moveCamera( 6, 4, 0.8, 0.5, "" );
	ScriptManager:hideFinger();
end

function KatyushaDestroyedTank3InPosition()
	ScriptManager:hideMarkerAt( 6, 4 );
	ScriptManager:showMarkerAt( 8, 6 );
	ScriptManager:dismissSubtitle();
	ScriptManager:disableAllTilesExcept( 8, 6 );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 8, 6, "cursorOverUnit", "cursorOverUnit", false );
	end
	
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_19,"" );
	ScriptManager:addOnUnitDestroyedTrigger( 1, -1, 8, "FinalTargetDestroyed" );
end

function FinalTargetDestroyed()
	checkControllerAndHideButton();
	
	ScriptManager:dismissSubtitle();
	ScriptManager:removeAllMarkers();
	ScriptManager:sleep( 3, "TurnEnd" );
	ScriptManager:disableAllTilesExcept( 0, 0 );
end 

function TurnEnd()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_21,"" );
	ScriptManager:moveCamera( 6, 5, 0.7, 1, "" );
	ScriptManager:enableEndTurnButton();
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:wait( 1 );
		showControllerButtonGfx( ControllerButton.FACE_UP, 1, 6, 5 );
	end
			
	ScriptManager:startHighlightingEndTurnButton();
end

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-------------------- Tutorial Part 2 ----------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

function DisableDialogue()
	ScriptManager:dismissSubtitle()
end

function EnemyReinforcements()
	ScriptManager:hideControllerButton();
	
	ScriptManager:dismissSubtitle()
	ScriptManager:sleep( 3,"EnemyReinforcementsDialogue" );
	local unit = ScriptManager:spawnUnit( 
		1, 17 , 	--PLAYER, UNIT
		9, 6 ,	--X, Y
		30, 5 ); --SQUADID, STATE
	ScriptManager:moveUnit( unit:getId(), 8, 6, "EnemyReinforcements_2" );
	ScriptManager:storeValue( "unitReinforcementTank1", unit:getId() );
end

function EnemyReinforcements_2()
	local unit = ScriptManager:spawnUnit( 
		1, 17 , 	--PLAYER, UNIT
		8, 3 ,	--X, Y
		30, 5 ); --SQUADID, STATE
	ScriptManager:moveUnit( unit:getId(), 7, 4, "EnemyReinforcements_3" );
	ScriptManager:storeValue( "unitReinforcementTank2", unit:getId() );
end

function EnemyReinforcements_3()
	local unit = ScriptManager:spawnUnit( 
		1, 17 , 	--PLAYER, UNIT
		9, 8 ,	--X, Y
		30, 5 ); --SQUADID, STATE
	ScriptManager:moveUnit( unit:getId(), 6, 7, "EnemyReinforcement1InPosition" );
	ScriptManager:storeValue( "unitReinforcementTank3", unit:getId() );
end

function EnemyReinforcementsDialogue()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_22, "" )
	ScriptManager:sleep( 8,"KillSubtitle" );
end

function EnemyReinforcement1InPosition()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank1" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"EnemyReinforcement2InPosition" );
end

function EnemyReinforcement2InPosition()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank2" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"EnemyReinforcement3InPosition" );
end

function EnemyReinforcement3InPosition()
	local unitTank2 = ScriptManager:getValue( "unitTank2" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank3" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTank2,	--DEFENDER
	"attackTurnEnd" );
end

function attackTurnEnd()
	ScriptManager:endTurn();
	ScriptManager:disableEndTurnButton();
end

function ReSupplyTiger()
	ScriptManager:dismissSubtitle();
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank1" );
	local enemyTank = Unit:getUnitById( reinforcement );
	enemyTank:setHealth( 200 );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank2" );
	local enemyTank = Unit:getUnitById( reinforcement );
	enemyTank:setHealth( 280 );
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_23, "" );
	ScriptManager:stopHighlightingEndTurnButton();
	ScriptManager:moveCamera( 5, 6, 1.1, 0.5, "" );
	ScriptManager:showMarkerAt( 5, 6 );
	
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorPosition( 7, 6 );
	end
	
	ScriptManager:sleep( 4, "ReSupplyTiger2" );
end

function ReSupplyTiger2()
	ScriptManager:disableAllTilesExcept( 5, 6 )
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
		ScriptManager:addOnControllerSelectedTileTrigger( 5, 6, "cursorOverUnitSinglePress", "cursorOverUnit", false );
	
	else
		ScriptManager:showFingerAtTile( 5, 6, 1 );
	end
	
	ScriptManager:dismissSubtitle()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, unitTiger, "TigerSelected2", "TigerSelected2" );
end

function TigerSelected2()
	ScriptManager:dismissSubtitle();
	ScriptManager:hideFinger();
	ScriptManager:hideMarkerAt( 5, 6 );
	ScriptManager:removeTrigger( "TigerSelected2" );
	
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:displaySubtitle( Text.T_TUTORIAL_CONTROLLER_PRESS_BUTTON );
		-- show it with other function cause otherwise next button display won't disappear
		ScriptManager:showControllerButtonAtTile( ControllerButton.FACE_LEFT, 5, 6, 0.2 );
		ScriptManager:addOnControllerButtonReleasedTrigger( ControllerButton.FACE_LEFT, "TigerSelected2Controller", "TigerSelected2Controller" );
	
	else
		ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_24,"" );
	end
	
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	ScriptManager:enableInteractionButton( InteractionButton.INSTANT_SUPPLY_SINGLE );
	ScriptManager:startHighlightingInteractionButton( InteractionButton.INSTANT_SUPPLY_SINGLE );
	
	ScriptManager:addOnInteractionButtonDeselectedTrigger( -1, -1, unitTiger, InteractionButton.INSTANT_SUPPLY_SINGLE, "ReSupplyPressed", "ReSupplyPressed" );
	ScriptManager:addOnInteractionButtonDeselectedTrigger( -1, -1, unitTiger, InteractionButton.INSTANT_SUPPLY_FULL, "ReSupplyPressed", "ReSupplyPressed" );
	ScriptManager:addOnInteractionButtonDeselectedTrigger( -1, -1, unitTiger, InteractionButton.INSTANT_SUPPLY_SINGLE, "ShowResupplyTigerTillFull", "ShowResupplyTigerTillFull" );
	ScriptManager:disableAllTilesExcept( 0,0 );
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank1" ) ):setIsAttackable( false );
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank2" ) ):setIsAttackable( false );
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank3" ) ):setIsAttackable( false );
end

function TigerSelected2Controller()
	RemoveTrigger( "TigerSelected2Controller" );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitle( Text.T_MISSION_TUTORIAL_1_24 );	
	ScriptManager:hideControllerButton();
	ScriptManager:showControllerButtonAtTile( ControllerButton.FACE_DOWN, 5, 6, 0.2 );
end

function ReSupplyPressed()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local tiger = Unit:getUnitById( unitTiger );
	if tiger:getHealth() >= 800 then
		ScriptManager:removeTrigger( "ReSupplyPressed" );
		ScriptManager:dismissSubtitle();
		ScriptManager:sleep( 1.5,"ContinueFull" );
		ScriptManager:disableAllInteractionButtons();
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:setControllerCursorEnabled( false ); -- TODO
			ScriptManager:hideControllerButton();
		end
	end
end


function ContinueFull()
	ScriptManager:displaySubtitle( Text.T_TUTORIAL_COMPLETE_SUPPLY,"" );
	ScriptManager:sleep( 2, "ContinueResupply" );
end

function ContinueResupply()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local tiger = Unit:getUnitById( unitTiger );
	ScriptManager:addOnInteractionButtonDeselectedTrigger( -1, -1, unitTiger, InteractionButton.INSTANT_SUPPLY_SINGLE, "ContinueResupply", "ContinueResupply" );
	ScriptManager:addOnInteractionButtonDeselectedTrigger( -1, -1, unitTiger, InteractionButton.INSTANT_SUPPLY_FULL, "ContinueResupply", "ContinueResupply" );
	ScriptManager:enableInteractionButton( InteractionButton.INSTANT_SUPPLY_SINGLE );
	ScriptManager:enableInteractionButton( InteractionButton.INSTANT_SUPPLY_FULL );
	ScriptManager:startHighlightingInteractionButton( InteractionButton.INSTANT_SUPPLY_FULL );
	ScriptManager:stopHighlightingInteractionButton( InteractionButton.INSTANT_SUPPLY_SINGLE );
	
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( false ); -- TODO
		HideDialogue();
		ScriptManager:displaySubtitle( Text.T_TUTORIAL_CONTROLLER_PRESS_BUTTON );
		-- show it with other function cause otherwise next button display won't disappear
		ScriptManager:showControllerButtonAtTile( ControllerButton.FACE_LEFT, 5, 6, 0.2 );
		ScriptManager:addOnControllerButtonReleasedTrigger( ControllerButton.FACE_LEFT, "ContinueResupplyController", "ContinueResupplyController" );
	end
	
	TillTigerFull()
end

function ContinueResupplyController()
	RemoveTrigger( "ContinueResupplyController" );
	ScriptManager:dismissSubtitle();
	ScriptManager:hideControllerButton();
	ScriptManager:showControllerButtonAtTile( ControllerButton.FACE_DOWN, 5, 6, 0.2 );
end

function TillTigerFull()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local tiger = Unit:getUnitById( unitTiger );
	if tiger:getHealth() == 1200 then
		TigerHpFull();
		
		ScriptManager:hideControllerButton();		
	end
end

function ShowResupplyTigerTillFull()	
	ScriptManager:removeTrigger( "ShowResupplyTigerTillFull" );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_25,"" );
end

function TigerHpFull()
	ScriptManager:removeAllTriggers();
	ScriptManager:enableAICalculation();
	ScriptManager:disableInteractionButton( InteractionButton.INSTANT_SUPPLY_SINGLE );
	ScriptManager:stopHighlightingInteractionButton( InteractionButton.INSTANT_SUPPLY_FULL );
	ScriptManager:disableInteractionButton( InteractionButton.INSTANT_SUPPLY_FULL );
	ScriptManager:disableAllTilesExcept( 0, 0 );
	ScriptManager:dismissSubtitle();
	ScriptManager:sleep( 1, "Dialoague26" );
	ScriptManager:sleep( 4.5, "HideDialogue" );
	ScriptManager:sleep( 5.5, "ShowDialogue27" );
end

function Dialoague26()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_26,"" );
end

function ShowDialogue27()
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
	end
	
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_27,"" );
	ScriptManager:addOnUnitSelectedTrigger( 0, -1, -1, "unitSelected", "unitSelected" );
	ScriptManager:addOnUnitHasAttackedTrigger( 0, -1, -1, "showMarkerAtUnits", "showMarkerAtUnits" );
	ScriptManager:moveCamera( 7, 6, 0.8,3, "unitSelected" );
	ScriptManager:sleep( 1.5, "reEnableTanks" );
end

function reEnableTanks()
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank1" ) ):setIsAttackable( true );
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank2" ) ):setIsAttackable( true );
	Unit:getUnitById( ScriptManager:getValue( "unitReinforcementTank3" ) ):setIsAttackable( true );
end

function showMarkerAtUnits()
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
	end
	
	ScriptManager:removeAllMarkers();
	ScriptManager:disableAllTilesExcept( 0, 0 );
	local tank1ID = ScriptManager:getValue( "unitTank1" );
	local tank2ID = ScriptManager:getValue( "unitTank2" );
	local tank3ID = ScriptManager:getValue( "unitTank3" );
	local tank4ID = ScriptManager:getValue( "unitTiger" );
	local tank1 = Unit:getUnitById( tank1ID );
	local tank2 = Unit:getUnitById( tank2ID );
	local tank3 = Unit:getUnitById( tank3ID );
	local tank4 = Unit:getUnitById( tank4ID );
	
	if tank1 ~= nil and tank1:hasAttacksLeft() then
		ScriptManager:showMarkerAt( tank1:getX(), tank1:getY() );
		ScriptManager:enableAdditionalTile( tank1:getX(), tank1:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank1:getX(), tank1:getY(), "cursorOverUnitSinglePress", "cursorOverUnit", false );
		end
	end
	if tank2 ~= nil and tank2:hasAttacksLeft() then
		ScriptManager:showMarkerAt( tank2:getX(), tank2:getY() );
		ScriptManager:enableAdditionalTile( tank2:getX(), tank2:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank2:getX(), tank2:getY(), "cursorOverUnitSinglePress", "cursorOverUnit", false );
		end
	end
	if tank3 ~= nil and tank3:hasAttacksLeft() then
		ScriptManager:showMarkerAt( tank3:getX(), tank3:getY() );
		ScriptManager:enableAdditionalTile( tank3:getX(), tank3:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank3:getX(), tank3:getY(), "cursorOverUnitSinglePress", "cursorOverUnit", false );
		end
	end
	if tank4 ~= nil and tank4:hasAttacksLeft() then
		ScriptManager:showMarkerAt( tank4:getX(), tank4:getY() );
		ScriptManager:enableAdditionalTile( tank4:getX(), tank4:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank4:getX(), tank4:getY(), "cursorOverUnitSinglePress", "cursorOverUnit", false );
		end
	end
	
	if ( tank1 == nil or tank1:hasAttacksLeft() == false ) and ( tank2 == nil or tank2:hasAttacksLeft() == false ) and ( tank3 == nil or tank3:hasAttacksLeft() == false ) and ( tank4 == nil or tank4:hasAttacksLeft() == false ) then
		endTurn();
		return
	end
	
	tank1ID = ScriptManager:getValue( "unitReinforcementTank1" );
	tank2ID = ScriptManager:getValue( "unitReinforcementTank2" );
	tank3ID = ScriptManager:getValue( "unitReinforcementTank3" );
	tank1 = Unit:getUnitById( tank1ID );
	tank2 = Unit:getUnitById( tank2ID );
	tank3 = Unit:getUnitById( tank3ID );
	
	if tank1 == nil and tank2 == nil and tank3 == nil then
		endTurn();
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:setControllerCursorEnabled( false );
		end
	end
end

function endTurn()
	ScriptManager:removeAllTriggers();
	ScriptManager:removeAllMarkers();
	ScriptManager:disableAllTilesExcept( 0,0 );
	ScriptManager:dismissSubtitle();
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_28,"" );
	ScriptManager:setMissionStatus( 1, MissionStatus.ACCOMPLISHED );
	ScriptManager:sleep( 2.5, "DisableDialogue" );
	ScriptManager:sleep( 3.5, "ShowDialogue29" );
end

function ShowDialogue29()
	ScriptManager:displaySubtitleAutoWithCallback( Text.T_MISSION_TUTORIAL_1_29,"" );
	ScriptManager:moveCamera( 7, 6, 0.7, 4, "" );
	ScriptManager:sleep( 5, "DisableDialogue" );
	ScriptManager:sleep( 6, "Victory" );
end

function unitSelected()
	cleanupController();
	if ScriptManager:isControllerConnected() then
		ScriptManager:setControllerCursorEnabled( true );
	end
	
	ScriptManager:dismissSubtitle();
	ScriptManager:removeAllMarkers();
	ScriptManager:disableAllTilesExcept( 0, 0 );
	local tank1ID = ScriptManager:getValue( "unitReinforcementTank1" );
	local tank2ID = ScriptManager:getValue( "unitReinforcementTank2" );
	local tank3ID = ScriptManager:getValue( "unitReinforcementTank3" );
	local tank1 = Unit:getUnitById( tank1ID );
	local tank2 = Unit:getUnitById( tank2ID );
	local tank3 = Unit:getUnitById( tank3ID );
	
	if tank1 ~= nil then
		ScriptManager:showMarkerAt( tank1:getX(), tank1:getY() );
		ScriptManager:enableAdditionalTile( tank1:getX(), tank1:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank1:getX(), tank1:getY(), "cursorOverUnit", "cursorOverUnit", false );
		end
	end
	if tank2 ~= nil then
		ScriptManager:showMarkerAt( tank2:getX(), tank2:getY() );
		ScriptManager:enableAdditionalTile( tank2:getX(), tank2:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank2:getX(), tank2:getY(), "cursorOverUnit", "cursorOverUnit", false );
		end
	end
	if tank3 ~= nil then
		ScriptManager:showMarkerAt( tank3:getX(), tank3:getY() );
		ScriptManager:enableAdditionalTile( tank3:getX(), tank3:getY() );
		
		if ScriptManager:isControllerConnected() then
			ScriptManager:addOnControllerSelectedTileTrigger( tank3:getX(), tank3:getY(), "cursorOverUnit", "cursorOverUnit", false );
		end
	end
end

function EnemyReinforcementsAttack()
	
end

function AttackTank1()
	ScriptManager:storeValue( "unitTank1", unit:getId() );
	local unitTiger = ScriptManager:getValue( "unitTank1" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank1" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"EnemyReinforcement2InPosition" );
end

function AttackTank2()
	local unitTiger = ScriptManager:getValue( "unitTank2" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank2" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"EnemyReinforcement3InPosition" );
end

function AttackTank3()
	local unitTiger = ScriptManager:getValue( "unitTank3" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank2" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"EnemyReinforcement3InPosition" );
end


function AttackTank4()
	local unitTiger = ScriptManager:getValue( "unitTiger" );
	local reinforcement = ScriptManager:getValue( "unitReinforcementTank3" );
	ScriptManager:attackUnit( 
	reinforcement,	--ATTACKER
	unitTiger,	--DEFENDER
	"attackTurnEnd" );
end

function Victory()
	ScriptManager:endGame();
end