require "lua/Functions_2"
require "lua/Constants"
require "lua/Text"
require "lua/Units"
require "math"

-- Scripts&Functions by PDO --
function IntitateUnitFunctions()
	ScriptManager:addOnUnitDestroyedTrigger(-1,-1,-1,"RemoveUnitId","RemoveUnitId",false)	--Remove unit id from table
	ScriptManager:addOnTurnStartTrigger(0,-1,-1,"LoadUnitsIntoTables")	--Load saved units into tables
	--Add Counters
	for i = 1, 15 do
		ScriptManager:storeValue(string.format("spawnCounter_%i",i),0)
	end
end


--	Groups for enemy wave spawner
enemyGroupsGroundEasySU_2_2 =
{
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_MP40},
} 
enemyGroupsTanfactory_2_3 =
{
		{Units.UNIT_DE_TIGER, Units.UNIT_DE_TIGER},
		{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4,}
} 

enemyGroupsGroundEasy = --Define Easy enemy group waves
{
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_PANZERFAUST},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_PANZERFAUST},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_PANZERFAUST},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_MP40}

}

enemyGroupsGroundMedium = --Define Medium enemy group waves
{
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_MP40, Units.UNIT_DE_MP40, Units.UNIT_DE_TANK_3, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3},
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_3},
}

enemyGroupsGroundHard = --Define Hard enemy group waves
{
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_PANZERFAUST, Units.UNIT_DE_MP40}, 
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4}, 
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4}, 
	{Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4, Units.UNIT_DE_TANK_4}, 
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_MP40},
	{Units.UNIT_DE_TIGER, Units.UNIT_DE_TIGER, Units.UNIT_DE_TANK_4, Units.UNIT_DE_MP40}
}

enemyGroupsPlanes = --Define Plane enemy waves
{
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_BOMBER},
	{Units.UNIT_DE_BOMBER},
	{Units.UNIT_DE_BOMBER},
	{Units.UNIT_DE_BOMBER, Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_BOMBER, Units.UNIT_DE_FIGHTER},
	{Units.UNIT_DE_BOMBER, Units.UNIT_DE_BOMBER}
}

--Standard Enemey Reinforcements Spawner
function SpawnEnemyReinforcements(spawnPosId,saveTable,saveTableString,unitTable,aiState)	--(Table(if more than 1 index = choose randomly) or UnitId, fraction, type)
	local spawnPosUnit = nil
	local unit = nil
	local unitIndex = nil
	local squadId = nil
	local index = 0
	if type(spawnPosId) == "table" then
		index = spawnPosId[math.random(1,#spawnPosId)]
		print(index[1])
		print(index[2])
		ScriptManager:storeValue("unitSpawnXPos",index[1])
		ScriptManager:storeValue("unitSpawnYPos",index[2])
	end
	if type(spawnPosId) == "number" then		
		if aiState == AiState.DEFEND then															--if Ai state defend = same squad id as spawnPos
			spawnPosUnit = Unit:getUnitById(spawnPosId)												--get squad id of spawnPos
			squadId = spawnPosUnit:getSquadId() 	
		else 
			squadId = 1337+ScriptManager:getCurrentRound()											--defaul squad id
		end
	elseif type(spawnPosId) == "table" then
		squadId = 1337+ScriptManager:getCurrentRound()			
	end
	unitIndex = unitTable[math.random(1,#unitTable)]
	for i = 1, #unitIndex do
			if type(spawnPosId) == "number" then			
				local unitSpawn = Unit:getUnitById(spawnPosId)
				if unitSpawn == nil then																							
				print("Can't Spawn units (SpawnPosId) = "..spawnPosId)	
				elseif unitSpawn ~= nil then
					unit = ScriptManager:spawnUnit(1,unitIndex[i],unitSpawn:getX(),unitSpawn:getY(),squadId,aiState)	-- get unit from unit id and spawn unit at this location				
				end
			elseif type(spawnPosId) == "table" then
				unit = ScriptManager:spawnUnit(1,unitIndex[i],index[1],index[2],squadId,aiState)
			end
		if unit ~= nil then
			table.insert(saveTable,#saveTable+1,unit:getId()) --insert unit into table
		elseif unit == nil then
			print("Cant't store unit into table (nil)")
		end
	end
	SaveUnitId(saveTable,saveTableString)
end

--Global Tables to store unit Id's
saveUnit_1 = {}
saveUnit_2 = {}
saveUnit_3 = {}
saveUnit_4 = {}
saveUnit_5 = {}
saveUnit_6 = {}
saveUnit_7 = {}
saveUnit_8 = {}
saveUnit_9 = {}
saveUnit_10 = {}
saveUnit_11 = {}
saveUnit_12 = {}
saveUnit_13 = {}
saveUnit_14 = {}
saveUnit_15 = {}
saveUnit_16 = {}
saveUnit_17 = {}
saveUnit_18 = {}
saveUnit_19 = {}

--save values from #table
function SaveUnitId(unitTableId, unitTableName) 													--(example : SaveUnitId(saveThisTable,"saveThisTable"))
	for i = 1, #unitTableId do																		--search for unit ids depeding on the length of the table																--get unit ids from the the table 
		ScriptManager:storeValue(string.format("unitId_%s_%i",unitTableName,i),unitTableId[i])		--store unitId from table			
		--print(string.format("Save Values = unitId_%s_%i",unitTableName,i))							--TODO:Remove Prints later									--TODO:Remove Prints later
	end
end

--set values of #table = -1
function ResetUnitId(table,tablename)
	for i = 1, #table do																			--find stored ids of table
		ScriptManager:storeValue(string.format("unitId_%s_%i",tablename,i),-1)						--overwrites value with -1
		--print(string.format("Reset Values (-1) = unitId_%s_%i",tablename,i))						--TODO:remove prints for release
	end
end

--load stored values into table (on turn start)
function LoadUnitId(unitTableId,unitTableName) --table
	local unitIndex = 1
	local unitId = -1
	if #unitTableId < 1 then -- check if there are any units if not trys to load saved units into the table
		repeat																						--load unit ids into table
			unitId = ScriptManager:getValue(string.format("unitId_%s_%i",unitTableName,unitIndex))	--Get value of stored unit
			if unitId ~= -1 then																		--if unitID exists
				table.insert(unitTableId,#unitTableId+1,unitId)										--insert UnitID into Table
				print(string.format("Load unitId_%s_%i into table",unitTableName,unitIndex))		--TODO:remove prints later
				print(unitId)
				unitIndex = unitIndex+1
			end
		until unitId == -1		
	end																								--repeat until all saved units are loaded
end


--ADD on turn start trigger to onGameStart function-- load v2

--loads unit ids into tables (on turn start)
function LoadUnitsIntoTables()						
	for i = 1, 19 do 
		LoadUnitId(_G[string.format("saveUnit_%i",i)],string.format("saveUnit_%i",i))
	end
end

--remove unitId v2
function RemoveUnitId(unit)
local unitId = unit:getId()
local unitTable = 0
tableIndex = 1		
																--start index
repeat 
	unitTable = _G[string.format("saveUnit_%i",tableIndex)]							--Get table from string
	
	for i = 1, #unitTable do														--scan table for unit Id
		if unitId == unitTable[i] then												--if unitId in this table then
			ResetUnitId(unitTable, string.format("saveUnit_%i",tableIndex))			--reset stored values (-1)
			table.remove(unitTable,i)												--remove unitId from the table
			--print(string.format("Remove ID:%i of saveUnit_1",unitId)) 				--TODO:remove print for release
			return SaveUnitId(unitTable, string.format("saveUnit_%i",tableIndex)) 	--save new table
		end
	end
	
	tableIndex = tableIndex + 1														--Increase search index and repeat

until tableIndex == 19																--until : amount of save tables (saveUnit_x)
end

--Spawnfunction v2
function ResetSpawnFunctions(spawnerTable)
local isActive = 0
local index = 0
local spawnTimer = 0
local spawnCounterIndex = 0
local saveTable = 0

	for i = 1, #spawnerTable do													--gets amount of spawners from spawnparameter table
		index = spawnerTable[i]
		print("ResetSpawnfunctions..."..i)
		isActive = ScriptManager:getValue(string.format("spawnerActive_%i",i))
		spawnTimer = math.random(index[2],index[3])
		spawnCounterIndex = ScriptManager:getValue(string.format("spawnCounterIndex_%i",i))
		
		if  spawnCounterIndex == -1 then
			spawnCounterIndex = ScriptManager:storeValue(string.format("spawnCounterIndex_%i",i),0)
		end
		
		saveTable = _G[string.format("saveUnit_%i",i)]
		print(saveTable,"units still left "..#saveTable)
		print(saveTable,"is Active: "..isActive)
		
		if #saveTable == 0 and index[4] > spawnCounterIndex and isActive == 1 then
			ScriptManager:addOnTurnStartTrigger(1,-1,ScriptManager:getCurrentRound()+spawnTimer,string.format("SpawnFunction_%i",i),string.format("SpawnFunction_%i",i),false)
			print(string.format("RespawnEnemies_%i in %i rounds",i,spawnTimer))	
			ScriptManager:storeValue(string.format("spawnerActive_%i",i),-1)
			spawnCounterIndex = ScriptManager:storeValue(string.format("spawnCounterIndex_%i",i),spawnCounterIndex+1)
		end
		
	end
end

--Spawn function
function SpawnerFunction(isActiveValue, spawnCounterString, posId, saveUnitTable, saveUnitTableString, unitTable , AiState)
	local spawnCounter = ScriptManager:getValue(spawnCounterString)  	--amount procceded of spawns
	local isActive = ScriptManager:getValue(isActiveValue)				--is actiaved 1st time stores interger for checking (starts respawn function)
	local unit = Unit:getUnitById(posId)
	
	if isActive ~= 1 then
		ScriptManager:storeValue(isActiveValue,1)
	end
	
	if unit ~= nil and unit:getPlayerId() == 1 then
		SpawnEnemyReinforcements(posId,saveUnitTable,saveUnitTableString, unitTable ,AiState) 	--"lua/UnitFunctions"
		ScriptManager:storeValue(spawnCounterString,spawnCounter+1)													--Increse spawn count index by 1 an stores new index
	end
end

--Function to choose the waypoint randomly and go trough all waypoints, then resetes
function PatrolFunctionChooseWaypoint(unitId,wayPoints)
	local unitId = ScriptManager:getValue("superTiger")
	local waypointStoreIndex = 0
	local wayPointIndex = 0	--define local variables
	local wayPoint = 0
	local wayPointsUsed = 0
	local squadId = 99
	--checks how many storages are used
	for i = 1, #tigerPatrolWaypoints do	
		if ScriptManager:getValue(string.format("waypoint_%i_%i",squadId,i)) ~= 0 then
			wayPointsUsed = wayPointsUsed + 1 --increase used index by 1 of theres a stored value ~= 0
		end
	end
	print("waypointsUsed:"..wayPointsUsed)											--TODO:remove prints for release
	--if #tigerPatrolWaypoints are used = resets the storages (0)
	if wayPointsUsed == #tigerPatrolWaypoints then			
		for i = 1, #tigerPatrolWaypoints-1 do
			ScriptManager:storeValue(string.format("waypoint_%i_%i",squadId,i),0)
			print("RESETTING WAYPOINTS")
		end
	end
	--repeats until if finds an index storage which is empty
	repeat	
		wayPointIndex = math.random(1,#tigerPatrolWaypoints)						--randomly chooses a index from #tigerPatrolWaypoints
		waypointStoreIndex = ScriptManager:getValue(string.format("waypoint_%i_%i",squadId,wayPointIndex)) -- get index from storage
	until waypointStoreIndex == 0 -- if finds an empty storage us this index
	wayPoint = tigerPatrolWaypoints[wayPointIndex]
	ScriptManager:addOnMovedToTileTrigger(wayPoint[1],wayPoint[2],1,squadId,2,true,"_PatrolChooseNewWayPoint","_PatrolChooseNewWayPoint",false) -- creat new trigger for the target location
	ScriptManager:setTargetTile(1,squadId,wayPoint[1],wayPoint[2])																				-- set new move order
	print("New waypoint = "..wayPoint[1],wayPoint[2])											--TODO:remove prints for release
	--Store new value
	ScriptManager:storeValue(string.format("waypoint_%i_%i",squadId,wayPointIndex),wayPointIndex) --stores unused index
end
