require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

-- Mission Practice 3


-- Game Start

function onGameStart()
  ScriptManager:sleep(0,"intro")
  
 end
 
 -- Plays the intro-cutscene
 
 function intro()
  ScriptManager:startCutscene()
  ScriptManager:displaySubtitle("tmp: Welcome to the front soldier. Your mission is to secure the ongoing operations in this area") 
  ScriptManager:wait(6)
  ScriptManager:dismissSubtitle()
  ScriptManager:stopCutscene()
  spawnUnit()
  
  end
  
  -- Spawns Unit for Player 1
  
  function spawnUnit()
    ScriptManager:spawnUnit(0,Units.UNIT_DE_TANK_4,1,10,1,AiState.ATTACK)
    ScriptManager:spawnUnits(0,Units.UNIT_DE_MP40,1,9,2,AiState.ATTACK,2)
    createMission()
   
   end
   
   function createMission()
    ScriptManager:createMission(1,true,"tmp: Occupy the deserted Bunker in the South-West.")
    ScriptManager:wait(4)
    ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
    ScriptManager:addOnUnitOccupiedTrigger(-1,25,Units.UNIT_SU_BUNKER,"BunkerCaptured","BunkerCaptured",false)
    
   end
   
   
   function BunkerCaptured()
      ScriptManager:startCutscene()
      ScriptManager:displaySubtitle("tmp: Good Job! In order to advance further, we have to interrupt the enemy supply line. Destroy the Soviet Supply Truck!")
      ScriptManager:wait(4)
      ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
      ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_SUPPLY_TRUCK,3,"SupplyTruckDestroyed","SupplyTruckDestroyed",false)
      ScriptManager:dismissSubtitle()
      ScriptManager:stopCutscene()
      createMission()
   
   end
   
   function SupplyTruckDestroyed()
   ScriptManager:createMission(3,true,"tmp: Advance north and engage the enemy infantry.")
   ScriptManager:wait(4)
   ScriptManager:setMissionStatus(3,MissionStatus.IN_PROGRESS)
   ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_RIFLE,4,"RifleDestroyed","RifleDestroyed",false)
   ScriptManager:dismissSubtitle()
   ScriptManager:stopCutscene()
   createMission()
   
   end
   
   function RifleDestroyed ()
   ScriptManager:createMission(4,true,"tmp: Capture the Soviet Headquarters.")
   ScriptManager:wait(4)
   ScriptManager:setMissionStatus(4,MissionStatus.IN_PROGRESS)
   ScriptManager:addOnUnitOccupiedTrigger(1,Units.UNIT_SU_HQ,5,"HQcaptured","HQcaptured",false)
   ScriptManager:dismissSubtitle()
   ScriptManager:stopCutscene()
   ScriptManager:setMissionStatus(4,MissionStatus.ACCOMPLISHED)
   ScriptManager:wait(2)
   ScriptManager:endGame()
   
   end   
   
   
   








--Mission Practice 2
--[[ function onGameStart()
  ScriptManager:sleep( 0, "intro" );
 end
 
 function intro()
  ScriptManager:startCutscene()
  ScriptManager:displaySubtitle("tmp: Welcome Soldier, good to have you here! Now we can show the enemy what we are made of!")
  ScriptManager:wait(3)
  ScriptManager:dismissSubtitle()
  ScriptManager:stopCutscene()
  spawnUnit()

end


function spawnUnit()
  ScriptManager:spawnUnit(0,Units.UNIT_DE_TIGER,3,16,1,AiState.ATTACK)
  createMission()

end


function createMission()  
  ScriptManager:createMission(1,true,"tmp: Destroy the enemy infantry which is located west!")
  ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
  ScriptManager:spawnUnit(1,Units.UNIT_SU_RIFLE,6,14,1,AiState.PASSIVE)
  ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_RIFLE,-1,"RifleDestroyed","RifleDestroyed",false)
  
end

function RifleDestroyed()
  ScriptManager:disableEndTurnButton();
  ScriptManager:blockUI( true );
  ScriptManager:wait(1)
  ScriptManager:blockUI(false);
  ScriptManager:enableEndTurnButton();
  
  ScriptManager:startCutscene()
  ScriptManager:displaySubtitle("tmp: Well done, soldier! That'll teach them!")
  ScriptManager:wait(3)
  ScriptManager:dismissSubtitle()
  ScriptManager:stopCutscene()
  
  ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
  ScriptManager:wait(2)
  ScriptManager:endGame()
  
  end
  
  ]]
  

-- Mission Practice 1
--[[function onGameStart()
	ScriptManager:createMission(1,true,"tmp: killInfantry")
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	
	ScriptManager:spawnUnit(1,Units.UNIT_SU_MORTAR,2,15,1,AiState.PASSIVE)
	
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_MORTAR,-1,"MortarDestroyed","MortarDestroyed",false)
	
end

function MortarDestroyed()
	ScriptManager:disableEndTurnButton();
	ScriptManager:blockUI( true );
	ScriptManager:wait(1)
	ScriptManager:blockUI( ( false );
	ScriptManager:enableEndTurnButton();
	ScriptManager:startCutscene()
	local unit = ScriptManager:spawnUnit(1,Units.UNIT_SU_RIFLE,2,11,2,AiState.ATTACK)
	local unitId = unit:getId();
	ScriptManager:moveUnitEx(unitId,1,15,true)
	ScriptManager:attackUnitEx(unitId,0,true)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_RIFLE,-1,"RifleDestroyed","RifleDestroyed",false)
	ScriptManager:stopCutscene()

end

function RifleDestroyed()
	DisablePlayerInteraction();
	
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait( 2 );
	EnablePlayerInteraction();
	ScriptManager:endGame();

end
]]
