require "lua/Constants"
require "lua/Functions"
require "lua/Functions_2"
require "lua/Text"
require "lua/Units"
require "math"

-- Scripting Practice for testmap

-- Generelle Kommentare:
-- unitTemplateId --> Welcher Typ Einheit
-- unitInstanceId --> Welche Einheit genau? - Werden von 0 auf hoch gezählt.


-- Missions:
-- 
-- 1 = Mission_primary : Destroy Truck
-- 2 = Mission_Secondary : Destroy AntiAir

Missions = {

	Mission_One = 1,
	Mission_Two = 2,

}



function onGameStart()
	ScriptManager:sleep(0,"intro")

	ScriptManager:gainGold(0,3000)

end



function intro()
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle("Welcome")
	ScriptManager:wait(2)
	ScriptManager:dismissSubtitle()
	ScriptManager:moveCameraEx(9,2,1,2,true)
	ScriptManager:revealFogOfWar(9,2,1,true)
	ScriptManager:showMarkerAt(9,2)
	ScriptManager:wait(2)
	ScriptManager:revealFogOfWar(9,2,1,false)
	ScriptManager:removeAllMarkers()
	ScriptManager:moveCameraEx(8,5,1,2,true)
	ScriptManager:revealFogOfWar(8,5,1,true)
	ScriptManager:showMarkerAt(8,5)
	ScriptManager:wait(2)
	ScriptManager:removeAllMarkers()
	ScriptManager:revealFogOfWar(8,5,1,false) --wenn auf true gesetzt bleibt der FoW aufgedeckt
	ScriptManager:moveCameraEx(2,2,1,2,true)
	ScriptManager:stopCutscene()
	createMission1()	
	
end


function createMission1()-- Bei mehreren missions auf die Nummerierung achten: createMission1 --> function Create Mission1(); create Mission2 --> function create Mission2() etc.
	ScriptManager:createMission(Missions.Mission_One,true,"Destroy the Truck")
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(2)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_TRANSPORT_TRUCK,-1,"TruckDestroyed","TruckDestroyed",false)
																							
end

function TruckDestroyed()
	--ScriptManager:startCutscene()
	ScriptManager:displaySubtitle("Well done!")-- damit nur der Subtitle eingeblendet wird, braucht es keine cutscene.
	ScriptManager:wait(1)
	
	ScriptManager:dismissSubtitle()
	--ScriptManager:stopCutscene()
	ScriptManager:wait(1)
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(1)
	createMission2()
	
end
	
function createMission2()
	ScriptManager:createMission(Missions.Mission_Two,true,"Destroy the AntiAir")
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(2)
	ScriptManager:addOnUnitDestroyedTrigger(1,Units.UNIT_SU_AA,-1,"AntiAirDestroyed","AntiAirDestroyed",false)
		
end

function AntiAirDestroyed()
	DisablePlayerInteraction()
	--ScriptManager:startCutscene()
	ScriptManager:displaySubtitle("Good Job!")
	ScriptManager:wait(1)
	ScriptManager:dismissSubtitle()
	--ScriptManager:stopCutscene()
	ScriptManager:setMissionStatus(2,MissionStatus.ACCOMPLISHED)
	ScriptManager:wait(1)
	
	ScriptManager:endGame()

end





--[[
-- More Scripting Practice for testmap

function onGameStart()
	ScriptManager:sleep(0,"intro")
	
end

function intro()
	ScriptManager:startCutscene()
	ScriptManager:displaySubtitle("Welcome to Bootcamp Soldier!")
	ScriptManager:wait(2)
	ScriptManager:dismissSubtitle()
	ScriptManager:moveCameraEx(8,4,1,2,true)
	ScriptManager:revealFogOfWar(8,4,1,true );
	ScriptManager:showMarkerAt(8,4);
	ScriptManager:wait(2)
	ScriptManager:removeAllMarkers()
	ScriptManager:revealFogOfWar(8,4,1,false );
	ScriptManager:moveCameraEx(2,2,1,2,true)
	ScriptManager:stopCutscene()
	createMission()

end
		
function createMission()
	ScriptManager:createMission(1,true,"Capture the Soviet HQ")
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	ScriptManager:wait(2)
	ScriptManager:addOnUnitCapturedTrigger(0,Units.UNIT_SU_HQ,-1,"HQcaptured","HQcaptured",false)	
	
end

function HQcaptured()
	ScriptManager:setMissionStatus( 1, MissionStatus.ACCOMPLISHED )
	ScriptManager:wait( 2 )
	ScriptManager:endGame()
	
end

]]